c  input files:
c    unit = 5 : inp 
c   unit = 6 : standard output
c   unit = 3 : fort.3 : source in time domain
c   unit =4 fort.4 : amplitude spaectrum source in freq. domain
c

c       open(unit=85,  file='kf_g.dat',    status='old')
c       open(unit=86,  file='rof_g.dat',   status='old')       
c       open(unit=87,  file='muf_g.dat',   status='old')
c       open(unit=88,  file='xks_g.dat',   status='old')
c       open(unit=89,  file='ros_g.dat',   status='old')       
c       open(unit=90,  file='fi_g.dat',    status='old')
c       open(unit=91,  file='kperm_g.dat', status='old')
c       open(unit=92,  file='qsm_g.dat',   status='old')       
c       open(unit=93,  file='qkc_g.dat',   status='old')       
c       open(unit=94,  file='qm_g.dat',    status='old')
c       open(unit=95,  file='xkm_g.dat',   status='old')
c       open(unit=96,  file='xnw_g.dat',   status='old')
c       open(unit=97,  file='struc_g.dat', status='old') 


c   Output files:
c
c   avu2yt.biot = unit 10 : snapshots of vs_z in 
c   avunty.biot = unit 11 : snapshots of vn_z in 
c   curlst.biot = unit 12 : snap of curl vs
c   divust.biot = unit 14 : snap of div vs
c   divust.biot = unit 15 : snap of div vn
c    avu2yf.biot = unit = 20 snap of u2y in freq. domain 
c    avunyf.biot = unit = 21 snap of uny in freq. domain 

c   fort.50+k-1, k=1,nrec  (nrec.le.7) : traces of v2y (v = iwu)
c   fort.57+k-1, k=1,nrec  (nrec.le.7) : traces of vny
c   fort.64+k-1, k=1,nrec  (nrec.le.7) : traces of div vs
c   fort.71+k-1, k=1,nrec  (nrec.le.7) : traces of  div vn
c   fort.78+k-1, k=1,nrec  (nrec.le.7) : traces of  curl vs

      implicit double precision (a-h,o-z)
csp2------------------------------------------------------------

       include 'mpif.h'
csp2------------------------------------------------------------

       include 'sizes'
csp2------------------------------------------------------------
	integer status(MPI_STATUS_SIZE)
csp2 -----------------------------------------------------------
      integer prfirst,prsecond,prtherd
      
      
      complex*16 fu1(mlsour,mnrec),fu2(mlsour,mnrec),cc(12,12)
      complex*16 cc_lu(12,12,mnx,mny),hh

      complex*16 funz(mlsour,mnrec)
      complex*16 fdivus(mlsour,mnrec),fdivun(mlsour,mnrec)
      complex*16 fcurl_us(mlsour,mnrec),fcurl_un(mlsour,mnrec)
      real*8 tpic2(mnx,mny,mtsnap),tpic_curls(mnx,mny,mtsnap)
      real*8 tpic_divus(mnx,mny,mtsnap),tpic_divun(mnx,mny,mtsnap)
      real*8 tpicny(mnx,mny,mtsnap)      
      real*8  rx(mnrec),ry(mnrec)
      integer irecid(mnrec)
      integer itsnap(mtsnap),iwsnap(mwsnap),irx(mnrec),iry(mnrec)
      real*8  tsnap(mtsnap),wsnap(mwsnap)
      real*8  suml(2),swork(2)
      complex*16 fsour(mlsour),avsol1,avsol2
      real*8  deltal(mnx),deltar(mnx),deltat(mny),deltab(mny)
      
      integer blockid,vblockid,blockty,ncontrol,nsx,nsy
      common/a1/ncontrol,blockid,vblockid(2),blockty,nsx,nsy

      real*8  rhob_m(0:mnx+1,0:mny+1)
      complex*16  xlamcw_m(0:mnx+1,0:mny+1)
      complex*16  xnw_m(0:mnx+1,0:mny+1)
      complex*16  bw_m(0:mnx+1,0:mny+1)
      complex*16  xmw_m(0:mnx+1,0:mny+1)
      real*8  b_m(0:mnx+1,0:mny+1)
      real*8  g_m(0:mnx+1,0:mny+1)
      real*8  shear_mod_el(0:mnx+1,0:mny+1)

      real*8 kf1(10),kf2(10),rof1(10),rof2(10),muf1(10),muf2(10)
      real*8 xks1(10),xks2(10),ros1(10),ros2(10),phi1(10),phi2(10)
      real*8 perm1(10),perm2(10),qsm1(10),qsm2(10),qkc1(10),qkc2(10)
      real*8 qm1(10),qm2(10)
      integer esp1(10),esp2(10)
      real*8 xkm1(10),xkm2(10),xnw1(10),xnw2(10)
      integer nc1,nc2,np1,np2,vector(mngy+1)


c   vectors for the absorbing b.c.
c
c  iteration  matrix coefficients  beta
c
      real*8 betal(3,3,mnx,mny),betar(3,3,mnx,mny)
      real*8 betab(3,3,mnx,mny),betat(3,3,mnx,mny)
      real*8 b(3,3)
c
c    solutions ubl , utl , ubr and utr for both solid and fluid 
c    components     at iteration  levels   n 
c     and   n+1

      complex*16 u1ln(0:mnx+1,0:mny+1),u1tn(0:mnx+1,0:mny+1),
     1           u1bn(0:mnx+1,0:mny+1)
      complex*16 u1rn(0:mnx+1,0:mny+1)
      complex*16 u2ln(0:mnx+1,0:mny+1),u2tn(0:mnx+1,0:mny+1),
     1           u2bn(0:mnx+1,0:mny+1)
      complex*16 u2rn(0:mnx+1,0:mny+1)

      complex*16 unln(0:mnx+1,0:mny+1),untn(0:mnx+1,0:mny+1),
     1           unbn(0:mnx+1,0:mny+1)
      complex*16 unrn(0:mnx+1,0:mny+1)
      


      complex*16 u1lnp1(0:mnx+1,0:mny+1),u1tnp1(0:mnx+1,0:mny+1),
     1           u1bnp1(0:mnx+1,0:mny+1)
      complex*16 u1rnp1(0:mnx+1,0:mny+1)
      complex*16 u2lnp1(0:mnx+1,0:mny+1),u2tnp1(0:mnx+1,0:mny+1),
     1           u2bnp1(0:mnx+1,0:mny+1)
      complex*16 u2rnp1(0:mnx+1,0:mny+1)

      complex*16 unlnp1(0:mnx+1,0:mny+1),untnp1(0:mnx+1,0:mny+1),
     1           unbnp1(0:mnx+1,0:mny+1)
      complex*16 unrnp1(0:mnx+1,0:mny+1)

c
c   lagrange  multipliers  parameters  lag1l, lag1b , lag1r, lag1t 
c                                      lag2l, lag2b , lag2r, lag2t
c                                      lagnl, lagnb , lagnr, lagnt 

c    levels   n   and   n+1
      complex*16 lag1ln(0:mnx+1,0:mny+1),lag1tn(0:mnx+1,0:mny+1),
     1           lag1bn(0:mnx+1,0:mny+1),lag1rn(0:mnx+1,0:mny+1)

      complex*16 lag2ln(0:mnx+1,0:mny+1),lag2tn(0:mnx+1,0:mny+1),
     1           lag2bn(0:mnx+1,0:mny+1),lag2rn(0:mnx+1,0:mny+1)

      complex*16 lagnln(0:mnx+1,0:mny+1),lagntn(0:mnx+1,0:mny+1),
     1           lagnbn(0:mnx+1,0:mny+1),lagnrn(0:mnx+1,0:mny+1)
     

      complex*16 lag1lnp1(0:mnx+1,0:mny+1),lag1tnp1(0:mnx+1,0:mny+1),
     1           lag1bnp1(0:mnx+1,0:mny+1),lag1rnp1(0:mnx+1,0:mny+1)

      complex*16 lag2lnp1(0:mnx+1,0:mny+1),lag2tnp1(0:mnx+1,0:mny+1),
     1           lag2bnp1(0:mnx+1,0:mny+1),lag2rnp1(0:mnx+1,0:mny+1)

      complex*16 lagnlnp1(0:mnx+1,0:mny+1),lagntnp1(0:mnx+1,0:mny+1),
     1           lagnbnp1(0:mnx+1,0:mny+1),lagnrnp1(0:mnx+1,0:mny+1)


     
      complex*16 sendvec(0:8*(mnmax+2)),recvec(0:8*(mnmax+2))
c
c  Global matrix matnum 
c 
c  matnum : integer matrix containing  the material type number at
c            each grid block in the global mesh
c
      dimension matnum(0:mngx+1,0:mngy+1)
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
******************************************************************

      integer nx,ny,ngx,ngy,ntsnap,jsou,ksou,nrec,isourid
      integer kdel,nwsnap,maxiter,nsize,maxlow,npf,keym
      real*8  h,reduc,hpx,hpy,f1,f2,f3,f4,perclow,xsou,ysou
      real*8  fq1,fq2,vmin,veloc1
      real*8  delf,delw      
      integer j,k
      real *8 vp1,vp2,vs
      
      integer nt,if1,if2,if3,if4
      integer jw1,jw2,jwlow
********************************************************************
********************************************************************
      real*8  xkm_m(0:mnx+1,0:mny+1)
      real*8  struc(0:mnx+1,0:mny+1)
      real*8  kperm(0:mnx+1,0:mny+1)
      real*8  fi(0:mnx+1,0:mny+1)
      real*8 kf(0:mnx+1,0:mny+1)
      real*8 rhof(0:mnx+1,0:mny+1)
      real*8 muf(0:mnx+1,0:mny+1),xks(0:mnx+1,0:mny+1)
      real*8 ros(0:mnx+1,0:mny+1)
      real*8 qsm(0:mnx+1,0:mny+1),qkc(0:mnx+1,0:mny+1)
      real*8 qm(0:mnx+1,0:mny+1)



c     end dimension statements
csp2      TMP - PARALLEL CODE

      open(unit=5,file='inp_400x1200_60p',form='formatted',
     1             status='unknown')
      open(unit=6,file='out_400x1200_ve_60p',form='formatted',
     1             status='unknown')
csp2---------------------------------------------------------------
	call MPI_INIT(mpierr)
        if(mpierr .ne. 0)then
           write(6,*)' MPI error !!! (1)'
           stop
         endif 
           	
	call MPI_COMM_SIZE(MPI_COMM_WORLD,nprocs,mpierr)
	   if(mpierr .ne. 0)then
           write(6,*)' MPI error !!! (2)'
           stop
         endif
csp2----------------------------------------------------------------

      pi=dabs(4.d0*datan(1.d0))
      twopi = 2.d0*pi

csp2      TMP - PARALLEL CODE

csp2      
      prfirst=1
      prsecond=1
      prtherd=1
        t0 = timer()
c     Set processor id
csp2----------------------------------------------------------------
	call MPI_COMM_RANK(MPI_COMM_WORLD,blockid,mpierr)
	
         if(mpierr .ne. 0)then
           write(6,*)' MPI error !!! (3)'
           stop
         endif	
csp2----------------------------------------------------------------

c     TMP - SERIAL CODE
c      blockid=mynode()
c       blockid=0


       call      readata(freq,key,stime,nx,ny,ngx,ngy,h,ntsnap,
     1              matnum,jsou,ksou,nrec,irx,iry,isourid,irecid,
     1              kdel,nwsnap,maxiter,reduc,nsize,hpx,hpy,
     1              wsnap,tsnap,maxlow,npf,f1,f2,f3,f4,perclow,
     1              xsou,ysou,rx,ry,fq1,fq2,keym,vmin,veloc1,
     1              kf1,kf2,rof1,rof2,muf1,muf2,xks1,xks2,ros1,ros2,
     1              phi1,phi2,perm1,perm2,qsm1,qsm2,qkc1,qkc2,qm1,
     1              qm2,esp1,esp2,nc1,nc2,xkm1,xkm2,xnw1,xnw2,
     1              np1,np2)
     

c 
       call     init(u1ln,u1tn,u1bn,u1rn,u2ln,u2tn,u2bn,u2rn, 
     1               unln,untn,unbn,unrn, 
     1               lag1ln,lag1tn,lag1bn,lag1rn,lag2ln,lag2tn, 
     1               lag2bn,lag2rn,lagnln,lagntn,lagnbn,lagnrn, 
     1               tpic2,tpic_curls,tpicny,nx,ny,ntsnap,
     1               tpic_divus,tpic_divun)    



c      set subdomain types

       vblockid(1) = mod(blockid,nsx)
       vblockid(2) = blockid/nsx

c      set subdomain type  in variable blockty of common /a1

       call subtype
 
c
c  sets delta  vectors accoeding to the subdomain type  blockty
c 
       call setdelta(nx,ny,deltal,deltar,deltat,deltab)

*****************************************************************************
* German: es aqui donde  se  leen de archivos las matrices globales con datos de
*  kf, rof, etc 
	   
      	
      call get_local_coef(kf,rhof,muf,xks,ros,fi,kperm,qsm,         
     1                     qkc,qm,xkm_m,struc,nx,ny,
     1                     h,hpx,hpy,ngx,ngy,shear_mod_el)
     

c Atencion: dentro de stabil veloc1 y vmin se fijaron, no se calcularon
c
      call     stabil(veloc1,vmin,h,stime,dt,nt,ntsnap,nwsnap,
     1                 delf,delw,itsnap,iwsnap,wsnap,tsnap,npf,
     1                 f1,f2,f3,f4,if1,if2,if3,if4,jw1,jw2,
     1                  jwlow,perclow,freq)

c computes souce in time and its Fourier transform and  amplitude spectrum
      
      call     calsource(freq,key,nt,delw,delf,jw2,if3,if4,fsour,dt)

 
c fijo la frecuencia central (en hertz) para los modelos de zener en freq 
c antes de entrar al loop en frecs.

c        w_0= twopi*freq*1.d+03
        w_0= twopi*freq	
      if(blockid.eq.ncontrol) then	
        write(6,*) 'w_0/twopi (kHz)=',w_0/twopi
      endif
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c    FRECUENCIAS
c
c                      jw2 = iwsnap(1)
c                      jw1 = iwsnap(1)
		      

c               jw2=7
c		jw1 = jw2
      if(blockid.eq.ncontrol) then
            write(6,2345)jw1,jw2
2345        format(/1x,' jw1 , jw2  in main = ',i5,4x,i5)
      endif

c             if(jw1.eq.jw2)stop 65387
c AQUI VA EL LOOP QUE CHEQUEA LAS VELOCIDADES!!!!!!!!!!!!!!!!

          
       do 3477 jw = jw2,jw1,-1
       
       fjw=jw
       fjw=fjw-1.d0+.5d0
       fr=fjw*delf
       omega=fr*twopi
       frmax = jw2 
       frmax = frmax -1.d0+.5d0
       frmax = frmax*delf
             
c computes  bulk density  in each cell (j,k)

       call bulk_density(fi,rhof,ros,nx,ny,rhob_m)

c calculo de los coeficientes elasticos	en cada celda (j,k)

c      call e_modulus(kf,xks,xkm_m,xnw_m,fi,nx,ny,xlamcw_m,bw_m,xmw_m)

       
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

c   put freq and frmax in units of hz


       freq=omega
       frmax = twopi*frmax
       
       call ve_modulus(freq,w_0,keym,qsm,qkc,qm,
     1   fq1,fq2,nx,ny,kf,xks,fi,xkm_m,shear_mod_el,
     1   xnw_m,xlamcw_m,bw_m,xmw_m)
     
c         call  ve_modulus(freq,w_0,keym,qsm,qkc,qm,fq1,fq2,nx,ny,
c     1   xnw_m,xlamcw_m,bw_m,xmw_m)


        call viscodynamic(freq,kperm,fi,muf,rhof,struc,nx,ny,g_m,b_m) 

         
       
c AQUI LLAMO A LA SUBRUTINA QUE CALCULA VELS. Y ATENUACIONES     
       do j=0,nx+1
       do k=0,ny+1
       hh=xlamcw_m(j,k)+2.d0*xnw_m(j,k)
               
      call veloc_aten(xmw_m(j,k),hh,bw_m(j,k),rhof(j,k),g_m(j,k)
     1,rhob_m(j,k),b_m(j,k),omega,xnw_m(j,k),vp1,vp2,vs,j,k)
 
        if(jw.eq.jw2.and.j.eq.1.and.k.eq.1)then    
            if(blockid.eq.ncontrol)then
               write(*,*)' frequency number jw = ',jw
	       write(*,*)     
               write(*,*)'wave speeds for element j,k =',j,k
               write(*,*)
               write(*,*)' vp1 = ',vp1,' vp2 = ',vp2,' vs = ',vs 
               write(*,*)
	       write(*,*)' xmw_m(j,k) = ', xmw_m(j,k)
	       if(dimag(xmw_m(j,k)).gt.1.d-15)then	       
               write(*,*)
	       write(*,*)' Q_M=dreal(xmw_m)/dimag(xmw) = ',
     1  	        dreal(xmw_m(j,k))/dimag(xmw_m(j,k))
               write(*,*)	       
               endif	       
	       
	       write(*,*)' hh = ',hh
               write(*,*)
	       write(*,*)' bw_m(j,k) = ', bw_m(j,k)	       
               write(*,*)
	       write(*,*)' rhof(j,k) = ', rhof(j,k)	       
               write(*,*)
	       write(*,*)' g_m(j,k) = ', g_m(j,k)	       
               write(*,*)
	       write(*,*)' rhob_m(j,k) = ', rhob_m(j,k)
               write(*,*)
	       write(*,*)' b_m(j,k) = ', b_m(j,k)
               write(*,*)
	       write(*,*)' frequency = ',omega/twopi,' kHz'	       	 	       
               write(*,*)
	       write(*,*)' xnw_m(j,k) = ', xnw_m(j,k)
	       if(dimag(xnw_m(j,k)).gt.1.d-15)then	       	       
               write(*,*)
	       write(*,*)' Q_N= dreal(xnw)/dimag(xnw) = ',
     1  	        dreal(xnw_m(j,k))/dimag(xnw_m(j,k))
               write(*,*)
	       endif	       	       	  	       	         
             endif   
         endif
        if(jw.eq.jw2.and.j.eq.nx.and.k.eq.(ny-1))then    
            if(blockid.eq.ncontrol)then
               write(*,*)' frequency number jw = ',jw
  	       write(*,*)     
               write(*,*)'wave speeds for element j,k =',j,k
               write(*,*)
               write(*,*)' vp1 = ',vp1,' vp2 = ',vp2,' vs = ',vs 
               write(*,*)
	       write(*,*)' xmw_m(j,k) = ', xmw_m(j,k)
	       if(dimag(xmw_m(j,k)).gt.1.d-15)then
               write(*,*)
	       write(*,*)' Q_M= dreal(xmw_m)/dimag(xmw) = ',
     1  	        dreal(xmw_m(j,k))/dimag(xmw_m(j,k))
               endif
	       
               write(*,*)	 	           	       
	       write(*,*)' hh = ',hh
               write(*,*)
	       write(*,*)' bw_m(j,k) = ', bw_m(j,k)	       
               write(*,*)
	       write(*,*)' rhof(j,k) = ', rhof(j,k)	       
               write(*,*)
	       write(*,*)' g_m(j,k) = ', g_m(j,k)	       
               write(*,*)
	       write(*,*)' rhob_m(j,k) = ', rhob_m(j,k)
               write(*,*)
	       write(*,*)' b_m(j,k) = ', b_m(j,k)
               write(*,*)
	       write(*,*)' frequency = ',omega/twopi,' kHz'	       	 	       
               write(*,*)
	       write(*,*)' xnw_m(j,k) = ', xnw_m(j,k)
	       if(dimag(xnw_m(j,k)).gt.1.d-15)then	       
	       write(*,*)
	       write(*,*)' Q_N = dreal(xnw)/dimag(xnw) = ',
     1  	        dreal(xnw_m(j,k))/dimag(xnw_m(j,k))
               write(*,*)
	       endif	 	           
             endif   
         endif

        if(jw.eq.jw1.and.j.eq.1.and.k.eq.1)then    
            if(blockid.eq.ncontrol)then
               write(*,*)' frequency number jw = ',jw
	       write(*,*)     
               write(*,*)'wave speeds for element j,k =',j,k
               write(*,*)
               write(*,*)' vp1 = ',vp1,' vp2 = ',vp2,' vs = ',vs 
               write(*,*)
	       write(*,*)' xmw_m(j,k) = ', xmw_m(j,k)
	       if(dimag(xmw_m(j,k)).gt.1.d-15)then	       
               write(*,*)
	       write(*,*)' Q_M=dreal(xmw_m)/dimag(xmw) = ',
     1  	        dreal(xmw_m(j,k))/dimag(xmw_m(j,k))
               write(*,*)	       
               endif	       
	       
	       write(*,*)' hh = ',hh
               write(*,*)
	       write(*,*)' bw_m(j,k) = ', bw_m(j,k)	       
               write(*,*)
	       write(*,*)' rhof(j,k) = ', rhof(j,k)	       
               write(*,*)
	       write(*,*)' g_m(j,k) = ', g_m(j,k)	       
               write(*,*)
	       write(*,*)' rhob_m(j,k) = ', rhob_m(j,k)
               write(*,*)
	       write(*,*)' b_m(j,k) = ', b_m(j,k)
               write(*,*)
	       write(*,*)' frequency = ',omega/twopi,' kHz'	       	 	       
               write(*,*)
	       write(*,*)' xnw_m(j,k) = ', xnw_m(j,k)
	       if(dimag(xnw_m(j,k)).gt.1.d-15)then	       	       
               write(*,*)
	       write(*,*)' Q_N= dreal(xnw)/dimag(xnw) = ',
     1  	        dreal(xnw_m(j,k))/dimag(xnw_m(j,k))
               write(*,*)
	       endif	       	       	  	       	         
             endif   
         endif
        if(jw.eq.jw1.and.j.eq.nx.and.k.eq.(ny-1))then    
            if(blockid.eq.ncontrol)then
               write(*,*)' frequency number jw = ',jw
  	       write(*,*)     
               write(*,*)'wave speeds for element j,k =',j,k
               write(*,*)
               write(*,*)' vp1 = ',vp1,' vp2 = ',vp2,' vs = ',vs 
               write(*,*)
	       write(*,*)' xmw_m(j,k) = ', xmw_m(j,k)
	       if(dimag(xmw_m(j,k)).gt.1.d-15)then
               write(*,*)
	       write(*,*)' Q_M= dreal(xmw_m)/dimag(xmw) = ',
     1  	        dreal(xmw_m(j,k))/dimag(xmw_m(j,k))
               endif
	       
               write(*,*)	 	           	       
	       write(*,*)' hh = ',hh
               write(*,*)
	       write(*,*)' bw_m(j,k) = ', bw_m(j,k)	       
               write(*,*)
	       write(*,*)' rhof(j,k) = ', rhof(j,k)	       
               write(*,*)
	       write(*,*)' g_m(j,k) = ', g_m(j,k)	       
               write(*,*)
	       write(*,*)' rhob_m(j,k) = ', rhob_m(j,k)
               write(*,*)
	       write(*,*)' b_m(j,k) = ', b_m(j,k)
               write(*,*)
	       write(*,*)' frequency = ',omega/twopi,' kHz'	       	 	       
               write(*,*)
	       write(*,*)' xnw_m(j,k) = ', xnw_m(j,k)
	       if(dimag(xnw_m(j,k)).gt.1.d-15)then	       
	       write(*,*)
	       write(*,*)' Q_N = dreal(xnw)/dimag(xnw) = ',
     1  	        dreal(xnw_m(j,k))/dimag(xnw_m(j,k))
               write(*,*)
	       endif	 	           
             endif   
         endif
	   


	   
      if((vp1.lt.0.d0).or.(vp1.gt.6.d0)) then
      if(blockid.eq.ncontrol) then      
      write(*,*)'LAS VELOC. NO DAN BIEN for jw, j,k = ',jw,j,k
      write(6,*)' vp1 = ',vp1      
      endif
      stop
      endif
       if((vp2.lt.0.d0).or.(vp2.gt.6.d0)) then
      if(blockid.eq.ncontrol) then        
      write(*,*)'LAS VELOC. NO DAN BIEN  for omega,j,k =',jw,j,k
      write(6,*)' vp2 = ',vp2      
      endif      
      stop
      endif
      if((vs.lt.0.d0).or.(vs.gt.6.d0)) then
      if(blockid.eq.ncontrol) then       
      write(*,*)'LAS VELOCIDADES NO DAN BIEN for jw,j,k =',jw,j,k
      write(6,*)' vs = ',vs      
      endif           
      stop
      endif
      enddo
      enddo
       
        
 3477  continue
 
        
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c MAIN LOOP IN FREQUENCY************************************

c              jw1=jw2
	       
            do 3000 jw = jw2,jw1,-1
c
c
c     sets  current angular frequency  omega  to compute the solution
           
       fjw=jw
       fjw=fjw-1.d0+.5d0
       fr=fjw*delf
       omega=fr*twopi
       frmax = jw2 
       frmax = frmax -1.d0+.5d0
       frmax = frmax*delf

c computes  bulk density  in each cell (j,k)

       call bulk_density(fi,rhof,ros,nx,ny,rhob_m)

c calculo de los coeficientes elasticos	en cada celda (j,k)
 
c      call e_modulus(kf,xks,xkm_m,xnw_m,fi,nx,ny,xlamcw_m,bw_m,xmw_m)

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

c   put freq and frmax in units of hz

       freq=omega
       frmax = twopi*frmax
       
       call ve_modulus(freq,w_0,keym,qsm,qkc,qm,
     1   fq1,fq2,nx,ny,kf,xks,fi,xkm_m,shear_mod_el,
     1   xnw_m,xlamcw_m,bw_m,xmw_m)

c         call  ve_modulus(freq,w_0,keym,qsm,qkc,qm,fq1,fq2,nx,ny,
c     1   xnw_m,xlamcw_m,bw_m,xmw_m)

        call viscodynamic(freq,kperm,fi,muf,rhof,struc,nx,ny,g_m,b_m)

      if(blockid.eq.ncontrol) then
       write(6,88666)jw,fr,dreal(fsour(jw)),dimag(fsour(jw))
88666  format(/1x,'frequency number : ',i5,/
     1            ' frequency :        ',g15.5,' kHz',/
     1            ' Real(source) :     ',g15.5/
     1            ' Imag(source) :     ',g15.5/)
       endif 


ccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
     
    
c    Computes iteration matrices betal,betar,betab,betat and  
c    entries in local matrices of the domain decomposition algorithm
c   ( 12x12 matrix cc(.,.) on each cell) and performs the LU-factorization of such matrices
c   (nx times   ny in total), stored in  cc_lu  
        
         call    coeflu(nx,ny,omega,
     1                  betal,betar,betab,betat,h,
     1                  deltal,deltar,deltab,deltat,
     1                  rhob_m,rhof,
     1                  xlamcw_m,xnw_m,bw_m,xmw_m,
     1                  b_m,g_m,b,
     1                  cc,cc_lu)
              
      if(blockid.eq.ncontrol.and.jw.eq.jw2) then
      write(6,*)' in driver after coeflu for  jw = ',jw
      endif
c
c   set maximum number of  inner iterations 
c acording to the  frequency number ( less number of 
c  iterations for low frequencies)
         maxi = maxiter
         if(jw.le.jwlow)maxi = maxlow

            do  1001 iter = 1, maxi

      if(blockid.eq.ncontrol.and.jw.eq.jw2.and.iter.eq.1) then
      write(6,*)' in driver before setbuf for iter ',iter,' jw  ',jw
      endif

c   performs one inner iteration
c
c   Fills buffer for each type of block ( 0-8)
c
csp2      PARALLEL CODE
csp2----------------------------------------------------------------------------------      
      call       setbuf_biot(nx,ny,sendvec,recvec,nsize,
     1       u1ln,u1tn,u1bn,u1rn,u2ln,u2tn,u2bn,u2rn,
     1       unln,untn,unbn,unrn,
     1       lag1ln,lag1tn,lag1bn,lag1rn,lag2ln,lag2tn,lag2bn,lag2rn,
     1       lagnln,lagntn,lagnbn,lagnrn)
     
      if(blockid.eq.ncontrol.and.jw.eq.jw2.and.iter.eq.1) then
      write(6,*)' in driver after setbuf for iter ',iter,' jw  ',jw
      endif
csp2----------------------------------------------------------------------------------
c
c    save current iteration for error check
        call         save_u(nx,ny,u1ln,u1tn,u1bn,u1rn,
     1                      lag1ln,lag1tn,lag1bn,lag1rn,
     1                      u2ln,u2tn,u2bn,u2rn,
     1                      lag2ln,lag2tn,lag2bn,lag2rn,
     1                      unln,untn,unbn,unrn,
     1                      lagnln,lagntn,lagnbn,lagnrn,
     1                      u1lnp1,u1tnp1,u1bnp1,u1rnp1,
     1                      lag1lnp1,lag1tnp1,lag1bnp1,lag1rnp1,
     1                      u2lnp1,u2tnp1,u2bnp1,u2rnp1,
     1                      lag2lnp1,lag2tnp1,lag2bnp1,lag2rnp1,
     1                      unlnp1,untnp1,unbnp1,unrnp1,
     1                      lagnlnp1,lagntnp1,lagnbnp1,lagnrnp1)

c   computes  displacement   u   for  all  black cells  (j,k)

       call         solvb(nx,ny,jw,u1ln,u1tn,u1bn,u1rn,
     1                    lag1ln,lag1tn,lag1bn,lag1rn,
     1                    u2ln,u2tn,u2bn,u2rn,
     1                    lag2ln,lag2tn,lag2bn,lag2rn,
     1                    unln,untn,unbn,unrn,
     1                    lagnln,lagntn,lagnbn,lagnrn,
     1                    omega,
     1                    betal,betar,betab,betat,h,kdel,
     1                    jsou,ksou,fsour,cc_lu,
     1                    deltal,deltar,deltab,deltat,isourid)

c
c updates black Lagrange multipliers
c

      call       uplagb(nx,ny,omega,betal,betar,betab,betat,
     1               u1ln,u1tn,u1bn,u1rn,
     1               lag1ln,lag1tn,lag1bn,lag1rn,
     1               u2ln,u2tn,u2bn,u2rn,
     1               lag2ln,lag2tn,lag2bn,lag2rn,
     1               unln,untn,unbn,unrn,
     1               lagnln,lagntn,lagnbn,lagnrn)


csp2      PARALLEL CODE
csp2----------------------------------------------------------------------------------      
      call       setbuf_biot(nx,ny,sendvec,recvec,nsize,
     1       u1ln,u1tn,u1bn,u1rn,u2ln,u2tn,u2bn,u2rn,
     1       unln,untn,unbn,unrn,
     1       lag1ln,lag1tn,lag1bn,lag1rn,lag2ln,lag2tn,lag2bn,lag2rn,
     1       lagnln,lagntn,lagnbn,lagnrn)

csp2----------------------------------------------------------------------------------

*  solves for  all (j,k) red cells 

       call         solvr(nx,ny,jw,u1ln,u1tn,u1bn,u1rn,
     1                    lag1ln,lag1tn,lag1bn,lag1rn,
     1                    u2ln,u2tn,u2bn,u2rn,
     1                    lag2ln,lag2tn,lag2bn,lag2rn,
     1                    unln,untn,unbn,unrn,
     1                    lagnln,lagntn,lagnbn,lagnrn,
     1                    omega,
     1                    betal,betar,betab,betat,h,kdel,
     1                    jsou,ksou,fsour,cc_lu,
     1                    deltal,deltar,deltab,deltat,isourid)
	    
c
c updates red Lagrange multipliers
c

      call       uplagr(nx,ny,omega,betal,betar,betab,betat,
     1               u1ln,u1tn,u1bn,u1rn,
     1               lag1ln,lag1tn,lag1bn,lag1rn,
     1               u2ln,u2tn,u2bn,u2rn,
     1               lag2ln,lag2tn,lag2bn,lag2rn,
     1               unln,untn,unbn,unrn,
     1               lagnln,lagntn,lagnbn,lagnrn)

  
c   underrelaxes solution u and lagrange multipliers
c   underrelaxation factor is taken to be .5 


        call          relax(nx,ny,u1ln,u1tn,u1bn,u1rn,
     1                      lag1ln,lag1tn,lag1bn,lag1rn,
     1                      u2ln,u2tn,u2bn,u2rn,
     1                      lag2ln,lag2tn,lag2bn,lag2rn,
     1                      unln,untn,unbn,unrn,
     1                      lagnln,lagntn,lagnbn,lagnrn,
     1                      u1lnp1,u1tnp1,u1bnp1,u1rnp1,
     1                      lag1lnp1,lag1tnp1,lag1bnp1,lag1rnp1,
     1                      u2lnp1,u2tnp1,u2bnp1,u2rnp1,
     1                      lag2lnp1,lag2tnp1,lag2bnp1,lag2rnp1,
     1                      unlnp1,untnp1,unbnp1,unrnp1,
     1                      lagnlnp1,lagntnp1,lagnbnp1,lagnrnp1)

      if(iter.eq.1) errn=1.d0

c JUAN change: now only computes error every 10 iterations
c  to save computing time
      
      if(iter.gt.1.and.mod(iter,10).eq.0)then

c  Checks if desired error reduction  has been  achieved. first computes local
c  error

             errn = 0.d0
              den = 0.d0
             do  j=1,nx
              do   k=1,ny
           errn = errn + ( cdabs( u1lnp1(j,k) - u1ln(j,k) ))**2
     1                   + ( cdabs( u1tnp1(j,k) - u1tn(j,k) ))**2
     1                   + ( cdabs( u1bnp1(j,k) - u1bn(j,k) ))**2
     1                   + ( cdabs( u1rnp1(j,k) - u1rn(j,k) ))**2
     1                   + ( cdabs( u2lnp1(j,k) - u2ln(j,k) ))**2
     1                   + ( cdabs( u2tnp1(j,k) - u2tn(j,k) ))**2
     1                   + ( cdabs( u2bnp1(j,k) - u2bn(j,k) ))**2
     1                   + ( cdabs( u2rnp1(j,k) - u2rn(j,k) ))**2
     1                   + ( cdabs( unlnp1(j,k) - unln(j,k) ))**2
     1                   + ( cdabs( untnp1(j,k) - untn(j,k) ))**2
     1                   + ( cdabs( unbnp1(j,k) - unbn(j,k) ))**2
     1                   + ( cdabs( unrnp1(j,k) - unrn(j,k) ))**2
                       

            den  = den + ( cdabs( u1lnp1(j,k) + u1ln(j,k) ))**2
     1                   + ( cdabs( u1tnp1(j,k) + u1tn(j,k) ))**2
     1                   + ( cdabs( u1bnp1(j,k) + u1bn(j,k) ))**2
     1                   + ( cdabs( u1rnp1(j,k) + u1rn(j,k) ))**2
     1                   + ( cdabs( u2lnp1(j,k) + u2ln(j,k) ))**2
     1                   + ( cdabs( u2tnp1(j,k) + u2tn(j,k) ))**2
     1                   + ( cdabs( u2bnp1(j,k) + u2bn(j,k) ))**2
     1                   + ( cdabs( u2rnp1(j,k) + u2rn(j,k) ))**2
     1                   + ( cdabs( unlnp1(j,k) + unln(j,k) ))**2
     1                   + ( cdabs( untnp1(j,k) + untn(j,k) ))**2
     1                   + ( cdabs( unbnp1(j,k) + unbn(j,k) ))**2
     1                   + ( cdabs( unrnp1(j,k) + unrn(j,k) ))**2
     

            enddo
             enddo

           suml(1) = errn
           suml(2) = den
           if(den.lt.1.d-12) den = 1.d0
              errn = errn/den
              errn = 2.d0*dsqrt(errn)
	      
c  next computes global error
csp2--------------------------------------------------------------
	icomm=1
c	call MPI_REDUCE(suml,swork,2,MPI_DOUBLE_PRECISION,
c     1                  MPI_SUM,ncontrol,icomm,mpierr)

 	call MPI_ALLREDUCE(suml,swork,2,MPI_DOUBLE_PRECISION,
     &                  MPI_SUM,MPI_COMM_WORLD,mpierr)

         if(mpierr .ne. 0)then
           write(6,*)' MPI error !!! (4)'
           stop
         endif
         
        call MPI_BCAST(swork,2,MPI_DOUBLE_PRECISION,ncontrol,
     !                 MPI_COMM_WORLD,mpierr)
         if(mpierr .ne. 0)then
           write(6,*)' MPI error !!! (5)'
           stop
         endif     
     
        suml(1) = swork(1)
        suml(2) = swork(2)

           errn = suml(1)
           den = suml(2)
           errn = errn/den
           errn = dsqrt(errn)
           errn = 2.d0*errn
csp2 -------------------------------------------------------------
             endif
           
      if(mod(iter,10).eq.0) then
           if(blockid.eq.ncontrol) then
                write(6,291)iter,errn,reduc
           endif
291   format(/1x,' iteration number = ',i5,/,
     1           ' actual rel. error reduc.(black-red)= ',e20.8,/,
     1           ' required relative error reduction  = ',e20.8)


                if(errn.lt.reduc)then
        if(blockid.eq.ncontrol) then
            write(6,66291)jw,iter,errn,reduc
66291     format(/1x,' convergence  for freq. # ',i5,
     1               ' achieved in ',i5,' inner iterations ',/,
     1               ' relative error reduction value = ',e20.8,/,
     1               ' required error reduction value = ',e20.8)
        endif
             
c
c   goes to solve for next omega
c
         go to 3005
	 
	       endif
	 endif

c
c    ends  inner domain decomposition  iteration
c

1001        continue

      if(blockid.eq.ncontrol) then
            write(6,64291)jw,iter,errn,reduc
64291     format(/1x,' NO convergence  for freq. # ',i5,
     1               ' after  ',i5,' inner iterations ',/,
     1               ' relative error value reduction = ',e20.8,/,
     1               ' required error reduction  =',e20.8)
       endif

3005    continue


c
c  checks if  we have to write  snapshots in the space-frequency domain
c  writes freq. domain snapshots in avu*f.biot
c

       do iw=1,nwsnap
           if(jw.eq.iwsnap(iw)) then 
c      call       fgprint(fr,prfirst,nx,ny,nmax,omega,
c     1                   u1ln,u1tn,u1bn,u1rn,u2ln,u2tn,u2bn,u2rn,
c     1                   unln,untn,unbn,unrn)
            endif
       enddo 


c
c       actualizes snapshots in the time domain in matrix tpic
c       for the times specified in vector tsnap(ntsnap) using the
c       solution obtained  for the current frequency
c       to compute the corresponding terms  in the discrete
c       inverse Fourier transform 
c
           jjw=jw
         
            call finvpic2(jjw,nx,ny,u1ln,u1tn,u1bn,u1rn,
     1                    u2ln,u2tn,u2bn,u2rn,unln,untn,unbn,unrn,
     1                    tpic2,tpic_curls,
     1                    tpicny,ntsnap,itsnap,dt,delw,h,
     1                    tpic_divus,tpic_divun)
	    
       call       savtrace(nrec,delw,jjw,h,irx,iry,fu1,fu2,
     1                     fdivus,fdivun,funz,
     1                     fcurl_us,fcurl_un,
     1                     u1ln,u1bn,u1rn,u1tn,u2ln,u2bn,u2rn,u2tn,
     1                     unln,untn,unbn,unrn,irecid)

c
c   ends  main loop in frequency

3000        continue

c
c   writes snapshots  in the time
c   domain  in files avu*t.biot
c
      call      tgprint(ntsnap,tsnap,nx,ny,nmax,nsize,delw,
     1                   tpic2,tpicny,tpic_divus,tpic_curls,
     1                   tpic_divun)
     
     
c  writes recorded traces at the specified receiver locations 
   
      call     out_traces(nx,ny,ntsnap,fu2,fdivus,fdivun,funz,
     1                    fcurl_us,fcurl_un, 
     1                    nt,dt,delw,jw1,jw2,nrec,irecid)     


csp2----------------------------------------------------------------
        if(blockid.eq.ncontrol) then     
         write(6,2356)timer()
2356   format(/1x,'tiempo for total run in IBMSP2=',g20.8,'seconds')
        endif
	
csp2----------------------------------------------------------------

	call MPI_FINALIZE(mpierr)
        if(mpierr .ne. 0)then
           write(6,*)' MPI error !!! (6)'
           stop
         endif	
	
csp2  -------------------------------------------------------------	
             stop
              end
************************************************************************
c    to be used with the SUN's
c           real*8 function timer()
c
c           real*4 etime,ust(2),time,time0
c           data time0/0.0/

c           time = etime(ust)
c           timer = time - time0
c           time0 = time

c           return
c           end
***********************************************************************
c
c  The function below should be used with the IBM's
c
          real*8 function timer()
          integer*4 mclock,time,time0
          data time0/0/

          time = mclock()
          timer = (time-time0)/100.
          time0 = time

          return
          end	      
*****************************************************************************
      subroutine  fgprint(fr,prfirst,nx,ny,nmax,omega,
     1                   u1ln,u1tn,u1bn,u1rn,u2ln,u2tn,u2bn,u2rn,
     1                   unln,untn,unbn,unrn)
c         parallel printout functions
        include 'sizes'
      implicit real*8(a-h,o-z)
       integer blockid,vblockid,blockty
      integer prfirst

      common/a1/ncontrol,blockid,vblockid(2),blockty,nsx,nsy

      complex*16 u1ln(0:mnx+1,0:mny+1),u1tn(0:mnx+1,0:mny+1),
     1           u1bn(0:mnx+1,0:mny+1),u1rn(0:mnx+1,0:mny+1)
      complex*16 u2ln(0:mnx+1,0:mny+1),u2tn(0:mnx+1,0:mny+1),
     1           u2bn(0:mnx+1,0:mny+1),u2rn(0:mnx+1,0:mny+1)
      complex*16 unln(0:mnx+1,0:mny+1),untn(0:mnx+1,0:mny+1),
     1           unbn(0:mnx+1,0:mny+1),unrn(0:mnx+1,0:mny+1)


      complex*16 avunvec1(0:mnx*mny),avunvec2(0:mnx*mny)
      complex*16 avsol1,aim
csp2------------------------------------------------------------
c        for MPI use dimension for nbytes, NOT the size in bytes
c
         nbytes = (nx*ny+1)
csp2 ----------------------------------------------------------
         if(prfirst.eq.1)then
         prfirst = -1
         if(blockid.eq.0)then
csp2-----------------------------------------------------------------------
         open(unit=20,file='avu2yf.biot',
     1   status='unknown')
         open(unit=21,file='avunyf.biot',
     1   status='unknown')

csp2 ---------------------------------------------------------------
         endif
         endif
       aim=dcmplx(0.d0,1.d0)

         avunvec1(0) = dcmplx(fr,0.d0)
         do j=0,ny-1
         do i=0,nx-1
              avsol1 =   .25d0* (u2ln(i+1,j+1)  +
     1                           u2tn(i+1,j+1)  +
     1                           u2bn(i+1,j+1)  +
     1                           u2rn(i+1,j+1)     )
            if(cdabs(avsol1).lt.1.e-14) avsol1 = dcmplx(0.d0,0.d0)
         avunvec1(1+i+j*nx) = avsol1
         enddo
         enddo

         avunvec2(0) = dcmplx(fr,0.d0)
         do j=0,ny-1
         do i=0,nx-1
              avsol1 =   .5d0* (-unbn(i+1,j+1) +
     1                           untn(i+1,j+1)   )
            if(cdabs(avsol1).lt.1.e-14) avsol1 = dcmplx(0.d0,0.d0)
         avunvec2(1+i+j*nx) = avsol1
         enddo
         enddo



       if(blockid.eq.0)then
       write(20,44) dreal(avunvec1(0))
       write(21,44) dreal(avunvec2(0))

       write(20,44)(dreal(aim*omega*avunvec1(i)),i=1,nx*ny)
       write(21,44)(dreal(aim*omega*avunvec2(i)),i=1,nx*ny)

44     format(e12.5)
         do j=1,nsx*nsy-1
c      / block 0  receives and print data from node j */
        call cmrecxy(j,1,avunvec1,nbytes)
        call cmrecxy(j,1,avunvec2,nbytes)

c     writes in 90,92,94 information received from node j
c
       write(20,44) dreal(avunvec1(0))
       write(21,44) dreal(avunvec2(0))

       write(20,44)(dreal(aim*omega*avunvec1(i)),i=1,nx*ny)
       write(21,44)(dreal(aim*omega*avunvec2(i)),i=1,nx*ny)

         enddo
       else
c
c      /* Current node sends data to node 0 */
c
        call cmsendxy(0,1,avunvec1,nbytes)
        call cmsendxy(0,1,avunvec2,nbytes)

             endif

        return
          end
***************************************************************	

       subroutine  tgprint(ntsnap,tsnap,nx,ny,nmax,nsize,delw,
     1                   tpic2,tpicny,tpic_divus,tpic_curls,
     1                   tpic_divun) 
     

c         parallel printout functions
c   Block 0 writes 
c   avu2yt.biot = unit 10 : snapshots of vs_z in 
c   avunty.biot = unit 11 : snapshots of vn_z in 
c   curlst.biot = unit 12 : snap of curl vs
c   divust.biot = unit 14 : snap of div vs
c   divust.biot = unit 15 : snap of div vn

        include 'sizes'      
      implicit real*8(a-h,o-z)
       integer blockid,vblockid,blockty
      common/a1/ncontrol,blockid,vblockid(2),blockty,nsx,nsy

      real*8 tpic2(mnx,mny,mtsnap),tpic_curls(mnx,mny,mtsnap)
      real*8 tpicny(mnx,mny,mtsnap)
      dimension tsnap(10)
      real*8 avunvec1(0:mnx*mny),avunvec2(0:mnx*mny)
      real*8 avunvec4(0:mnx*mny)
*cambio Claudia
      real*8 avunvec6(0:mnx*mny)
      real*8 avunvec7(0:mnx*mny)
      
      real*8 tpic_divus(mnx,mny,mtsnap),tpic_divun(mnx,mny,mtsnap)

         if(blockid.eq.0)then
csp2 ----------------------------------------------------
c   writes in 10 snapshots in time domain u2s
         open(unit=10,file='avu2yt.biot',
     1   status='unknown')
c   writes in 11 snapshots in time domain uny
c         open(unit=22,file='avunyt.biot',
        open(unit=11,file='avunyt.biot',
     1   status='unknown')

c   writes in 12 snapshots in time domain curls
c         open(unit=46,file='curlst.biot',
         open(unit=12,file='curlst.biot',	 
     1   status='unknown')
*cambio Claudia


c   writes in 14 snapshots in time domain div(us)
c         open(unit=48,file='divust.biot',
         open(unit=14,file='divust.biot',	 
     1   status='unknown')
c   writes in 15 snapshots in time domain div(un)
     
         open(unit=15,file='divunt.biot',	 
     1   status='unknown')
     
csp2 ----------------------------------------------------
         endif
csp2----------------------------------------------
c   for MPI use dimension as size, NOT bytes
          nbytes = (nx*ny+1) 
csp2  --------------------------------------------
      pi = 4.d0*datan(1.d0)

         do nn=1,ntsnap
         avunvec1(0) = tsnap(nn)
         avunvec2(0) = tsnap(nn)

         avunvec4(0) = tsnap(nn)

         avunvec6(0) = tsnap(nn)
         avunvec7(0) = tsnap(nn)
c
       do j=0,ny-1
       do i=0,nx-1
         avunvec1(1+i+j*nx) = tpic2(i+1,j+1,nn)
         avunvec2(1+i+j*nx) = tpicny(i+1,j+1,nn)
c         avunvec3(1+i+j*nx) = tpicwy(i+1,j+1,nn)

	 
         avunvec4(1+i+j*nx) = tpic_curls(i+1,j+1,nn)
*cambio Claudia

c         avunvec5(1+i+j*nx) = dsqrt(tpic1(i+1,j+1,nn)**2+
c     $   tpic2(i+1,j+1,nn)**2)
         avunvec6(1+i+j*nx) = tpic_divus(i+1,j+1,nn)
	 
         avunvec7(1+i+j*nx) = tpic_divun(i+1,j+1,nn)
       enddo
       enddo
       
c
       if(blockid.eq.0)then
       write(10,44) avunvec1(0)
c       write(11,44) avunvec2(0)
c       write(34,44) avunvec3(0)
       write(12,44) avunvec4(0)
*cambio Claudia
c       write(47,44) avunvec5(0)

       write(14,44) avunvec6(0)
c       write(15,44) avunvec7(0)       

       write(10,44)(avunvec1(i)*delw/pi,i=1,nx*ny)
c       write(11,44)(avunvec2(i)*delw/pi,i=1,nx*ny)
c       write(34,44)(avunvec3(i)*delw/pi,i=1,nx*ny)
       write(12,44)(avunvec4(i)*delw/pi,i=1,nx*ny)
*cambio Claudia
c       write(47,44)(avunvec5(i)*delw/pi,i=1,nx*ny)

       write(14,44)(avunvec6(i)*delw/pi,i=1,nx*ny)
c       write(15,44)(avunvec7(i)*delw/pi,i=1,nx*ny)
       
44     format(e12.5)
         do j=1,nsx*nsy-1
c      / block 0  receives and print data from node j */

        call cmrect(j,1,avunvec1,nbytes)
        call cmrect(j,1,avunvec2,nbytes)

        call cmrect(j,1,avunvec4,nbytes)

        call cmrect(j,1,avunvec6,nbytes)
	
        call cmrect(j,1,avunvec7,nbytes)
c     writes in 10, 22, 46 and 48 information received from node j
c
        write(10,44) avunvec1(0)
c        write(11,44) avunvec2(0)
        write(12,44) avunvec4(0)
	write(14,44) avunvec6(0)
c	write(15,44) avunvec6(0)	
	
        write(10,44)(avunvec1(i)*delw/pi,i=1,nx*ny)
c        write(11,44)(avunvec2(i)*delw/pi,i=1,nx*ny)
        write(12,44)(avunvec4(i)*delw/pi,i=1,nx*ny)
        write(14,44)(avunvec6(i)*delw/pi,i=1,nx*ny)
c        write(15,44)(avunvec7(i)*delw/pi,i=1,nx*ny)
          enddo
       else
c
c      /* Current node sends data to node 0 */
c
        call cmsendt(0,1,avunvec1,nbytes)
        call cmsendt(0,1,avunvec2,nbytes)

        call cmsendt(0,1,avunvec4,nbytes)

        call cmsendt(0,1,avunvec6,nbytes)
        call cmsendt(0,1,avunvec7,nbytes)
	
        endif
	enddo


        return
          end

**************************************************************************
       subroutine cmsendxy(b_id,dumb,sendd,size)
csp2--------------------------------------------------------------------
        include 'mpif.h'
        include 'sizes'       
csp2 -------------------------------------------------------------------
       integer b_id,dumb
       complex*16 sendd(0:(mnmax+2)*(mnmax+2))
       integer size
       integer blockid,vblockid,blockty
       common/a1/ncontrol,blockid,vblockid(2),blockty,nsx,nsy
c      TMP - PARALLEL CODE
c       call csend(blockid,sendd,size,b_id,0)
csp2 -------------------------------------------------------
	itag=1
        call MPI_SEND(sendd,size,MPI_DOUBLE_COMPLEX,b_id,
     1                itag,MPI_COMM_WORLD,mpierr)
         if(mpierr .ne. 0)then
           write(6,*)' MPI error !!! (7)'
           stop
         endif     
     
csp2 ------------------------------------------------------------
       return
       end
*********************************************************************
       subroutine cmrecxy(b_id,dumb,recc,size)
csp2----------------------------------------------------------------------
	include 'mpif.h'
        include 'sizes'	
	integer status(MPI_STATUS_SIZE)       
csp2 ---------------------------------------------------------
       integer b_id,dumb
       complex*16 recc(0:(mnmax+2)*(mnmax+2))
       integer size
       integer blockid,vblockid,blockty

       common/a1/ncontrol,blockid,vblockid(2),blockty,nsx,nsy

c      TMP - PARALLEL CODE
c       call crecv(b_id,recc,size)
csp2-----------------------------------------------------------------------
        itag=1
        call MPI_RECV(recc,size,MPI_DOUBLE_COMPLEX,b_id,
     1                itag,MPI_COMM_WORLD,status,mpierr)
     
         if(mpierr .ne. 0)then
           write(6,*)' MPI error !!! (8)'
           stop
         endif     
csp2 -----------------------------------------------------------
       return
       end

**********************************************************************
       subroutine cmsendt(b_id,dumb,tsendd,size)
csp2--------------------------------------------------------------------
        include 'mpif.h'
        include 'sizes' 
csp2 -----------------------------------------------------------
       integer b_id,dumb
       real*8 tsendd(0:(mnmax+2)*(mnmax+2))
       integer size
       integer blockid,vblockid,blockty
       common/a1/ncontrol,blockid,vblockid(2),blockty,nsx,nsy
c      TMP - PARALLEL CODE
c       call csend(blockid,tsendd,size,b_id,0)
csp2 ---------------------------------------------------
        itag=1
        call MPI_SEND(tsendd,size,MPI_DOUBLE_PRECISION,b_id,
     1                itag,MPI_COMM_WORLD,mpierr)
         if(mpierr .ne. 0)then
           write(6,*)' MPI error !!! (9)'
           stop
         endif     
     
csp2 ---------------------------------------------------------
       return
       end
*********************************************************************
       subroutine cmrect(b_id,dumb,trecc,size)
csp2----------------------------------------------------------------------
        include 'mpif.h'
        include 'sizes'
        integer status(MPI_STATUS_SIZE)
csp2 ------------------------------------------------------------------- 
       integer b_id,dumb
       real*8 trecc(0:(mnmax+2)*(mnmax+2))
       integer size
       integer blockid,vblockid,blockty

       common/a1/ncontrol,blockid,vblockid(2),blockty,nsx,nsy

c      TMP - PARALLEL CODE
c       call crecv(b_id,trecc,size)
csp2-----------------------------------------------------------------------
        itag=1
        call MPI_RECV(trecc,size,MPI_DOUBLE_PRECISION,b_id,
     1                itag,MPI_COMM_WORLD,status,mpierr)
         if(mpierr .ne. 0)then
           write(6,*)' MPI error !!! (9)'
           stop
         endif     
     
csp2  --------------------------------------------------------
       return
       end
	      
**********************************************************************

     
       subroutine      readata(freq,key,stime,nx,ny,ngx,ngy,h,ntsnap,
     1              matnum,jsou,ksou,nrec,irx,iry,isourid,irecid,
     1              kdel,nwsnap,maxiter,reduc,nsize,hpx,hpy,
     1              wsnap,tsnap,maxlow,npf,f1,f2,f3,f4,perclow,
     1              xsou,ysou,rx,ry,fq1,fq2,keym,vmin,veloc1,
     1              kf1,kf2,rof1,rof2,muf1,muf2,xks1,xks2,ros1,ros2,
     1              phi1,phi2,perm1,perm2,qsm1,qsm2,qkc1,qkc2,qm1,
     1              qm2,esp1,esp2,nc1,nc2,xkm1,xkm2,xnw1,xnw2,
     1              np1,np2)     
     
     
       include 'sizes'
      implicit double precision (a-h,o-z)

      integer  irecid(mnrec)
      real*8 xnod(mnx+1),ynod(mny+1)
      real*8 rx(mnrec), ry(mnrec)
      integer irx(mnrec), iry(mnrec)
      real*8  wsnap(mwsnap),tsnap(mtsnap)
      integer nrec,keym
      real*8 fq1,fq2

c      real*8  ros,roo,row,muo,muw,xn

      integer blockid,vblockid,blockty,ncontro,nsx,nsy
      common/a1/ncontrol,blockid,vblockid(2),blockty,nsx,nsy
c      double precision sro,srw,amplit,mbeta

      
     

c      common/a2/sro,srw,amplit,mbeta

c
c  global matrix matnum 
c 
c  matnum : integer matrix containing  the material type number at
c            each grid block in the global mesh
c
      dimension matnum(0:mngx+1,0:mngy+1)
      
      real*8 kf1(10),kf2(10),rof1(10),rof2(10),muf1(10),muf2(10)
      real*8 xks1(10),xks2(10),ros1(10),ros2(10),phi1(10),phi2(10)
      real*8 perm1(10),perm2(10),qsm1(10),qsm2(10),qkc1(10),qkc2(10)
      real*8 qm1(10),qm2(10),h
      integer esp1(10),esp2(10)
      real*8 xkm1(10),xkm2(10),xnw1(10),xnw2(10)
      integer nc1,nc2,np1,np2      
      
c
c   end  dimension statements
c
      twopi = 6.28318530717958d0
      pi = twopi*.5d0
c
c  reads   nsx = number of processors ( blocks) in the x-direccion
c
c
c  reads   nsy = number of processors ( blocks) in the y-direccion
c
c  ncontrol = processor number where output is being written
c
c
c  reads   ngx = global grid size in the  x-direccion
c
c
c  reads   ngy = global grid size in the  y-direccion
c

       read(5,170)maxlow
       read(5,150)perclow
       read(5,170)nsx
       read(5,170)nsy
       read(5,170)ncontrol
       read(5,170)ngx
       read(5,170)ngy

c     compute local grid sizes
      nx = ngx/nsx
      ny = ngy/nsy

      if(blockid.eq.ncontrol) then
      write(6,1831) nsx,nsy
1831  format(/1x,'# subdomains  in x-direction nsx = ',i5,/,
     $       1x,'# subdomains  in y-direction nsy = ',i5)
      write(6,2831) ncontrol
2831  format(/1x,'# control subdomain ncontrol = ',i5)

      write(6,3831) ngx,ngy
3831  format(/1x,'global # elements  in x-direction ngx = ',i5,/,
     $       1x, 'global # elements  in y-direction ngy = ',i5)

      write(6,8831) nx,ny
 8831 format(/1x,'local # elements  in x-direction nx = ',i5,/,
     $       1x, 'local # elements  in y-direction ny = ',i5)
      endif

c     compute size of buffer for message passing
      nmax = nx
      if( nmax.lt.ny) nmax = ny
      nsize = (nmax+2)*6

      if(nx.gt.mnx ) stop 77
      if(ny.gt.mny) stop 77
      read(5,150)xsize
      read(5,150) ysize
c  computes  processor grid sizes  hpx, hpy
c

           hpx = xsize/nsx
           hpy = ysize/nsy


      if(blockid.eq.ncontrol) then
 150  format(e20.8)
      write(6,8382) hpx,hpy
 8382 format(/1x,' processor grid size in the x-dir  hpx = ',g20.8,/,
     $       1x, ' processor grid size in the y-dir  hpy  = ',g20.8)

      write(6,1)xsize
 1    format(/1x,' domain size xsize = ',e20.8,' m')
      write(6,22) ysize
 22    format(/1x,' domain size ysize = ',e20.8,' m')
      endif
      if(blockid.eq.ncontrol) then
        write(6,1730)maxlow,perclow
        
1730   format(/1x,'  maxlow (max.iter. in low freq range ) = ',
     1 i6,' perclow ( perc. of(low) freq. solved with maxlow = ', 
     1 e20.8)
          endif 
c
c   chooses minimum h between hx and hy
c
         hx=xsize/ngx
         hy=ysize/ngy
         h = hx
           if(h.gt.hy)h=hy
c
c      rounds xsize , ysize
c
         xsize=ngx*h
         ysize=ngy*h
      if(blockid.eq.ncontrol) then
         write(6,66291)xsize,ysize
66291    format(/1x,' rounded xsize = ',e20.8,' m ; ',/,
     $        ' rounded ysize = ',e20.8,' m '/)
      endif
c
c
c  now when reading domain description we may have problems
c  since xsize and ysize may be smaller.
c   we may have to run twice the code  for this reason.
c the first pass just to know the rounded -to - h  sizes.
c
c
      read(5,170)nwsnap
      if(nwsnap.gt.mwsnap)stop 27453
      read(5,150)(wsnap(i),i=1,nwsnap)
      read(5,170) ntsnap
      if(ntsnap.gt.mtsnap)stop 27454      
      read(5,150) (tsnap(i),i=1,ntsnap)
c      read(5,170)keyqua
      read(5,170)npf
      read(5,170)key
      read(5,150)freq
      read(5,150)stime
      read(5,150)f1
      read(5,150)f2
      read(5,150)f3
      read(5,150)f4
      read(5,170)maxiter
      read(5,150)reduc
      if(nwsnap.gt.mwsnap) stop 5183
      if(ntsnap.gt.mtsnap) stop 6183

      if(blockid.eq.ncontrol) then
      write(6,8833) h
 8833 format(/1x,' mesh size h= ',e20.8,' m')
      write(6,76234)nwsnap
76234 format(/1x,' number of snapshots in freq. domain= ',i5)
      write(6,7746)(i,wsnap(i),i=1,nwsnap)
 7746 format(/1x,' freq. to compute  snapshots in freq.domain',/,
     $     i5,3x,e20.8,' khz')
      write(6,76232)ntsnap
76232 format(/1x,' number of snapshots in time domain= ',i5)
      write(6,7741) (i,tsnap(i),i=1,ntsnap)
 7741 format(/1x,' times to compute  snapshots in time domain',/,
     $     i5,3x,e20.8,' msec')


c       write(6,87365)keyqua
c87365  format(/1x,' quadrature choice=1,standard,=2,mid point',/,
c     1           '  keyqua = ',i5)
      write(6,16234)npf
16234 format(/1x,' number of points to compute solution= ',/,
     1           ' in the frequency domain    npf  = ',i5)

      write(6,100)key
100   format(/1x,'  key==1 for type 1 source (tsang&rader paper) ;',
     $   /1x,'      key==2 for type 2 source(gaussian derivative)
     $      ;',i5,//)


      write(6,1305)freq
1305  format(/1x,'  frequency  freq= ',e20.8,' khz'//)
      write(6,160)stime
160   format(/1x,' total simulation time  stime =  ',e20.8,' msec'/)

         write(6,7752)f1,f2,f3,f4
 7752   format(/1x,'  parameters of  source band-pass filter',//,
     1         ' set equal to 0. if not filter is desired'//,
     1         ' f1  = ',e20.8,'   khz ',//,
     1         ' f2  = ',e20.8,'   khz ',//,
     1         ' f3  = ',e20.8,'   khz ',//,
     1         ' f4  = ',e20.8,'   khz ',//)

           write(6,2190)maxiter
2190     format(/1x,'  maxiter =  max. # inner iterations ',i5)
           write(6,2590)reduc
2590     format(/1x,'  reduc =  relative error required  ',e20.8)

       endif


      read(5,170)nmat
      if(nmat.gt.mnmat) stop 222

      if(blockid.eq.ncontrol) then
c               write(6,7923)
7923   format(/1x,' vector xnod  in readata '//)
c             write(6,34921)(xnod(j),j=1,nx+1)
34921  format(/1x,5e15.5)
c               write(6,1923)
1923   format(/1x,' vector ynod  in readata '//)
c             write(6,34921)(ynod(j),j=1,ny+1)

      write(6,2346)nmat
2346   format(/1x,' number of materials (nmat) = ',i5)
      endif

       read(5,170)kdel

      if(blockid.eq.ncontrol) then
       write(6,9473)kdel
9473   format(/1x,' kdel=0 : delta, kdel = 1:  d/dx(delta). kdel = ',i6)
      endif

c
c  if source is derivative of delta, checks that the source position
c  xsou  does no coincide with a nodal  point  xnod(k)
c
c
c  reads  global physical position of  point source
c
      read(5,150)xsou,ysou
      if(xsou.lt.h) xsou=h
      if(xsou.gt.(xsize-h)) xsou=xsize-h
      if(ysou.lt.h) ysou=h
      if(ysou.gt.(ysize-h)) ysou=ysize-h 
 
      read(5,170)nrec
      if(nrec .gt. mnrec) stop 9920
c
c  gets  local grid corrdinates ( jsou,ksou) for the source
c  and sourceid  with the blockid number where the source
c  is located.
        js = xsou/hpx
         ks = ysou/hpy
          ks = (nsy-1)-ks

c gets blockid where the source is located in isourid
c
        isourid = ks*nsx + js
         souvid1 = mod(isourid,nsx)
          souvid2 = isourid/nsx

c    xsourbl=   souvid1 *hpx = x-coordinate of the block isourid where
c                       the source is located

           xsourbl= souvid1*hpx

c    ysourbl  =   ((nsy-1)-souvid2)*hpy = y-coordinate of the  block where
c                                the source is located

              ysourbl = ((nsy-1)-souvid2)*hpy
           xsloc = xsou-xsourbl
           ysloc = ysou-ysourbl

      jsou=xsloc/h + 1.0d0
      ksou = ysloc/h + 1.0d0

      if(jsou.gt.nx.or.jsou.lt.1) then
      if (blockid.eq.ncontrol)then
       write(6,5693)jsou
5693   format(/1x,' wrong jsou = ',i5)
       endif 
       stop 666
        endif

      if(ksou.gt.ny.or.ksou.lt.1) then
      if (blockid.eq.ncontrol)then
       write(6,5697)ksou
5697   format(/1x,' wrong ksou = ',i5)
       endif 
       stop 666
        endif

      if(blockid.eq.ncontrol) then
      write(6,7725)jsou,ksou,isourid
 7725 format(/1x,' jsou = ',i5,'  ksou = ',i5,' isourid = ',i5)
       write(6,7722)xsou,ysou
 7722 format(/1x,' xsou = ',e20.8,' m ysou = ',e20.8,' m')

      write(6,7624) nrec
 7624 format(/1x,' number of receivers, nrec = ',i5)
       endif
c
c  reads  global physical position of receivers
c
      do 7723 i = 1, nrec
         read(5,150) rx(i)
         read(5,150) ry(i)
       if(rx(i).lt.h) rx(i)=h
       if(rx(i).gt.(xsize-h)) rx(i)=xsize-h
       if(ry(i).lt.h) ry(i)=h
       if(ry(i).gt.(ysize-h)) ry(i)=ysize-h 
c    
c  gets  local grid corrdinates ( jsou,ksou) for the source
c  and sourceid  with the blockid number where the source
c  is located.
        jr = rx(i)/hpx
         kr = ry(i)/hpy
          kr = (nsy-1)-kr

c gets blockid where the receiver is located
c
        irecid(i) = kr*nsx + jr
         recid1 = mod(irecid(i),nsx)
          recid2 = irecid(i)/nsx

c    xrecbl=   recid1 *hpx = x-coordinate of the block irecid(i) where
c                       the actual receiver is located

           xrecbl= recid1*hpx

c   yrecbl =     ((nsy-1)-recid2)*hpy = y-coordinate of the  block irecid(i) where
c                                the actual receiver is located

              yrecbl = ((nsy-1)-recid2)*hpy
           xrloc = rx(i)-xrecbl
           yrloc = ry(i)-yrecbl

      irx(i)=xrloc/h + 1.0d0
      iry(i) = yrloc/h + 1.0d0

      if(blockid.eq.ncontrol) then
         write(6,7727) i, irx(i), iry(i), rx(i), ry(i)
 7727 format(/1x,'receiver i =',i5,3x,'irx & iry = ',2i5,/,15x,
     $     'rx(i) & ry(i) = ', 2g15.8, '  m')
      endif

      if(irx(i).lt.1.or.irx(i).gt.nx+1)then
      if(blockid.eq.ncontrol) then
         write(6,7729) i, irx(i),nx+1
      endif
      stop  88888
      endif

 7729 format(/1x,'receiver i =',i5,3x,'irx(i)  = ',i5,
     $     'nx+1  = ',i5)

             if(iry(i).lt.1.or.iry(i).gt.ny+1)then

      if(blockid.eq.ncontrol) then
         write(6,7750) i, iry(i),ny+1
      endif

 7750 format(/1x,'receiver i =',i5,3x,' iry(i)  = ',i5,
     $     'ny+1  = ',i5)
                stop  88888

                   endif

 7723    continue
c
c      if(blockid.eq.ncontrol) then

c      do 7743 i = 1, 3

c         write(6,7836) kdel, i, irx(i)
c7836      format(/1x,' kdel -  i - irx(i) (receivers) ',3i5)
c7743    continue
c        endif
c               endif
c
c    matnum(i) = material type number for material of type  i
c
c    reads 2-d earth  material description  via  izi,izf,numat
6735   continue
       read(5,150)xi,xf,yi,yf
       read(5,170)numat
170    format(i5)
      if(blockid.eq.ncontrol) then
       write(6,3854)xi,xf,yi,yf,numat
3854   format(1x,' from  xi                     = ',e20.8,' m  ',/
     1           ' up to xf                     = ',e20.8,' m ',/  
     1           ' from  yi                     = ',e20.8,' m  ',/
     1           ' up to yf                     = ',e20.8,' m ',/  
     1           ' material type number  numat  = ',i5/)

          endif

       if(xi.lt.0.)go to 5553
c
c   adjusts xi, xf, yi and yf to indicate the mid point
c   physical  cordinates    of the initial and final grid blocks
c    having  material property  numat
c 
           xi = xi + .5d0*h
           xf = xf - .5d0*h
           
           yi = yi + .5d0*h
           yf = yf - .5d0*h

 
       ixi= xi/h + 1.0d0
       ixf= xf/h + 1.0d0
       iyi= yi/h + 1.0d0
       iyf= yf/h + 1.0d0

      if(blockid.eq.ncontrol) then

       write(6,2673)ixi,ixf,iyi,iyf,numat
2673   format(1x,' from  ixi (x-global grid #)    = ',i5,/
     1           ' up to ixf (x-global grid #)    = ',i5,/  
     1           ' from  iyi (y-global grid #)    = ',i5,/
     1           ' up to yf  (y-global grid #)    = ',i5,/  
     1           ' material type number  numat    = ',i5/)


      endif

        if(ixi.lt.1.or.ixi.gt.ngx)then
        write(6,6629)ixi
6629     format(/1x,' wrong material description  ixi = ',i5)
           stop
            endif

        if(iyi.lt.1.or.iyi.gt.ngy)then
        write(6,6129)iyi
6129     format(/1x,' wrong material description  iyi = ',i5)
           stop
            endif


        if(ixf.lt.1.or.ixf.gt.ngx)then
        write(6,6229)ixf
6229     format(/1x,' wrong material description  ixf = ',i5)
           stop
            endif

        if(iyf.lt.1.or.iyf.gt.ngy)then
        write(6,6669)iyf
6669     format(/1x,' wrong material description  iyf = ',i5)
           stop
            endif

          if(numat.lt.1.or.numat.gt.nmat)then
        write(6,8629)numat
8629     format(/1x,' wrong material number numat  = ',i5)
           stop
            endif

        do 6736 j=ixi,ixf
       do 6736 k=iyi,iyf

       matnum(j,k)=numat
6736   continue

       go to 6735
5553   continue
             do 9836 k=0,ngy+1
               matnum(0,k) = matnum(1,k)
                 matnum(ngx+1,k) = matnum(ngx,k)
9836        continue

             do 9837 j=0,ngx+1
                matnum(j,0) = matnum(j,1)
                    matnum(j,ngy+1) = matnum(j,ngy)

9837        continue

                   iii=1
                       if(iii.eq.2) then

c
c starts printing  material type number for each element (j,k)
c
       write(6,4347)
4347   format(//1x,' material information  for each  element'//)
c
c  loop  over the elements
c
       do 3429 j=1,nx
       do 3429 k=1,ny

       write(6,776)
776    format(/1x,'element    material type number'/)

       write(6,4537)j,k,matnum(j,k)
4537   format(/1x,i2,2x,i2,10x,i5)


3429   continue

                  endif

c Aqui comienzo con los parametros de las distintas capas
c       read(5,*) 

 
       read(5,170)nc1
       read(5,170)np1
       
          if(blockid.eq.ncontrol) then
	  write(6,*)	   
	  write(6,*)' controls read data from blockid = ',blockid
	  write(6,*)
	  write(6,*)' data for REGION 2 '
	  write(6,*)      
          write(6,*)' nc1 ',nc1
          write(6,*)' np1 ',np1
	  write(6,*)
	  write(6,*)            	  
          endif
       
       do i=1,nc1
       read(5,170)esp1(i)
       read(5,150)kf1(i)
       read(5,150)rof1(i)
       read(5,150)muf1(i)
       read(5,150)xks1(i)
       read(5,150)ros1(i)
       read(5,150)phi1(i)
       read(5,150)perm1(i)
       read(5,150)xkm1(i)
       read(5,150)xnw1(i)
       read(5,150)qsm1(i)
       read(5,150)qkc1(i)
       read(5,150)qm1(i)
c control de lectura
           if(blockid.eq.ncontrol) then
	 write(6,*)' i ',i 
         write(6,*)'esp1(i)  ',esp1(i) 
         write(6,*)' kf1(i)  ',kf1(i)
         write(6,*)'rof1(i)  ',rof1(i)
         write(6,*)'muf1(i)  ',muf1(i)
         write(6,*)'xks1(i)  ',xks1(i)
         write(6,*)'ros1(i)  ',ros1(i)
         write(6,*)'phi1(i)  ',phi1(i)
         write(6,*)'perm1(i) ',perm1(i)
         write(6,*)'xkm1(i)  ',xkm1(i)
         write(6,*)'xnw1(i)  ',xnw1(i)
         write(6,*)'qsm1(i)  ',qsm1(i)
         write(6,*)'qkc1(i)  ',qkc1(i)
         write(6,*)'qm1(i)   ',qm1(i)
	    endif      
            
* changes units of bulk modulus from GPa to gr-m-ms 1 GPa = 10^10 dyn/cm^2 = 10*6 gr/(m (ms)^2)

       
       kf1(i)  = kf1(i)*1.d+6 
       xks1(i) = xks1(i)*1.d+6
       xnw1(i) = xnw1(i)*1.d+6 
       xkm1(i) = xkm1(i)*1.d+6
* changes unit of mass from gr/cm^3   to gr/m^3   gr/cm^3 = 10^6 gr/m^3 

       rof1(i) = rof1(i)* 1.d+6
       ros1(i) = ros1(i)* 1.d+6
       
* changes units of viscosity from Poise to gr/(m ms) 
*  1 Poise = gr/(cm s) =10^{-1} gr/(m ms)       
       muf1(i) = muf1(i) * 1.d-1 
* changes units of permeability from cm^2  to m^2  

       perm1(i) = perm1(i) * 1.d-4
            
       enddo    
c       read(5,*)
       read(5,170)nc2
       read(5,170)np2
       
          if(blockid.eq.ncontrol) then 
	  write(6,*)	  	 
          write(6,*)' controls read data from blockid = ',blockid
	  write(6,*)
	  write(6,*)' data for REGION 1 '        
       write(6,*)'nc2 ',nc2
       write(6,*)'np2 ' ,np2
       write(6,*)
          endif
	  
        do i=1,nc2
       read(5,170)esp2(i)
       read(5,*)kf2(i)
       read(5,150)rof2(i)
       read(5,150)muf2(i)
       read(5,150)xks2(i)
       read(5,150)ros2(i)
       read(5,150)phi2(i)
       read(5,150)perm2(i)
       read(5,150)xkm2(i)
       read(5,150)xnw2(i)
       read(5,150)qsm2(i)
       read(5,150)qkc2(i)
       read(5,150)qm2(i)

c control de lectura
           if(blockid.eq.ncontrol) then	
	 write(6,*)
	 write(6,*)' i ',i 
         write(6,*)'esp2(i)  ',esp2(i) 
         write(6,*)' kf2(i)  ',kf2(i)
         write(6,*)'rof2(i)  ',rof2(i)
         write(6,*)'muf2(i)  ',muf2(i)
         write(6,*)'xks2(i)  ',xks2(i)
         write(6,*)'ros2(i)  ',ros2(i)
         write(6,*)'phi2(i)  ',phi2(i)
         write(6,*)'perm2(i) ',perm2(i)
         write(6,*)'xkm2(i)  ',xkm2(i)
         write(6,*)'xnw2(i)  ',xnw2(i)
         write(6,*)'qsm2(i)  ',qsm2(i)
         write(6,*)'qkc2(i)  ',qkc2(i)
         write(6,*)'qm2(i)   ',qm2(i)
	 write(6,*)
	    endif      


* changes units of bulk modulus from GPa to gr-m-ms 1 GPa = 10^10 dyn/cm^2 = 10*6 gr/(m (ms)^2)

       
       kf2(i)  = kf2(i)*1.d+6 
       xks2(i) = xks2(i)*1.d+6
       xnw2(i) = xnw2(i)*1.d+6 
       xkm2(i) = xkm2(i)*1.d+6
* changes unit of mass from gr/cm^3   to gr/m^3   gr/cm^3 = 10^6 gr/m^3 

       rof2(i) = rof2(i)* 1.d+6
       ros2(i) = ros2(i)* 1.d+6
       
* changes units of viscosity from Poise to gr/(m ms) 
*  1 Poise = gr/(cm s) =10^{-1} gr/(m ms)       
       muf2(i) = muf2(i) * 1.d-1 
* changes units of permeability from cm^2  to m^2  

       perm2(i) = perm2(i) * 1.d-4       
       
       enddo 

       read(5,2)fq1
       read(5,2)fq2
       read(5,3)keym
       read(5,2)vmin
       read(5,2)veloc1
 
         if(blockid.eq.ncontrol) then
	  write(6,*)	 	  	 
          write(6,*)' controls read data from blockid = ',blockid
	  write(6,*)
	  write(6,*)'fq1    ',fq1
	  write(6,*)'fq2    ',fq2
          write(6,*)'keym   ',keym
          write(6,*)'vmin   ',vmin
          write(6,*)'veloc1 ', veloc1
	 endif 	  
	 

2      format(g20.10)
3      format(i5)

                    return
                          end	      
***********************************************************************
      subroutine init(u1ln,u1tn,u1bn,u1rn,u2ln,u2tn,u2bn,u2rn, 
     1               unln,untn,unbn,unrn, 
     1               lag1ln,lag1tn,lag1bn,lag1rn,lag2ln,lag2tn, 
     1               lag2bn,lag2rn,lagnln,lagntn,lagnbn,lagnrn, 
     1               tpic2,tpic_curls,tpicny,nx,ny,ntsnap,
     1               tpic_divus,tpic_divun)
     
     
     
       include 'sizes'
      implicit double precision (a-h,o-z)
      complex*16 u1ln(0:mnx+1,0:mny+1),u1tn(0:mnx+1,0:mny+1),
     1           u1bn(0:mnx+1,0:mny+1)
      complex*16 u1rn(0:mnx+1,0:mny+1)
      complex*16 u2ln(0:mnx+1,0:mny+1),u2tn(0:mnx+1,0:mny+1),
     1           u2bn(0:mnx+1,0:mny+1)
      complex*16 u2rn(0:mnx+1,0:mny+1)

      complex*16 unln(0:mnx+1,0:mny+1),untn(0:mnx+1,0:mny+1),
     1           unbn(0:mnx+1,0:mny+1)
      complex*16 unrn(0:mnx+1,0:mny+1)
      

           
      complex*16 lag1ln(0:mnx+1,0:mny+1),lag1tn(0:mnx+1,0:mny+1),
     1           lag1bn(0:mnx+1,0:mny+1),lag1rn(0:mnx+1,0:mny+1)

      complex*16 lag2ln(0:mnx+1,0:mny+1),lag2tn(0:mnx+1,0:mny+1),
     1           lag2bn(0:mnx+1,0:mny+1),lag2rn(0:mnx+1,0:mny+1)

      complex*16 lagnln(0:mnx+1,0:mny+1),lagntn(0:mnx+1,0:mny+1),
     1           lagnbn(0:mnx+1,0:mny+1),lagnrn(0:mnx+1,0:mny+1)


               
      real*8 tpic_divus(mnx,mny,mtsnap),tpic_divun(mnx,mny,mtsnap)    
 
       real*8 tpic2(mnx,mny,mtsnap),tpic_curls(mnx,mny,mtsnap)
       real*8 tpicny(mnx,mny,mtsnap)    
     
     
              do   j=0,nx+1
               do    k=0,ny+1
            u1ln(j,k) = dcmplx(0.d0,0.d0)
            u1tn(j,k) = dcmplx(0.d0,0.d0)
            u1bn(j,k) = dcmplx(0.d0,0.d0)
            u1rn(j,k) = dcmplx(0.d0,0.d0)

            u2ln(j,k) = dcmplx(0.d0,0.d0)
            u2tn(j,k) = dcmplx(0.d0,0.d0)
            u2bn(j,k) = dcmplx(0.d0,0.d0)
            u2rn(j,k) = dcmplx(0.d0,0.d0)

            unln(j,k) = dcmplx(0.d0,0.d0)
            untn(j,k) = dcmplx(0.d0,0.d0)
            unbn(j,k) = dcmplx(0.d0,0.d0)
            unrn(j,k) = dcmplx(0.d0,0.d0)



          

            lag1ln(j,k) = dcmplx(0.d0,0.d0)
            lag1tn(j,k) = dcmplx(0.d0,0.d0)
            lag1bn(j,k) = dcmplx(0.d0,0.d0)
            lag1rn(j,k) = dcmplx(0.d0,0.d0)

            lag2ln(j,k) = dcmplx(0.d0,0.d0)
            lag2tn(j,k) = dcmplx(0.d0,0.d0)
            lag2bn(j,k) = dcmplx(0.d0,0.d0)
            lag2rn(j,k) = dcmplx(0.d0,0.d0)

            lagnln(j,k) = dcmplx(0.d0,0.d0)
            lagntn(j,k) = dcmplx(0.d0,0.d0)
            lagnbn(j,k) = dcmplx(0.d0,0.d0)
            lagnrn(j,k) = dcmplx(0.d0,0.d0)


	               
              enddo
	     enddo 

              do j=1,nx
	       do k=1,ny
	         do n=1,ntsnap
		 tpic2(j,k,n)=0.d0
		 tpic_curls(j,k,n)=0.d0		 
		 tpicny(j,k,n)=0.d0
                 tpic_divus(j,k,n)=0.d0
                  tpic_divun(j,k,n)=0.d0
		 enddo
	      enddo
	     enddo 	 		  
	       	  
                return 
              end
	      
**********************************************************************
       subroutine subtype
       include 'sizes'
      implicit double precision (a-h,o-z)
      integer blockid,vblockid,blockty,ncontrol,nsx,nsy
      common/a1/ncontrol,blockid,vblockid(2),blockty,nsx,nsy

       if(vblockid(1).eq.0.and.vblockid(2).eq.0)then
               blockty=0

        elseif(vblockid(1).eq.nsx-1.and.vblockid(2).eq.0)then
               blockty=2

        elseif(vblockid(1).eq.nsx-1.and.vblockid(2).eq.nsy-1)then
               blockty=8

        elseif(vblockid(1).eq.0.and.vblockid(2).eq.nsy-1)then
               blockty=6

        elseif(vblockid(2).eq.0)then
               blockty=1

        elseif(vblockid(1).eq.nsx-1)then
               blockty=5

        elseif(vblockid(2).eq.nsy-1)then
               blockty=7

        elseif(vblockid(1).eq.0)then
               blockty=3

        else
                blockty= 4
        endif

c       TMP - SERIAL CODE
c        blockty= 9

            return
                end
*******************************************************************
       subroutine setdelta(nx,ny,deltal,deltar,deltat,deltab)
       include 'sizes'
       implicit double precision (a-h,o-z)

       real*8  deltal(mnx),deltar(mnx),deltat(mny),deltab(mny)
       integer nx,ny
       integer blockid,vblockid,blockty,ncontrol,nsx,nsy
       common/a1/ncontrol,blockid,vblockid(2),blockty,nsx,nsy
       integer j

           do 232 j=1,nx
             deltal(j)=0.d0
             deltar(j)=0.d0
232     continue

           do 233 j=1,ny
             deltab(j)=0.d0
             deltat(j)=0.d0
233     continue

      if(blockty.eq.0) then
                 deltal(1) =1.d0
                 deltar(nx) =0.d0
                 deltab(1) =0.d0
                 deltat(ny) =1.d0
      elseif(blockty.eq.1) then
                 deltal(1) =0.d0
                 deltar(nx) =0.d0
                 deltab(1) =0.d0
                 deltat(ny) =1.d0
      elseif(blockty.eq.2) then
                 deltal(1) =0.d0
                 deltar(nx) =1.d0
                 deltab(1) =0.d0
                 deltat(ny) =1.d0
      elseif(blockty.eq.3) then
                 deltal(1) =1.d0
                 deltar(nx) =0.d0
                 deltab(1) =0.d0
                 deltat(ny) =0.d0
      elseif(blockty.eq.4) then
                 deltal(1) =0.d0
                 deltar(nx) =0.d0
                 deltab(1) =0.d0
                 deltat(ny) =0.d0
      elseif(blockty.eq.5) then
                 deltal(1) =0.d0
                 deltar(nx) =1.d0
                 deltab(1) =0.d0
                 deltat(ny) =0.d0
      elseif(blockty.eq.6) then
                 deltal(1) =1.d0
                 deltar(nx) =0.d0
                 deltab(1) =1.d0
                 deltat(ny) =0.d0
      elseif(blockty.eq.7) then
                 deltal(1) =0.d0
                 deltar(nx) =0.d0
                 deltab(1) =1.d0
                 deltat(ny) =0.d0
      else
                 deltal(1) =0.d0
                 deltar(nx) =1.d0
                 deltab(1) =1.d0
                 deltat(ny) =0.d0

      endif

      if(blockty.eq.9) then
                 deltal(1) =1.d0
                 deltar(nx) =1.d0
                 deltab(1) =1.d0
                 deltat(ny) =1.d0
      endif

        return
        end
***************************************************************************************************************
   
      subroutine get_local_coef(kf,rhof,muf,xks,ros,fi,kperm,qsm,         
     1                     qkc,qm,xkm_m,struc,nx,ny,
     1                     h,hpx,hpy,ngx,ngy,shear_mod_el)     
     
         
       include 'sizes'
      
* local data matrices
      
      real*8 kf(0:mnx+1,0:mny+1),rhof(0:mnx+1,0:mny+1)
      real*8 muf(0:mnx+1,0:mny+1),xks(0:mnx+1,0:mny+1)
      real*8 ros(0:mnx+1,0:mny+1)
      real*8 fi(0:mnx+1,0:mny+1),kperm(0:mnx+1,0:mny+1)
      real*8 qsm(0:mnx+1,0:mny+1),qkc(0:mnx+1,0:mny+1)
      real*8 qm(0:mnx+1,0:mny+1),xkm_m(0:mnx+1,0:mny+1)
      real*8 struc(0:mnx+1,0:mny+1)
      real*8 shear_mod_el(0:mnx+1,0:mny+1)      
c      complex*16 xnw_m(0:mnx+1,0:mny+1)
      
* global data matrices
      
      real*8 kf_g(0:mngx+1,0:mngy+1),rhof_g(0:mngx+1,0:mngy+1)
      real*8 muf_g(0:mngx+1,0:mngy+1),xks_g(0:mngx+1,0:mngy+1)
      real*8 ros_g(0:mngx+1,0:mngy+1)
      real*8 fi_g(0:mngx+1,0:mngy+1),kperm_g(0:mngx+1,0:mngy+1)
      real*8 qsm_g(0:mngx+1,0:mngy+1),qkc_g(0:mngx+1,0:mngy+1)
      real*8 qm_g(0:mngx+1,0:mngy+1),xkm_m_g(0:mngx+1,0:mngy+1)
      real*8 struc_g(0:mngx+1,0:mngy+1)
      real*8 shear_mod_el_g(0:mngx+1,0:mngy+1)      
c      complex*16 xnw_m_g(0:mngx+1,0:mngy+1)
            
      integer nx,ny,ngx,ngy
      real*8 h,hpx,hpy
      
      real*8 aaa,bbb,posx,posy,auxx,auxy
      integer j,k,indgeox,indgeoy

      integer blockid,vblockid,blockty,ncontrol,nsx,nsy     
      common/a1/ncontrol,blockid,vblockid(2),blockty,nsx,nsy 
           
c global data coef. files (all processors read the  global data)
      
       open(unit=86,  file='kf_g.dat',    status='old')
       open(unit=87,  file='rof_g.dat',   status='old')       
       open(unit=88,  file='muf_g.dat',   status='old')
       open(unit=89,  file='xks_g.dat',   status='old')
       open(unit=90,  file='ros_g.dat',   status='old')       
       open(unit=91,  file='fi_g.dat',    status='old')
       open(unit=92,  file='kperm_g.dat', status='old')
       open(unit=93,  file='qsm_g.dat',   status='old')       
       open(unit=94,  file='qkc_g.dat',   status='old')       
       open(unit=95,  file='qm_g.dat',    status='old')
       open(unit=96,  file='xkm_g.dat',   status='old')
       open(unit=97,  file='shear_mod_el_g.dat',status='old')
       open(unit=98,  file='struc_g.dat', status='old') 


c German:  todos los procesadores leen los datos de coeficientes globales, 
c  luego c/u saca  de alli lo que le corresponde (local properties)
c 
           do k=0,ngy+1	 
          do j=0,ngx+1

          read(86,99)kf_g(j,k)
          read(87,99)rhof_g(j,k)	  
          read(88,99)muf_g(j,k)
          read(89,99)xks_g(j,k)
          read(90,99)ros_g(j,k)
          read(91,99)fi_g(j,k)	  
          read(92,99)kperm_g(j,k)
          read(93,99)qsm_g(j,k)	  
          read(94,99)qkc_g(j,k)
          read(95,99)qm_g(j,k)	  
          read(96,99)xkm_m_g(j,k)
          read(97,99)shear_mod_el_g(j,k)	  	  
          read(98,99)struc_g(j,k)		  		  
 
	  enddo
    	  enddo 
* starts assigning local coef. from global coefficients. This is a parallel
c  stuff  that also works for a serial code if blokid etc are set as in this
c  code
c
c   loop over the local grid  to obtain material properties for
c  the current  processor ( block)
c
       do k=0,ny+1
         do j=0,nx+1
c
c  computes global position  coordinate in the  x-direction in posx variable  
c
          posx = vblockid(1)*hpx + (j-1)*h +.5d0*h
c
c  computes global position  coordinate in the  y-direction in posy variable 
c
          posy = ((nsy-1)-vblockid(2))*hpy+ (k-1)*h + 0.5d0*h
c
	  auxx = posx/h +1.d0
          auxy = posy/h +1.d0
c
	  indgeox = auxx
          indgeoy = auxy
	  
          kf(j,k)    = kf_g(indgeox,indgeoy)
	  rhof(j,k)  = rhof_g(indgeox,indgeoy)
	  muf(j,k)   = muf_g(indgeox,indgeoy)	  
	  xks(j,k)   = xks_g(indgeox,indgeoy)
	  ros(j,k)   = ros_g(indgeox,indgeoy)
	  fi(j,k)    = fi_g(indgeox,indgeoy)	  
          kperm(j,k) = kperm_g(indgeox,indgeoy)
	  qsm(j,k)   = qsm_g(indgeox,indgeoy)
	  qkc(j,k)   = qkc_g(indgeox,indgeoy)
	  qm(j,k)    = qm_g(indgeox,indgeoy)
	  xkm_m(j,k) = xkm_m_g(indgeox,indgeoy)
	  shear_mod_el(j,k) = shear_mod_el_g(indgeox,indgeoy)
	  struc(j,k) = struc_g(indgeox,indgeoy)
       enddo 
         enddo

c Cambio Claudia (para 4 procesadores (nsx=nsy=2) y ngx=ngy=8) 
c escribe lo que cada procesador tiene como datos locales de  kf 
c
c           if(blockid.eq.0) then
c           write(20,*)'in get_local kf in blockid=',blockid
c           do k=ny+1,0,-1
c	   write(20,990)(kf(j,k),j=0,nx+1)     
c             enddo             	   
c              endif

c           if(blockid.eq.1) then
c           write(21,*)'in get_local kf in blockid=',blockid
c           do k=ny+1,0,-1	  
c	   write(21,990)(kf(j,k),j=0,nx+1)	     
c              enddo		   
c              endif

c           if(blockid.eq.2) then
c           write(22,*)'in get_local kf in blockid=',blockid
c           do k=ny+1,0,-1 
c	   write(22,990)(kf(j,k),j=0,nx+1)	     
c               enddo		   
c              endif

c           if(blockid.eq.3) then
c           write(23,*)'in get_local kf in blockid=',blockid
c           do k=ny+1,0,-1          
c	   write(23,990)(kf(j,k),j=0,nx+1)		     
c             enddo		   
c              endif

c990    format(6e20.10)


99        format(e12.5)
	          
      return
      end
********************************************************************

     
  
      subroutine  stabil(veloc1,vmin,h,stime,dt,nt,ntsnap,nwsnap,
     1                 delf,delw,itsnap,iwsnap,wsnap,tsnap,npf,
     1                 f1,f2,f3,f4,if1,if2,if3,if4,jw1,jw2,
     1                  jwlow,perclow,freq)
          
       include 'sizes'
      implicit double precision (a-h,o-z)
      real*8 secfac,dt,h,veloc1,vmin,stime

      real*8 f1,f2,f3,f4,perclow,freq
      
      real*8  wsnap(mwsnap),tsnap(mtsnap)
      integer  itsnap(mtsnap),iwsnap(mwsnap)
      integer nt,ntsnap,nwsnap,npf,if1,if2,if3,if4
      integer jw1,jw2,jwlow
      
      integer blockid,vblockid,blockty,ncontrol,nsx,nsy
      common/a1/ncontrol,blockid,vblockid(2),blockty,nsx,nsy

* local variables
      
      real*8 fnpf,fny,delf,delw,wavel1_f0,wavel2_f0,fjw2,fmax
      real*8 aliasing
      integer i,npw1_f0,npw2_f0,npw1_fmax,npw2_fmax
     
      pi=dabs(4.d0*datan(1.d0))
      twopi = 2.d0*pi
 
c     computes dt using  cfl stability
c
      secfac = 1.d0
       dt = ( h/veloc1) * secfac

c
c     computes number of time steps in n
c
      nt = stime/dt
c
       fny =  1.d0/(2.d0*dt)
c
c       if(f4.gt.fny) f4=fny
c
       fnpf=npf
       delf=f4/fnpf
       delw = twopi*delf

      if(blockid.eq.ncontrol) then
       write(6,1000)fny
1000   format(/1x,' nyquist frequency = ',e20.8,' khz')
c
c   be careful , delete later
c
c       if(f4.gt.fny)f4=fny
c
c     computes delf in khz using npf and the cut frequency f4
c
      write(6,1010) delf,delw
1010   format(/1x,' delf = ',e20.8,'  khz'//,
     $           ' delw = ',e20.8,'  2 pi*khz',//)
c
c       computes indices related to band-pass filters
c
       endif

       if1= f1/delf+1
       if2= f2/delf+1
       if3= f3/delf+1
       if4= f4/delf+1
       if(if4.eq.1)then
       f4=fny
       f3=.9d0*fny
       if3=f3/delf+1
       if4=f4/delf+1
       endif
       if(if3.eq.if4)if3=if4-1
c
c     computes starting index  for frequencies according we compute
c    for w= .5*delw,1.5*delw etc
c   jw1 = 1 ,index for zero frequency,jw1=2 index for delw and so on
c
       
       
       jw1=1
       
c
c    computes jw2 = last index for frequencies
c     the source fourier transform is zero for  jw.ge.if4
c    after filtering with the low-pass filter
c
      jw2=if4-1
         calcw = perclow * jw2
          jwlow = calcw

      if(blockid.eq.ncontrol) then
       write(6,6389)if1,if2,if3,if4
 6389  format(/1x,' if1 if2 if3 if4 =',4i6)
         write(6,8724)jw1,jw2,jwlow
 8724    format(/1x,'jw1 - jw2 - jwlow ',3i7)
      endif

          if(jw2.gt.mlsour) stop 33377
c
c
 150  format(e20.8)

      if(blockid.eq.ncontrol) then
      write(6,210)dt
210   format(/1x,' time step  dt = ',e20.8,' msec'//)
      write(6,200)nt
200   format(/1x,' number of time steps  nt = ',i6//)
      endif
      if(nt.gt.ntstep) stop 999



c
c   computes indices iwsnap() related to snapshots in
c   the space- frequency domain
c
      do 4488 i=1,nwsnap
         iwsnap(i)= wsnap(i)/delf + 1.
 4488 continue
c
c   computes indices itsnap()  related to snapshots
c   in the space-time domain
c
      do 4482 i=1,ntsnap
         itsnap(i)= tsnap(i)/dt
 4482 continue

      if(blockid.eq.ncontrol) then
      write(6,66554)(i,iwsnap(i),i=1,nwsnap)
66554 format(/1x,' freq. indices for snapshots ',/,i5,2x,i5)
      write(6,66154)(i,itsnap(i),i=1,ntsnap)
66154 format(/1x,' time steps for snapshots ',/,i5,2x,i5)
      endif
      
c
       wavel1_f0= veloc1/freq
       wavel2_f0= vmin/freq
       
       npw1_f0 = wavel1_f0/h
       npw2_f0 = wavel2_f0/h
        
       fjw2 = jw2
       fjw2 = fjw2-1.d0
       fjw2=fjw2+0.5d0
       fmax = fjw2*delf 
       
           if(blockid.eq.ncontrol) then  
           
       write(6,55)jw2,fjw2,delf,fmax
55     format(/1x,' jw2-fjw2-delf -fmax',i5,3g15.5)       
           endif
	      
       wavel1_fmax= veloc1/fmax
       wavel2_fmax= vmin/fmax
       
       npw1_fmax = wavel1_fmax/h
       npw2_fmax = wavel2_fmax/h 
        
       aliasing= vmin/(2.d0*fmax)       
                  
      if(blockid.eq.ncontrol) then      
       write(6,12)wavel1_f0,freq
12     format(/1x,' wavelenght for p1-waves= ',g15.5,' meters ',
     1        ' at  central frequency ', g15.5,' khz '/)       
       write(6,85)npw1_f0
85     format(/1x,' number of mesh points per wavelength', 
     1        ' for p1 waves =',i5/)

       write(6,120)wavel2_f0,freq
120   format(/1x,' wavelenght for slowest wave p3 = ',g15.5,' meters ',
     1        ' at  central frequency ', g15.5,' khz '/)       
       write(6,85)npw2_f0
850     format(/1x,' number of mesh points per wavelength =',
     1  ' for p3 waves = ',i5)


      
       write(6,121)wavel1_fmax,fmax
121     format(/1x,' wavelenght for p1-waves= ',g15.5,' meters ',
     1        ' at  maximum  frequency ', g15.5,' khz '/)       
       write(6,851)npw1_fmax
851     format(/1x,' number of mesh points per wavelength',
     1   ' for  p1 waves = ',i5/)

       write(6,122)wavel2_fmax,fmax
122   format(/1x,' wavelenght for slowest wave p3 = ',g15.5,' meters ',
     1        ' at  maximum  frequency ', g15.5,' khz '/)       
       write(6,852)npw2_fmax
852     format(/1x,' number of mesh points per wavelength',
     1  ' for p3 waves = ',i5/)



       write(6,47)vmin,veloc1,fmax,aliasing,h
47     format(/1x,' vmin = ',g15.5,' m/msec = km/sec',/
     1         ' vmax = ',g15.5,' m/msec',/
     1        ' max freq fmax = ', g15.5,' khz'//,' aliasing = ',g15.5,
     2        ' meters , mesh size  h = ',g15.5) 
     
       if(h.gt.aliasing)then
       write(6,853)
853    format(/1x,' non-aliasing condition h < vmin/(2*fmax) ',
     1  ' is not satisfied')
c          stop 44
       endif             
	

      endif
       
              return
              end
*****************************************************************
      subroutine calsource(freq,key,nt,delw,delf,jw2,if3,if4,
     1                     fsour,dt)
       include 'sizes'
      implicit double precision (a-h,o-z)
      dimension  source(ntstep)
      complex*16 x(mlsour),fsour(mlsour)
      integer blockid,vblockid,blockty,ncontrol,nsx,nsy
      common/a1/ncontrol,blockid,vblockid(2),blockty,nsx,nsy

      pi=dabs(4.d0*datan(1.d0))
      twopi = 2.d0*pi
c
c     now computes time shape of pulse in  source(n)
c     according to  key (type of source)
      if(key.eq.2)then
c
c   gaussian derivative source
c
      w0 = twopi*freq
      alfaf= .79d0 * w0/pi
      psi=8.d0*freq**2
      width=.5d0/freq
      ts=2.5d0*width
      totpul=3.0d0*ts
      lpulse=totpul/dt+1.0001d0
      
           if(blockid.eq.ncontrol) then
	   
      write(6,1405)w0,alfaf
1405   format(/1x,' w0 = ',e20.8,'  alfaf = ',e20.8,//)
      write(6,378)lpulse
       if(lpulse.gt.ntstep)stop 12345
      write(6,107)psi,width
      write(6,117)ts,totpul
      write(6,378)nt
 107  format(/1x,'psi=',e20.8,'width=',e20.8,'msec')
 117  format(/1x,'ts=',e20.8,'msec. totpul=',e20.8,'msec')
 378  format(/1x,' pulse length in samples',i8)
 
           endif
      if(nt.lt.lpulse)nt=lpulse
      do 2000 n=1,nt
      tt=(n-1)*dt
      aux=psi*(tt-ts)**2
      source(n)=-2.d0*psi*(tt-ts)*exp(-aux)
 2000 continue
        endif
c
        if(key .eq. 1) then
c
c      source in tsang&rader paper
c
      do 240 n=1,nt
      tt=(n-1)*dt
      source(n) = 4.d0*alfaf*tt * exp(-alfaf*tt)*dsin(w0*tt)
240   continue
            endif

        if(key .eq. 3) then
c
c    bymodal source like the one in tsang& rader  with    w1 = 2 * w0
c
         w1 = 2.d0*w0

      do 2431 n=1,nt
      tt=(n-1)*dt
      source(n) = 4.d0*alfaf*tt * exp(-alfaf*tt)*
     1            (dsin(w0*tt) + dsin(w1*tt) )
2431   continue
            endif
	    
c    ricker wavelet as given by  carcione
	    
	 if(key.eq.4)then
       fjw2 = jw2
       fjw2 = fjw2-1.d0
       fjw2=fjw2+0.5d0
       fmax = fjw2*delf 	    
c efhz: cut-off frequency , twice the central (input) 
*       efhz=0.8e+6

        efhz=fmax
	
c wavelt: wavelet array (output)
c nwavlt: number of samples (output)
c dt: time step (input)
c-------------------------------------------------------
c       subroutine wave(wavelt,nwavlt,efhz,dt)
c       dimension wavelt(1)
c       pi=3.14159265
c       pi2=2.*pi
       agauss=0.5d0*efhz
       tcut=1.5d0/agauss
       nwavlt=tcut*2.d0/dt
       nw=nwavlt/2
       write(6,*)'number of samples nwavlt =',nwavlt
       
       do  i=1,nwavlt
       s=(-nw+i-1)*dt*agauss
c       wavelt(i)=exp(-2.*s*s)*cos(pi2*s)
       source(i)= dexp(-2.d0*s*s)*dcos(twopi*s)
       enddo
            if(nwavlt.lt.nt)then
       do i=nwavlt+1,nt
       source(i)=0.d0
       enddo
            endif
       
       endif	    
	    

     
c
c       forces the max value of the source to be one
c
        xmax = 0.d0
        do 5589 n=1,nt
        if(dabs(source(n)).gt.xmax) xmax = dabs(source(n))
5589    continue

        do 5590 n=1,nt
        source(n) = source(n)/xmax
         if(dabs(source(n)).lt.1.e-14) source(n) = 0.d0
5590    continue
c
c     writes in 1 source time shape before filtering
c
c       write(1,270)((n-1)*dt,source(n),n=1,nt)
270   format(2e20.8)

c
c     computes amplitude and phase of the periodic source
c
      
      
      call ffu2(source,nt,x,jw2,dt,delw)
      

c
c     writes amplitude  spectrum in  2
c
      
       
c       write(2,270)((n-1)*delf+.5d0*delf,dsqrt( dreal(x(n))**2
c     1              + dimag(x(n))**2),n=1,jw2)
      
***
***     low-pass filter for the source
***
      if(if3.ne.1)then
       do 75757 jw=if3,if4
       fif3=if3
       fif4=if4
       fjw=jw
       fact=(fif4-fjw)/(fif4-fif3)
       x(jw) = x(jw) * fact
75757  continue
       endif
c
c     compute new amplitude spectrum of the source after filtering
c
      
           if(blockid.eq.ncontrol) then 
           
      write(4,270)((n-1)*delf+.5d0*delf,dsqrt( dreal(x(n))**2
     1              + dimag(x(n))**2),n=1,jw2)
          endif
     


      
c
c    stores filtered source fourier transform  in fsour
c
      do 44887  n=1,jw2
44887 fsour(n) = x(n)

c
c      computes  inverse fourier transform
c      to obtain the  filtered source in  the time domain
c
         
         call finvu2(x,jw2,source,nt,dt,delw)
         
c
c      writes in 3   filtered source in time domain
c
      if(blockid.eq.ncontrol) then
        write(3,270)((n-1)*dt,source(n),n=1,nt)
      endif	
c    reads 2-d earth  material description  via  izi,izf,numat

             return
             end
**********************************************************************
      subroutine ffu2(u,nt,fu,nw,dt,delw)
      
      implicit double precision (a-h,o-z)
       include 'sizes'

      dimension u(ntstep)
      complex*16  fu(mlsour)
      do  3 jw = 1,nw
      fjw = jw
      fjw = fjw-1.d0
      fjw = fjw + .5d0
      fu(jw) = dcmplx(0.d0,0.d0)
      do 4  jt = 1,nt
      fjt = jt
      fjt = fjt - 1.d0
      v = fjw*delw* fjt*dt
      v=-v
      fu(jw) = fu(jw) + u(jt) * dcmplx(dcos(v),dsin(v))
 4    continue
      fu(jw)=fu(jw)*dt
 10   format(2e20.8)
 3    continue
      return
      end

**************************************************************************

      subroutine finvu2(fu,nw,u,nt,dt,delw)
       include 'sizes'
      implicit double precision (a-h,o-z)
      dimension u(ntstep)
      complex*16  fu(mlsour)
      twopi=6.28318530717950d0
      pi=.5d0*twopi
      do  13  jt = 1,nt
      fjt=jt
      fjt = fjt - 1.d0
      u(jt) = 0.d0
      do 14 jw=1,nw
      fjw=jw
      fjw = fjw -1.d0
      fjw = fjw + .5d0
      v = fjw * delw * fjt * dt
      u(jt) = u(jt) +dreal( fu(jw) * dcmplx(dcos(v),dsin(v)) )
14    continue
      u(jt)=u(jt)*delw/pi
10    format(2e20.8)
13    continue
      return
      end

**************************************************************
          
       subroutine bulk_density(fi,rhof,ros,nx,ny,rhob_m)

       include 'sizes'
c234567
       real*8  fi(0:mnx+1,0:mny+1),rhob_m(0:mnx+1,0:mny+1)
       real*8 rhof(0:mnx+1,0:mny+1)
       real*8 ros(0:mnx+1,0:mny+1)
       integer nx,ny

       do j=0,nx+1
       do k=0,ny+1
        rhob_m(j,k) = (1.d0-fi(j,k))*ros(j,k) + fi(j,k)*rhof(j,k)

c paso metro, gramo, miliseg.
c        rhob_m(j,k) = rhob_m(j,k)*1.d+06
c        rhof(j,k)=rof(j,k)
        enddo
        enddo
     
             return
                 end
*****************************************************************************
       subroutine e_modulus(kf,xks,xkm_m,xnw_m,
     #                fi,nx,ny,xlamcw_m,bw_m,
     #                xmw_m)

        include 'sizes' 
        implicit double precision (a-h,o-z)
       real*8  fi(0:mnx+1,0:mny+1)
       real*8 xks(0:mnx+1,0:mny+1),kf(0:mnx+1,0:mny+1)
      real*8  xkm_m(0:mnx+1,0:mny+1)
      complex*16 xnw_m(0:mnx+1,0:mny+1), xlamcw_m(0:mnx+1,0:mny+1)
      complex*16 bw_m(0:mnx+1,0:mny+1)
      complex*16 xmw_m(0:mnx+1,0:mny+1)
      real*8  xkc
      real*8  b1
      real*8  xm1,kav
       integer nx,ny
      integer blockid,vblockid,blockty,ncontrol,nsx,nsy
      common/a1/ncontrol,blockid,vblockid(2),blockty,nsx,nsy



        do j=0,nx+1
        do k=0,ny+1
      alfa=1-(xkm_m(j,k)/xks(j,k))
      kav=1.d0/((alfa-fi(j,k))/xks(j,k)+fi(j,k)/kf(j,k))
      xkc=xkm_m(j,k)+kav*alfa*alfa
      b1=alfa*kav
      xm1=kav
      bw_m(j,k)= dcmplx(b1,0.d0)
       xmw_m(j,k)= dcmplx(xm1,0.d0)
      xlamcw_m(j,k)=xkc - 2.d0*xnw_m(j,k)/3.d0
          enddo
            enddo
	    
c           if(blockid.eq.0) then
c           write(24,*)'in e_modulus xlamcw_m in blockid=',blockid
c           do k=ny+1,0,-1
c	   write(24,990)(xlamcw_m(j,k),j=0,nx+1)     
c             enddo             	   
c              endif

c           if(blockid.eq.1) then
c           write(25,*)'in e_modulus xlamcw_m in blockid=',blockid
c           do k=ny+1,0,-1	  
c	   write(25,990)(xlamcw_m(j,k),j=0,nx+1)	     
c              enddo		   
c              endif

c           if(blockid.eq.2) then
c           write(26,*)'in e_modulus xlamcw_m in blockid=',blockid
c           do k=ny+1,0,-1 
c	   write(26,990)(xlamcw_m(j,k),j=0,nx+1)	     
c               enddo		   
c              endif

c           if(blockid.eq.3) then
c           write(27,*)'in e_modulus xlamcw_m in blockid=',blockid
c           do k=ny+1,0,-1          
c	   write(27,990)(xlamcw_m(j,k),j=0,nx+1)		     
c             enddo		   
c              endif
c
c990    format(6e20.10)
             return
               end
************************************************************ 
c234567

      subroutine ve_modulus(freq,w_0,keym,qsm,qkc,qm,
     1   fq1,fq2,nx,ny,kf,xks,fi,xkm_m,shear_mod_el,
     1   xnw_m,xlamcw_m,bw_m,xmw_m)
     
       include 'sizes'
      implicit real*8 (a-h,o-z)
      real*8 deltsm,clsm,clkc,tau1,tau2
       integer keym
      real*8 asm,bsm,fq1,fq2
      complex*16 aaim
      complex*16  xlamcw_m(0:mnx+1,0:mny+1)
      complex*16  xnw_m(0:mnx+1,0:mny+1)
      complex*16  bw_m(0:mnx+1,0:mny+1)
      complex*16  xmw_m(0:mnx+1,0:mny+1)
      real*8 qsm(0:mnx+1,0:mny+1),qkc(0:mnx+1,0:mny+1)
      real*8 qm(0:mnx+1,0:mny+1)
      complex*16  xkcw,xmumw,xmw
      real*8 deltkc,apkc,bpkc 
      
       
      real*8  fi(0:mnx+1,0:mny+1)
      real*8  xks(0:mnx+1,0:mny+1),kf(0:mnx+1,0:mny+1)
      real*8  xkm_m(0:mnx+1,0:mny+1),shear_mod_el(0:mnx+1,0:mny+1)      
      real*8  xkc,alfa
      real*8  b1
      real*8  xm1,kav
           
      integer blockid,vblockid,blockty,ncontrol,nsx,nsy
      common/a1/ncontrol,blockid,vblockid(2),blockty,nsx,nsy    

      aaim=dcmplx(0.d0,1.d0)
      pi=dabs(4.d0*datan(1.d0))
      twopi=2.d0*pi
      w=freq
     

c23456
      if(keym.eq.1)then

** modelo de liu continuo      
c constante 'c' y parametros tau1 y tau2 del modelo de liu continuo
       do j=0,nx+1
       do k=0,ny+1
          if(qsm(j,k).gt.0.d0) then
      deltsm =pi/qsm(j,k) 
      else
      deltsm=0.d0
           endif
           if(qkc(j,k).gt.0.d0) then
      deltkc =pi/qkc(j,k) 
      else
      deltkc=0.d0
            endif
            if(qm(j,k).gt.0.d0) then
      deltm =pi/qkc(j,k) 
      else
      deltm=0.d0
            endif
* compute elastic modulus
      alfa=1.d0-(xkm_m(j,k)/xks(j,k))
      kav=1.d0/((alfa-fi(j,k))/xks(j,k)+fi(j,k)/kf(j,k))
      xkc=xkm_m(j,k)+kav*alfa*alfa
      b1=alfa*kav
      xm1=kav
      xmum = shear_mod_el(j,k)
c bw_m is always real
     
      bw_m(j,k)= dcmplx(b1,0.d0)
c      xmw_m(j,k)= dcmplx(xm1,0.d0)
c      xlamcw_m(j,k)=xkc - 2.d0*xnw_m(j,k)/3.d0            

           
      tau1=1.d0/(twopi*fq1)
      tau2=1.d0/(twopi*fq2)
      aux1=1.d0+(w*tau1)**2
      aux2=1.d0+(w*tau2)**2
      aux3=w*(tau1-tau2)
      aux4=1.d0+ (w*tau1)*(w*tau2)
      
c mod de corte complejo

      clsm=2.d0*deltsm/(pi**2)      
      asm=1.d0-.5d0*clsm*dlog(aux1/aux2)
      bsm=clsm*datan(aux3/aux4)
      xmumw=xmum/(asm-aaim*bsm)
      
c      xnw_m(j,k)=xnw_m(j,k)/(asm-aaim*bsm)
      xnw_m(j,k) =  xmumw  
c mod Kc complejo
      clkc=2.d0*deltkc/(pi**2)
      apkc=1.d0-.5d0*clkc*dlog(aux1/aux2)
      bpkc=clkc*datan(aux3/aux4)

      
c      xkcw = xlamcw_m(j,k) + 2.d0*xnw_m(j,k)/3.d0
      xkcw=xkc/(apkc-aaim*bpkc)

      xlamcw_m(j,k)=xkcw - 2.d0*xmumw/3.d0
  
c HAGO COMPLEJO AL m1:

      clm=2.d0*deltm/(pi**2)
      apm=1.d0-.5d0*clm*dlog(aux1/aux2)
      bpm=clm*datan(aux3/aux4)
      
      xmw = xm1/(apm-aaim*bpm)
      
      xmw_m(j,k)= xmw
      


        enddo
           enddo
       endif


      if(keym.ne.1) stop

c IMPORTANTE: si se habilitan keym=2 o keym=3 hay que hacer
c correcciones pues el calculo de aux1,aux2,aux3,aux4 y asm y bsm
c se hacen DENTRO de keym=1. Ademas, el ftnchek tira error para
c la variable "frec" dentro de keym=3 (no esta def!)


***************************************************       
c       if(keym.eq.2)then
** modelo de q constante de white
c      do j=0,nx+1
c       do k=0,ny+1
    
c      xkcw = xlamcw_m(j,k) + xnw_m(j,k)
c      xkcw=xkcw*(1.d0+aaim*deltkc/pi)  

c      xnw_m(j,k)=xnw_m(j,k)*(1.d0+aaim*deltsm/pi)
c      xlamcw_m(j,k)=xkcw - xnw_m(j,k)

c         enddo
c           enddo
c      endif

   
***************************************************
c       if(keym.eq.3)then

** modelo standard linear solid simple centrado en una frec w_0
** fija segun flas. de carcione, cuyo q resultante es exactamente
** igual al dato  solo en la w_0 elegida.
** funciona bien tanto en altas
** como bajas presiones, (pero da un q dependiente de w)
 
c       do j=0,nx+1
c       do k=0,ny+1
c juan change  modulo de volumen saturado y cerrado 
 
c       xkcw = xlamcw_m(j,k) + xnw_m(j,k)
      
c       taueps = (1.d0/w_0)*(deltkc/pi+dsqrt((deltkc/pi)**2+1.d0))
c       tausig= 1.d0/taueps/(w_0**2)
c       xkcw=xkcw*(1.d0+aaim*frec*taueps)/
c     # (1.d0+aaim*frec*tausig) 
c       xkcw=xkcw*tausig/taueps
         
c modulo de corte             
c       taueps = (1.d0/w_0)*(deltsm/pi+dsqrt((deltsm/pi)**2+1.d0))
c       tausig= 1.d0/taueps/(w_0**2)
c       xnw_m(j,k)=xnw_m(j,k)*(1.d0+aaim*w*taueps)/(1.d0+aaim*w*tausig)
c cambio (segun jose considero que xn es el h.f. limit, no el l.f. limit)
c        xnw_m(j,k)=xnw_m(j,k)*tausig/taueps 
c fin cambio
c        xlamcw_m(j,k)=xkcw - xnw_m(j,k)       

c4      format(6g15.6)
c         enddo
c           enddo

c           endif


c  cambio de unidades a metro, mseg, gramo

c       do j=0,nx+1
c       do k=0,ny+1

 
c       xlamcw_m(j,k)=xlamcw_m(j,k)*1.d+06
c       xnw_m(j,k)=xnw_m(j,k)*1.d+06 
c       bw_m(j,k)=bw_m(j,k)*1.d+06
c       xmw_m(j,k)=xmw_m(j,k)*1.d+06
       


c         enddo
c           enddo

       return
        end
*****************************************************************
      subroutine viscodynamic(frec,kperm,fi,muf,rhof,
     1  struc,nx,ny,g_m,
     1  b_m)

       include 'sizes'

      implicit real*8(a-h,o-z)
      real*8 br(4),bi(4),muf(0:mnx+1,0:mny+1)
      real*8 rhof(0:mnx+1,0:mny+1)
      real*8  fi(0:mnx+1,0:mny+1),kperm(0:mnx+1,0:mny+1)
      real*8  struc(0:mnx+1,0:mny+1)
      real*8  g_m(0:mnx+1,0:mny+1)
      real*8  b_m(0:mnx+1,0:mny+1)     
      


* constantes utiles 
      pi=4.d0*datan(1.d0)
      ra2=dsqrt(2.0d0)/2.d0



* constante de kozeny-carman
        xkoz=5.d0                          

* pore size parameter (ac**2)

          do j=0,nx+1
          do k=0,ny+1 


***********************************************************************
* coefs. para non-wetting phase 
*
       ii=1
       if(ii.eq.1)go to  237
      
      if(muf(j,k).lt.1.d-15) then
      f_rn=1.d0
      f_in=0.d0
      else
      acn=4.d0*xkoz*kperm(j,k)/fi(j,k)                  
      theta_n=dabs(dsqrt(acn*frec*rhof(j,k)/muf(j,k)))
      xn=(-ra2)*theta_n
      yn=(-xn)
      n=4
      call mmbzjn(xn,yn,n,br,bi,ier)
      
       if(ier.ne.0)then
       write(6,911)ier,j,k,frec/(2.*pi),dsqrt(xn**2+yn**2),xn
       stop  44444
911   format(1x,'error in bessel nonwet calculation',/'ier=',i4,1x,
     1 'j,k=',2i4,'frec = ',g20.8,/
     # 1x,'dsqrt(xn**2+yn**2)=',g20.8,/
     # 1x,'xn=-yn=',g20.8)
       endif
       
* calculo de la funcion de frecuencia f
* parte real e imaginaria (f_r,f_i)
 
      f_rn = 0.125d0*(theta_n**2)*(bi(1)*br(3)-br(1)*bi(3))/
     1 (br(3)**2+bi(3)**2)
  
      f_in= (br(1)*br(3)+bi(1)*bi(3))/(br(3)**2+bi(3)**2)

      f_in = -0.125d0*(theta_n**2)*(1.d0+f_in)
       endif
c NO HAGO CORRECCION VISCODINAMICA

237   continue

      f_rn=1.d0
      f_in=0.d0


      
* acoplamiento de masa g 
       g_m(j,k)=rhof(j,k)*struc(j,k)/fi(j,k)+f_in*muf(j,k)/(frec
     1*kperm(j,k))
       b_m(j,k)=muf(j,k)*f_rn/kperm(j,k)        	
    

c        b_m(j,k)=b_m(j,k)*1.d+03
c         g_m(j,k)=g_m(j,k)*1.d+06      
         
     

           enddo
            enddo
78       return
        end



*********************************************************************
c
      subroutine mmbzjn (x,y,n,br,bi,ier)
       include 'sizes'
c                                  specifications for arguments
      integer            n,ier
      double precision   x,y,br(n),bi(n)
c                                  specifications for local variables
      integer            largez,magz,ncalc,nbmz,nn,m,nstart,nend,
     *                   ipos,mrecur,k,l,mlast,imrecr,itemp,jmag,i
      double precision   pr,pi,plastr,plasti,poldr,poldi,psaver,psavei,
     *                   exparg,test,tover,tempar,tempai,tempbr,tempbi,
     *                   tempcr,tempci,rsign,sumr,sumi,zinvr,zinvi,dsig,
     *                   rten,xinf,tmpar4,smallz,srpri
c
c                                  machine dependent constants
c
      data               xinf/1.700000000d+38/
      data               dsig/16.8d0/
      data               rten/38.d0/
      data               largez /100000/
      data               exparg/200.0/
c     data               exparg/88.0/
c                                  first executable statement
      ier = 0
      tempar = dsqrt(x*x + y*y)
      magz = ifix(sngl(tempar))
      if(n.gt.0 .and. magz.le.largez .and.((dabs(y).le.exparg)))go to 10
c                                  error return - z or n is out of range
      nn = n
      if(n.le.0) nn = 1
      do 5  i=1,nn
         br(i) = xinf
    5 continue
      ier = 129
      go to 9000
   10 rsign = 1.d0
      ncalc = n
c                                  use 2-term ascending series for
c                                    small z
      tmpar4 = tempar**4
      smallz = .1d0**dsig
      if(tmpar4 .lt. smallz) go to 175
c                                  initialize the calcultion of the p*s
      nbmz = n-magz
      nn = magz+1
      if(dabs(x) .lt. dabs(y)) go to 15
      zinvr = 1.d0/(x+y*y/x)
      zinvi = -y*zinvr/x
      go to 20
   15 zinvi = -1.d0/(y+x*x/y)
      zinvr = -x*zinvi/y
   20 plastr = 1.d0
      plasti = 0.d0
      pr = rsign*dble(float(2*nn))*zinvr
      pi = rsign*dble(float(2*nn))*zinvi
      test = 2.d0*1.d1**dsig
      m = 0
      if(nbmz .lt. 3) go to 30
c                                  calculate p*s until nn=n-1. check for
c                                    possible overflow
      tover = 1.d1**(rten-dsig)
      nstart = magz+2
      nend = n-1
      do 25  nn=nstart,nend
         poldr = plastr
         poldi = plasti
         plastr = pr
         plasti = pi
         pr=rsign*(dble(float(2*nn))*(plastr*zinvr-plasti*zinvi)-poldr)
         pi=rsign*(dble(float(2*nn))*(plasti*zinvr+plastr*zinvi)-poldi)
         srpri = dsqrt(pr**2 + pi**2)
         if(srpri - tover) 25, 25, 35
   25 continue
      nn = nend
c                                  calculate special significance test
c                                    for nbmz .gt. 2
      tempbi = dmax1(dabs(pr),dabs(pi))
      tempbi = tempbi*dsqrt(2.d0*1.d1**dsig*dsqrt(((pr/tempbi)**2+(pi/
     *         tempbi)**2)*((plastr/tempbi)**2+(plasti/tempbi)**2)))
      test = dmax1(test,tempbi)
c                                  calculate p*s until significance
c                                    test is passed.
   30 nn = nn+1
      poldr = plastr
      poldi = plasti
      plastr = pr
      plasti = pi
      pr = rsign*(dble(float(2*nn))*(plastr*zinvr-plasti*zinvi)-poldr)
      pi = rsign*(dble(float(2*nn))*(plasti*zinvr+plastr*zinvi)-poldi)
      if((pr/test)**2+(pi/test)**2.lt.1.d0) go to 30
      if(m.eq.1) go to 55
c                                  calculate strict variant of
c                                    significance test. and calculate
c                                    p*s until this test is passed.
      m = 1
      tempbi = dmax1(dabs(pr),dabs(pi))
      tempbr = dsqrt(((pr/tempbi)**2+(pi/tempbi)**2)/((plastr/tempbi)**
     *         2+(plasti/tempbi)**2))
      tempbi = dble(float(nn+1))/tempar
      if(tempbr+1.d0/tempbr.gt.2.d0*tempbi) tempbr =
     *   tempbi+dsqrt(tempbi**2-1.d0)
      test = test/dsqrt(tempbr-1.d0/tempbr)
      if((pr/test)**2+(pi/test)**2-1.d0) 30, 55, 55
   35 nstart = nn+1
c                                  to avoid overflow, normalize p*s by
c                                    dividing by tover. calculate p*s
c                                    until unnormalized p would overflow
      pr = pr/tover
      pi = pi/tover
      plastr = plastr/tover
      plasti = plasti/tover
      psaver = pr
      psavei = pi
      tempcr = plastr
      tempci = plasti
      test = 1.d1**(dsig+dsig)
   40 nn = nn+1
      poldr = plastr
      poldi = plasti
      plastr = pr
      plasti = pi
      pr = rsign*(dble(float(2*nn))*(plastr*zinvr-plasti*zinvi)-poldr)
      pi = rsign*(dble(float(2*nn))*(plasti*zinvr+plastr*zinvi)-poldi)
      tmpar4 = pr*pr+pi*pi
      if(tmpar4 .le. test) go to 40
c                                  calculate backward test, and find
c                                    ncalc, the highest nn such that the
c                                    test is passed.
      tempbr = dsqrt((plastr**2+plasti**2)/(poldr**2+poldi**2))
      tempbi = dble(float(nn))/tempar
      if(tempbr+1.d0/tempbr.gt.2.d0*tempbi) tempbr =
     *   tempbi+dsqrt(tempbi**2-1.d0)
      test = .5d0*(1.d0-1.d0/tempbr**2)/1.d1**dsig
      test = ((plastr**2+plasti**2)*test)*((poldr**2+poldi**2)*test)
      pr = plastr*tover
      pi = plasti*tover
      nn = nn-1
      nend = min0(n,nn)
      do 45  ncalc=nstart,nend
         poldr = tempcr
         poldi = tempci
         tempcr = psaver
         tempci = psavei
         psaver = rsign*(dble(float(2*nn))*(tempcr*zinvr-tempci*zinvi)
     *            - poldr)
         psavei = rsign*(dble(float(2*nn))*(tempci*zinvr+tempcr*zinvi)
     *            - poldi)
         if((psaver**2+psavei**2)*(tempcr**2+tempci**2)-test)45,45,50
   45 continue
      ncalc = nend+1
   50 ncalc = ncalc-1
c                                  the coefficient of b(nn) in the
c                                    normalization sum is
c                                    m*sqrt(-1)**jmag, where m=-2,0,
c                                    or 2, and imag is 0 or 1. calculate
c                                    recursion rules for m and jmag, and
c                                    initialize them.
   55 nn = nn+1
      tempbr = y
      ipos = 0
      if(tempbr) 60, 65, 60
   60 ipos = ifix(sngl(1.1d0*tempbr/dabs(tempbr)))
   65 mrecur = 4*((2+ipos)/2)-3-2*(ipos)
      k = 2+ipos
      l = nn-4*(nn/4)
      mlast = 2+8*((k*l)/4)-4*((k*l)/2)
      if(ipos.eq.0 .and. (l.eq.1 .or. l.eq.3)) mlast = 0
      l = l+3-4*((l+3)/4)
      m = 2+8*((k*l)/4)-4*((k*l)/2)
      if(ipos.eq.0 .and. (l.eq.1 .or. l.eq.3)) m = 0
      imrecr = ipos*ipos
      jmag = imrecr*(l-2*(l/2))
c                                  initialize the backward recursion and
c                                    the normalization sum.
      tempbr = 0.d0
      tempbi = 0.d0
      if(dabs(pi).gt.dabs(pr)) go to 70
      tempar = 1.d0/(pr+pi*(pi/pr))
      tempai = -(pi*tempar)/pr
      go to 75
   70 tempai = -1.d0/(pi+pr*(pr/pi))
      tempar = -(pr*tempai)/pi
   75 if(jmag.ne.0) go to 80
      sumr = dble(float(m))*tempar
      sumi = dble(float(m))*tempai
      go to 85
   80 sumr = -dble(float(m))*tempai
      sumi = dble(float(m))*tempar
   85 nend = nn-n
      if(nend) 120, 105, 90
c                                  recur backward via difference
c                                    equation calculation (but not
c                                    storing) br(nn) and bi(nn) until
c                                    nn = n.
   90 do 100  l=1,nend
         nn = nn-1
         tempcr = tempbr
         tempci = tempbi
         tempbr = tempar
         tempbi = tempai
         pr = dble(float(2*nn))*zinvr
         pi = dble(float(2*nn))*zinvi
         tempar = pr*tempbr-pi*tempbi-rsign*tempcr
         tempai = pr*tempbi+pi*tempbr-rsign*tempci
         jmag = (1-jmag)*imrecr
         k = mlast
         mlast = m
         m = k*mrecur
         if(jmag.ne.0) go to 95
         sumr = sumr+dble(float(m))*tempar
         sumi = sumi+dble(float(m))*tempai
         go to 100
   95    sumr = sumr-dble(float(m))*tempai
         sumi = sumi+dble(float(m))*tempar
  100 continue
c                                  store br(nn),bi(nn)
  105 br(nn) = tempar
      bi(nn) = tempai
      if(nn.gt.1) go to 110
c                                  n=1.  since 2*tempar and 2*tempai
c                                    were added to sumr and sumi
c                                    respectively, we must subtract
c                                    tempar and tempai
      sumr = sumr-tempar
      sumi = sumi-tempai
      go to 155
c                                  calculate and store br(nn-1),(nn-1)
  110 nn = nn-1
      pr = dble(float(2*nn))*zinvr
      pi = dble(float(2*nn))*zinvi
      br(nn) = pr*tempar-pi*tempai-rsign*tempbr
      bi(nn) = pr*tempai+pi*tempar-rsign*tempbi
      if(nn.eq.1) go to 150
      jmag = (1-jmag)*imrecr
      k = mlast
      mlast = m
      m = k*mrecur
      if(jmag.ne.0) go to 115
      sumr = sumr+dble(float(m))*br(nn)
      sumi = sumi+dble(float(m))*bi(nn)
      go to 130
  115 sumr = sumr-dble(float(m))*bi(nn)
      sumi = sumi+dble(float(m))*br(nn)
      go to 130
c                                  nn .lt. n, so store br(nn), and set
c                                    higher orders zero
  120 br(nn) = tempar
      bi(nn) = tempai
      nend = -nend
      do 125  l=1,nend
         itemp = nn+l
         br(itemp) = 0.0d0
         bi(itemp) = 0.0d0
  125 continue
  130 nend = nn-2
      if(nend.eq.0) go to 145
c                                  calculate via difference equation and
c                                    store br(nn),bi(nn), until nn=2
      do 140  l=1,nend
         nn = nn-1
         pr = dble(float(2*nn))*zinvr
         pi = dble(float(2*nn))*zinvi
         br(nn) = pr*br(nn+1)-pi*bi(nn+1)-rsign*br(nn+2)
         bi(nn) = pr*bi(nn+1)+pi*br(nn+1)-rsign*bi(nn+2)
         jmag = (1-jmag)*imrecr
         k = mlast
         mlast = m
         m = k*mrecur
         if(jmag.ne.0) go to 135
         sumr = sumr+dble(float(m))*br(nn)
         sumi = sumi+dble(float(m))*bi(nn)
         go to 140
  135    sumr = sumr-dble(float(m))*bi(nn)
         sumi = sumi+dble(float(m))*br(nn)
  140 continue
c                                  calculute and store br(1), bi(1)
  145 br(1) = 2.d0*(br(2)*zinvr-bi(2)*zinvi)-rsign*br(3)
      bi(1) = 2.d0*(br(2)*zinvi+bi(2)*zinvr)-rsign*bi(3)
  150 sumr = sumr+br(1)
      sumi = sumi+bi(1)
c                                  calculate normalization factor,
c                                    tempar + i*tempai
  155 tempcr = dble(float(ipos))*y
      tempci = dble(float(-ipos))*x
      tempcr = dexp(tempcr)
      tempbr = dcos(tempci)
      tempbi = dsin(tempci)
      if(dabs(sumr).lt.dabs(sumi)) go to 160
      tempci = sumi/sumr
      tempcr = (tempcr/sumr)/(1.d0+tempci*tempci)
      tempar = tempcr*(tempbr+tempbi*tempci)
      tempai = tempcr*(tempbi-tempbr*tempci)
      go to 165
  160 tempci = sumr/sumi
      tempcr = (tempcr/sumi)/(1.d0+tempci*tempci)
      tempar = tempcr*(tempbr*tempci+tempbi)
      tempai = tempcr*(tempbi*tempci-tempbr)
c                                  normalize
  165 do 170  nn=1,n
         tempbr = br(nn)*tempar-bi(nn)*tempai
         bi(nn) = br(nn)*tempai+bi(nn)*tempar
         br(nn) = tempbr
  170 continue
      go to 185
c                                  two-term ascending series for small z
  175 tempar = 1.d0
      tempai = 0.d0
      tempcr = .25d0*(x*x-y*y)
      tempci = .5d0*x*y
      br(1) = 1.d0-rsign*tempcr
      bi(1) = -rsign*tempci
      if(n.eq.1) go to 185
      do 180  nn=2,n
         tempbr = (tempar*x-tempai*y)/dble(float(2*nn-2))
         tempai = (tempar*y+tempai*x)/dble(float(2*nn-2))
         tempar = tempbr
         tempbr = dble(float(nn))
         br(nn) = tempar*(1.d0-rsign*tempcr/tempbr)+tempai*tempci/tempbr
         bi(nn) = tempai*(1.d0-rsign*tempcr/tempbr)-tempar*tempci/tempbr
  180 continue
  185 continue
      if(n.eq.ncalc) go to 9005
      ier = 129+ncalc
 9000 continue
c     call uertst(ier,6hmmbzjn)
 9005 return
      end
c *****************************************************************
      subroutine veloc_aten(xmw,hcw,dw,rof,gw,rob,bw,omega,xmumw,vp1,vp2
     c,vs,j,k)
      complex*16 aim,xmw,hcw,xmumw,p1,p2,p3,xk1,xk2,dw
      real*8 omega,rof,gw,rob,bw,c1w,c2w,csw,pi,vp1
      real*8 vp2,vs
      

      
       
      aim=dcmplx(0.d0,1.d0)
      pi=4.d0*datan(1.d0)
      p1=xmw*hcw- dw**2

      p2=2.d0*rof*dw-hcw*gw-rob*xmw+
     1    aim*bw*hcw/omega

      p3=rob*gw- rof**2 -aim*bw*rob/omega





c xk1= k1/omega ; xk2=k2/omega

      xk1=cdsqrt((-p2-cdsqrt(p2*p2-4.d0*p1*p3))/(2.d0*p1))
      xk2=cdsqrt((-p2+cdsqrt(p2*p2-4.d0*p1*p3))/(2.d0*p1))
      c1w=1.d0/dreal(xk1)
      c2w=1.d0/dreal(xk2)
c      aten1=-8.686d0*2.d0*pi*dimag(xk1)/dreal(xk1)
c      aten2=-8.686d0*2.d0*pi*dimag(xk2)/dreal(xk2)  
      vp1=c1w
      vp2=c2w  
 
*   computes  frequency dependent  shear waves speed 

        p1 = gw - aim*bw/omega
	p2 = rob - rof**2/p1
	p3 = (omega**2*p2)/xmumw
	p3 = cdsqrt(p3)
        csw   = omega/dreal(p3)
c        atens=-8.686d0*2.d0*pi*dimag(p3)/dreal(p3)
        vs=csw
        return
        end
	
*********************************************************************
      subroutine coeflu(nx,ny,omega,
     1                  betal,betar,betab,betat,h,
     1                  deltal,deltar,deltab,deltat,
     1                  rhob_m,rhof,
     1                  xlamcw_m,xnw_m,bw_m,xmw_m,
     1                  b_m,g_m,b,
     1                  cc,cc_lu)
       include 'sizes'

      implicit double precision (a-h,o-z)

      real*8  rhob_m(0:mnx+1,0:mny+1),rhof(0:mnx+1,0:mny+1)
      complex*16  xlamcw_m(0:mnx+1,0:mny+1)
      complex*16  xnw_m(0:mnx+1,0:mny+1)
      complex*16  bw_m(0:mnx+1,0:mny+1)
      complex*16  xmw_m(0:mnx+1,0:mny+1)
      real*8  b_m(0:mnx+1,0:mny+1)
      real*8  g_m(0:mnx+1,0:mny+1)

      complex*16 cc(12,12),cc_lu(12,12,mnx,mny)
      complex*16 aim
      real*8  deltal(mnx),deltar(mnx),deltat(mny),deltab(mny)
      
      real*8 betal(3,3,mnx,mny),betar(3,3,mnx,mny)
      real*8 betab(3,3,mnx,mny),betat(3,3,mnx,mny)      

      real*8 b(3,3)
      real*8  xajk,xajkn   
c
c     end dimension statements
c
            
        

       
        aim=dcmplx(0.d0,1.d0)
c
c
c   loop over the  elements  to factor each 8x8 system
c
                 do 1003 j=1,nx
                 do 1003 k=1,ny
                  

c  calculation of iteration matrices betal,betar,betat,betab 
c  and absorbing  b. c matrix b

      call       abc_beta(j,k,betal,betar,betab,betat,
     1                    rhob_m,rhof,
     1                    xlamcw_m,xnw_m,bw_m,xmw_m,
     1                    g_m,b)

         xajk=-omega**2*rhob_m(j,k)
         xajkn=-omega**2*rhof(j,k)
         

*  coefficients for  l - equation

c      write(6,*) 'valores'
c      write(6,*) xajk * h**2 * 781.d0/5040.d0
c      write(6,*) xlamcw_m(j,k)
c      write(6,*) xnw_m(j,k)
c      write(6,*)  65.d0 * (xlamcw_m(j,k)+2.d0*xnw_m(j,k)) /28.d0
c     1          +  37.d0 * xnw_m(j,k) /28.d0

c       write(6,*)deltal(j) * aim * omega* h * b(1,1)
c       write(6,*) deltal(j) 
c       write(6,*) omega 
c       write(6,*) h 
c       write(6,*) b(1,1)
c       write(6,*) rhob_m(j,k)
       

      cc(1,1) = xajk * h**2 * 781.d0/5040.d0   
     1          +  65.d0 * (xlamcw_m(j,k)+2.d0*xnw_m(j,k)) /28.d0
     1          +  37.d0 * xnw_m(j,k) /28.d0
     1          +  deltal(j) * aim * omega* h * b(1,1)
     1          + (1.d0-deltal(j))*aim * omega*  betal(1,1,j,k) * h

      cc(1,2) = xajk * h**2 * 269.d0/5040.d0 
     1          -  37.d0 * (xlamcw_m(j,k)+2.d0*xnw_m(j,k))/28.d0
     1          -  37.d0 * xnw_m(j,k) /28.d0

      cc(1,3) = xajk * h**2 * (-59.d0)/5040.d0 
     1          + 9.d0 * (xlamcw_m(j,k)+2.d0*xnw_m(j,k))/28.d0 
     1          + 37.d0 * xnw_m(j,k)/28.d0

      cc(1,4) = xajk * h**2 * 269.d0/5040.d0 
     1          - 37.d0 * (xlamcw_m(j,k)+2.d0*xnw_m(j,k))/28.d0 
     1          - 37.d0 * xnw_m(j,k)/28.d0

      cc(1,5) = deltal(j) * aim * omega* h * b(1,2)
     1          + (1.d0-deltal(j))*aim * omega*  betal(1,2,j,k) * h

      cc(1,6) = xlamcw_m(j,k) 

      cc(1,7) = dcmplx(0.d0,0.d0)

      cc(1,8) = -xlamcw_m(j,k) 

      cc(1,9) = -xajkn * h**2 * 5.d0/24.d0   
     1          - bw_m(j,k)
     1          -  deltal(j) * aim * omega* h * b(1,3)
     1          - (1.d0-deltal(j))*aim * omega*  betal(1,3,j,k) * h

      cc(1,10) = xajkn * h**2 /24.d0   
     1          - bw_m(j,k)

      cc(1,11) = - bw_m(j,k)

      cc(1,12) = - bw_m(j,k)

  

* coefficients for  b - equation

      cc(2,1) = cc(1,2)

      cc(2,2) = xajk * h**2 * 781.d0/5040.d0   
     1          +  37.d0 * (xlamcw_m(j,k)+2.d0*xnw_m(j,k)) /28.d0
     1          +  65.d0 * xnw_m(j,k) /28.d0
     1          +  deltab(k) * aim * omega* h * b(2,2)
     1          + (1.d0-deltab(k))*aim * omega*  betab(2,2,j,k) * h

      cc(2,3) = xajk * h**2 * 269.d0/5040.d0 
     1          - 37.d0 * (xlamcw_m(j,k)+2.d0*xnw_m(j,k))/28.d0 
     1          - 37.d0 * xnw_m(j,k)/28.d0

      cc(2,4) = xajk * h**2 * (-59.d0)/5040.d0 
     1          + 37.d0 * (xlamcw_m(j,k)+2.d0*xnw_m(j,k))/28.d0 
     1          + 9.d0 * xnw_m(j,k)/28.d0

      cc(2,5) = xnw_m(j,k)

c sign 

      cc(2,6) = -deltab(k) * aim * omega* h * b(2,1)
     1          - (1.d0-deltab(k))*aim * omega*  betab(2,1,j,k) * h

      cc(2,7) = -xnw_m(j,k)

      cc(2,8) = dcmplx(0.d0,0.d0)

      cc(2,9) = -xajkn * h**2 /8.d0

      cc(2,10) = xajkn * h**2 /8.d0

c sign
      cc(2,11) = deltab(k) * aim * omega* h * b(2,3)
     1          + (1.d0-deltab(k))*aim * omega*  betab(2,3,j,k) * h

      cc(2,12) = dcmplx(0.d0,0.d0)


* coefficients for  r - equation

      cc(3,1) = cc(1,3)

      cc(3,2)  = cc(2,3)

      cc(3,3) = xajk * h**2  * 781.d0/5040.d0
     1          + 65.d0 * (xlamcw_m(j,k)+2.d0*xnw_m(j,k))/28.d0 
     1          + 37.d0 * xnw_m(j,k)/28.d0
     1          +  deltar(j) * aim * omega* h * b(1,1) 
     1          + (1.d0-deltar(j))*aim * omega* betar(1,1,j,k) * h

      cc(3,4) = xajk * h**2 * 269.d0/5040.d0 
     1          - 37.d0 * (xlamcw_m(j,k)+2.d0*xnw_m(j,k))/28.d0
     1          - 37.d0 * xnw_m(j,k)/28.d0

      cc(3,5) = dcmplx(0.d0,0.d0)

      cc(3,6) = -xlamcw_m(j,k) 

      cc(3,7) = deltar(j) * aim * omega* h * b(1,2) 
     1          + (1.d0-deltar(j))*aim * omega* betar(1,2,j,k) * h

      cc(3,8) = xlamcw_m(j,k)
 
      cc(3,9) = -xajkn * h**2 /24.d0   
     1          + bw_m(j,k)

      cc(3,10) = xajkn * h**2 * 5.d0/24.d0   
     1          + bw_m(j,k)
     1           + deltar(j) * aim * omega* h * b(1,3) 
     1          + (1.d0-deltar(j))*aim * omega* betar(1,3,j,k) * h

      cc(3,11) = bw_m(j,k)

      cc(3,12) = bw_m(j,k)

    

* coefficients for   t - equation

      cc(4,1) = cc(1,4)

      cc(4,2) = cc(2,4)

      cc(4,3) = cc(3,4)

      cc(4,4) = xajk * h**2 * 781.d0/5040.d0 
     1          + 37.d0 * (xlamcw_m(j,k)+2.d0*xnw_m(j,k))/28.d0 
     1          + 65.d0 * xnw_m(j,k)/28.d0
     1          +  deltat(k) * aim * omega* h * b(2,2)
     1          + (1.d0-deltat(k))* aim * omega* betat(2,2,j,k)* h

      cc(4,5) = -xnw_m(j,k)

      cc(4,6) = dcmplx(0.d0,0.d0)

      cc(4,7) = xnw_m(j,k)

c sign 

      cc(4,8) = -deltat(k) * aim * omega* h * b(2,1)
     1          - (1.d0-deltat(k))* aim * omega* betat(2,1,j,k)* h

      cc(4,9) = -xajkn * h**2 /8.d0

      cc(4,10) = xajkn * h**2 /8.d0

      cc(4,11) = dcmplx(0.d0,0.d0)

c sign 
      cc(4,12) = -deltat(k) * aim * omega* h * b(2,3)
     1          - (1.d0-deltat(k))* aim * omega* betat(2,3,j,k)* h

   

*  coefficients for  l - equation (for 2nd comp.)

      cc(5,1) = cc(1,5)

      cc(5,2) = cc(2,5)

      cc(5,3) = cc(3,5)

      cc(5,4) = cc(4,5)

      cc(5,5) = xajk * h**2 * 781.d0/5040.d0  
     1          + 37.d0 * (xlamcw_m(j,k)+2.d0*xnw_m(j,k))/28.d0 
     1          + 65.d0 * xnw_m(j,k)/28.d0
     1          +  deltal(j) * aim * omega* h * b(2,2)
     1          + (1.d0-deltal(j))* aim * omega* betal(2,2,j,k)* h

      cc(5,6) = xajk * h**2 * 269.d0/5040.d0 
     1          - 37.d0 * (xlamcw_m(j,k)+2.d0*xnw_m(j,k))/28.d0 
     1          - 37.d0 * xnw_m(j,k)/28.d0

      cc(5,7) = xajk * h**2 * (-59.d0)/5040.d0 
     1          + 37.d0 * (xlamcw_m(j,k)+2.d0*xnw_m(j,k))/28.d0
     1          + 9.d0 * xnw_m(j,k)/28.d0

      cc(5,8) = xajk * h**2 * 269.d0/5040.d0
     1          - 37.d0 * (xlamcw_m(j,k)+2.d0*xnw_m(j,k))/28.d0 
     1          - 37.d0 * xnw_m(j,k)/28.d0

      cc(5,9) = -deltal(j) * aim * omega* h * b(2,3)
     1          - (1.d0-deltal(j))* aim * omega* betal(2,3,j,k)* h

      cc(5,10) = dcmplx(0.d0,0.d0)

      cc(5,11) = -xajkn * h**2 /8.d0

      cc(5,12) = xajkn * h**2 /8.d0

   

* coefficients for  b - equation  (for 2nd comp.)

      cc(6,1) = cc(1,6)

      cc(6,2) = cc(2,6)

      cc(6,3) = cc(3,6)

      cc(6,4) = cc(4,6)

      cc(6,5) = cc(5,6)

      cc(6,6) = xajk * h**2 * 781.d0/5040.d0 
     1          + 65.d0 *(xlamcw_m(j,k)+2.d0*xnw_m(j,k)) /28.d0 
     1          + 37.d0 * xnw_m(j,k)/28.d0
     1          +  deltab(k) * aim * omega* h * b(1,1)
     1          + (1.d0-deltab(k))* aim * omega* betab(1,1,j,k)* h

      cc(6,7) = xajk * h**2 * 269.d0/5040.d0
     1          - 37.d0 *(xlamcw_m(j,k)+2.d0*xnw_m(j,k)) /28.d0 
     1          - 37.d0 * xnw_m(j,k)/28.d0 

      cc(6,8) = xajk * h**2 * (-59.d0)/5040.d0 
     1          + 9.d0 * (xlamcw_m(j,k)+2.d0*xnw_m(j,k))/28.d0
     1          + 37.d0 * xnw_m(j,k)/28.d0

      cc(6,9) = -bw_m(j,k)

      cc(6,10) = -bw_m(j,k)

      cc(6,11) = -xajkn * h**2 * 5.d0/24.d0   
     1          - bw_m(j,k)
     1          - deltab(k) * aim * omega* h * b(1,3) 
     1          - (1.d0-deltab(k))*aim * omega* betab(1,3,j,k) * h

      cc(6,12) = xajkn * h**2 /24.d0   
     1          - bw_m(j,k)

  

* coefficients for  r - equation  (for 2nd comp.)

      cc(7,1) = cc(1,7)

      cc(7,2) = cc(2,7)

      cc(7,3) = cc(3,7)

      cc(7,4) = cc(4,7)

      cc(7,5) = cc(5,7)

      cc(7,6)  = cc(6,7)

      cc(7,7) = xajk * h**2 * 781.d0/5040.d0
     1          + 37.d0 * (xlamcw_m(j,k)+2.d0*xnw_m(j,k))/28.d0 
     1          + 65.d0 * xnw_m(j,k)/28.d0
     1          +  deltar(j) * aim * omega* h * b(2,2)
     1          + (1.d0-deltar(j))* aim * omega *betar(2,2,j,k)* h

      cc(7,8) = xajk * h**2 * 269.d0/5040.d0
     1          - 37.d0 * (xlamcw_m(j,k)+2.d0*xnw_m(j,k))/28.d0 
     1          - 37.d0 * xnw_m(j,k)/28.d0

      cc(7,9) = dcmplx(0.d0,0.d0)

      cc(7,10) = deltar(j) * aim * omega* h * b(2,3)
     1          + (1.d0-deltar(j))* aim * omega *betar(2,3,j,k)* h

      cc(7,11) = -xajkn * h**2 /8.d0

      cc(7,12) = xajkn * h**2 /8.d0

   
* coefficients for   t - equation (for 2nd comp.)

      cc(8,1) = cc(1,8)

      cc(8,2) = cc(2,8)

      cc(8,3) = cc(3,8)

      cc(8,4) = cc(4,8)

      cc(8,5) = cc(5,8)

      cc(8,6) = cc(6,8)

      cc(8,7) = cc(7,8)

      cc(8,8) = xajk * h**2 * 781.d0/5040.d0
     1          + 65.d0 *(xlamcw_m(j,k)+2.d0*xnw_m(j,k)) /28.d0 
     1          + 37.d0 * xnw_m(j,k)/28.d0
     1          +  deltat(k) * aim * omega* h * b(1,1)
     1          + (1.d0-deltat(k))* aim *omega *betat(1,1,j,k)* h

      cc(8,9) = bw_m(j,k)

      cc(8,10) = bw_m(j,k)

      cc(8,11) = -xajkn * h**2 /24.d0
     1          + bw_m(j,k)

      cc(8,12) = xajkn * h**2 * 5.d0/24.d0   
     1          + bw_m(j,k)
     1          + deltat(k) * aim * omega* h * b(1,3) 
     1          + (1.d0-deltat(k))*aim * omega* betat(1,3,j,k) * h

     
    

* coefficients for   l - equation (for n comp.)

      cc(9,1) = cc(1,9)

      cc(9,2) = cc(2,9)

      cc(9,3) = cc(3,9)

      cc(9,4) = cc(4,9)

      cc(9,5) = cc(5,9)

      cc(9,6) = cc(6,9)

      cc(9,7) = cc(7,9)

      cc(9,8) = cc(8,9)

      cc(9,9) = -omega**2*g_m(j,k)* h**2 /3.d0 
     1          + aim * omega * b_m(j,k)* h**2 /3.d0
     1          + xmw_m(j,k) 
     1          + deltal(j) * aim * omega* h * b(3,3) 
     1          + (1.d0-deltal(j))*aim * omega* betal(3,3,j,k) * h

      cc(9,10) = -omega**2*g_m(j,k)* (-h**2 /6.d0)  
     1          - aim * omega * b_m(j,k)* h**2 /6.d0
     1          + xmw_m(j,k)

      cc(9,11) = xmw_m(j,k)

      cc(9,12) = xmw_m(j,k)

    

* coefficients for   r - equation (for n comp.)

      cc(10,1) = cc(1,10)

      cc(10,2) = cc(2,10)

      cc(10,3) = cc(3,10)

      cc(10,4) = cc(4,10)

      cc(10,5) = cc(5,10)

      cc(10,6) = cc(6,10)

      cc(10,7) = cc(7,10)

      cc(10,8) = cc(8,10)

      cc(10,9) = cc(9,10)

      cc(10,10) = -omega**2*g_m(j,k)* h**2 /3.d0 
     1          + aim * omega * b_m(j,k)* h**2 /3.d0
     1          + xmw_m(j,k) 
     1          +deltar(j) * aim * omega* h * b(3,3) 
     1          + (1.d0-deltar(j))*aim * omega* betar(3,3,j,k) * h

      cc(10,11) = xmw_m(j,k) 

      cc(10,12) = xmw_m(j,k) 

  

* coefficients for   b - equation (for n comp.)

      cc(11,1) = cc(1,11)

      cc(11,2) = cc(2,11)

      cc(11,3) = cc(3,11)

      cc(11,4) = cc(4,11)

      cc(11,5) = cc(5,11)

      cc(11,6) = cc(6,11)

      cc(11,7) = cc(7,11)

      cc(11,8) = cc(8,11)

      cc(11,9) = cc(9,11)

      cc(11,10) = cc(10,11)

      cc(11,11) = -omega**2*g_m(j,k)* h**2 /3.d0 
     1          + aim * omega * b_m(j,k)* h**2 /3.d0
     1          + xmw_m(j,k) 
     1          +deltab(k) * aim * omega* h * b(3,3) 
     1          + (1.d0-deltab(k))*aim * omega* betab(3,3,j,k) * h

      cc(11,12) = -omega**2*g_m(j,k)* (-h**2 /6.d0)  
     1          - aim * omega * b_m(j,k)* h**2 /6.d0
     1          + xmw_m(j,k)

    
       
* coefficients for   t - equation (for n comp.)

      cc(12,1) = cc(1,12)

      cc(12,2) = cc(2,12)

      cc(12,3) = cc(3,12)

      cc(12,4) = cc(4,12)

      cc(12,5) = cc(5,12)

      cc(12,6) = cc(6,12)

      cc(12,7) = cc(7,12)

      cc(12,8) = cc(8,12)

      cc(12,9) = cc(9,12)

      cc(12,10) = cc(10,12)

      cc(12,11) = cc(11,12)

      cc(12,12) = -omega**2*g_m(j,k)* h**2 /3.d0 
     1          + aim * omega * b_m(j,k)* h**2 /3.d0
     1          + xmw_m(j,k) 
     1          +deltat(k) * aim * omega* h * b(3,3) 
     1          + (1.d0-deltat(k))*aim * omega* betat(3,3,j,k) * h

   
      
     

c                   if(j.eq.2.and.k.eq.2)then
c       write(28,6544) j,k,jw
c6544   format(1x,'j=',i5,3x,'k=',i5,'jw=',i5)
c       write(28,*) 'parte real'
c        do 2390 m=1,16
c            write(28,6390)(dreal(cc(m,n)),n=1,16)
c2390   continue
c6390      format(8e20.12/)
c       write(28,5666)
c5666  format(/1x,'parte imaginaria')
c      do 2394 m=1,16
c            write(28,6390)(dimag(cc(m,n)),n=1,16)
c2394   continue
c            endif


          call factorlu(cc,cc_lu,j,k)

1003      continue

	  
          return
             end
******************************************************************
      subroutine abc_beta(j,k,betal,betar,betab,betat,
     1                    rhob_m,rhof,
     1                    xlamcw_m,xnw_m,bw_m,xmw_m,
     1                    g_m,b)
       include 'sizes'

      implicit double precision (a-h,o-z)

      real*8  rhob_m(0:mnx+1,0:mny+1),rhof(0:mnx+1,0:mny+1)
      complex*16  xlamcw_m(0:mnx+1,0:mny+1)
      complex*16  xnw_m(0:mnx+1,0:mny+1)
      complex*16  bw_m(0:mnx+1,0:mny+1)
      complex*16  xmw_m(0:mnx+1,0:mny+1)
      real*8  g_m(0:mnx+1,0:mny+1)
      real*8 betal(3,3,mnx,mny),betar(3,3,mnx,mny)
      real*8 betab(3,3,mnx,mny),betat(3,3,mnx,mny)
      real*8 b(3,3),a(3,3),e(3,3),asq(3,3),asqo(3,3)
      real*8 ssq(3,3),ae(3,3),s(3,3),sa(3,3)
      real*8 b1(3,3),b2(3,3),b3(3,3),b4(3,3)

c
c     end dimension statements
c

c coef para la condicion de borde absorbente

        ro_hat  = rhob_m(j,k)-rhof(j,k)*rhof(j,k)/g_m(j,k)

c Starts calculation of iteration matrices betal,betar,betat,betab
c  matriz  a dep. de frecuencia 
      
c Center calculation (j,k)

c  matriz  a dep. de frecuencia 
      
        do i1=1,3
        do j1=1,3
        a(i1,j1)=0.d0
        enddo
        enddo


        a(1,1)=rhob_m(j,k)
        a(1,3)=rhof(j,k)
        a(2,2)=ro_hat
        a(3,1)=a(1,3)
        a(3,3)=g_m(j,k)
            
c procedimiento para calcular la raiz cuadrada de la matriz
       n=3

      call wurzel(n,a,asq)

c calculo de s, se necesita la inversa de asq
c guardo asq en asqo
      do i1=1,3
      do j1=1,3
      asqo(i1,j1)=asq(i1,j1)
      enddo
      enddo
c procedimiento para calcular la inversa

      call invert(n,asq)

c  matriz e usando coef. viscoelasticos
      
        do i1=1,3
        do j1=1,3
        e(i1,j1)=0.d0
       enddo
       enddo
       e(1,1)=dreal(xlamcw_m(j,k))+2.d0*dreal(xnw_m(j,k))
       e(1,3)=dreal(bw_m(j,k))
       e(2,2)=dreal(xnw_m(j,k))
       e(3,1)=e(1,3)
       e(3,3)=dreal(xmw_m(j,k))      
      
     
      
c calculo ae = a**{-1/2}*e 
      do i1=1,3
      do j1=1,3
      sum=0.d0
      do k1=1,3
      sum=sum+asq(i1,k1)*e(k1,j1)
      enddo
      ae(i1,j1)=sum
      enddo
      enddo
c calculo  s = ae*asq = a**{-1/2}*e*a**{-1/2} = d del latex file  
      do i1=1,3
      do j1=1,3
      sum=0.d0
      do k1=1,3
      sum=sum+ae(i1,k1)*asq(k1,j1)
      enddo
      s(i1,j1)=sum
      enddo
      enddo

       
c calculo raiz cuadrada de s
    

           
      call wurzel(n,s,ssq)
c calculo asqo*ssq
      do i1=1,3
      do j1=1,3
      sum=0.d0
      do k1=1,3
      sum=sum+asqo(i1,k1)*ssq(k1,j1)
      enddo
      sa(i1,j1)=sum
      enddo
      enddo
c calculo de b, sa*asqo
      do i1=1,3
      do j1=1,3
      sum=0.d0
      do k1=1,3
      sum=sum+sa(i1,k1)*asqo(k1,j1)
      enddo
      b(i1,j1)=sum
      enddo
      enddo
       

       

c Left boundary (j-1,k)
           
         ro_hat  = rhob_m(j-1,k)-rhof(j-1,k)*rhof(j-1,k)/g_m(j-1,k)

        a(1,1)=rhob_m(j-1,k)
        a(1,3)=rhof(j-1,k)
        a(2,2)=ro_hat
        a(3,1)=a(1,3)
        a(3,3)=g_m(j-1,k)
            

c  matriz e usando coef. viscoelasticos
      
       e(1,1)=dreal(xlamcw_m(j-1,k))+2.d0*dreal(xnw_m(j-1,k))
       e(1,3)=dreal(bw_m(j-1,k))
       e(2,2)=dreal(xnw_m(j-1,k))
       e(3,1)=e(1,3)
       e(3,3)=dreal(xmw_m(j-1,k))
        

c procedimiento para calcular la raiz cuadrada de la matriz
       n=3

      call wurzel(n,a,asq)

c calculo de s, se necesita la inversa de asq
c guardo asq en asqo
      do i1=1,3
      do j1=1,3
      asqo(i1,j1)=asq(i1,j1)
      enddo
      enddo
c procedimiento para calcular la inversa

      call invert(n,asq)
c calculo ae = a**{-1/2}*e 
      do i1=1,3
      do j1=1,3
      sum=0.d0
      do k1=1,3
      sum=sum+asq(i1,k1)*e(k1,j1)
      enddo
      ae(i1,j1)=sum
      enddo
      enddo
c calculo  s = ae*asq = a**{-1/2}*e*a**{-1/2} = d del latex file  
      do i1=1,3
      do j1=1,3
      sum=0.d0
      do k1=1,3
      sum=sum+ae(i1,k1)*asq(k1,j1)
      enddo
      s(i1,j1)=sum
      enddo
      enddo
c calculo raiz cuadrada de s


           
      call wurzel(n,s,ssq)

c calculo asqo*ssq
      do i1=1,3
      do j1=1,3
      sum=0.d0
      do k1=1,3
      sum=sum+asqo(i1,k1)*ssq(k1,j1)
      enddo
      sa(i1,j1)=sum
      enddo
      enddo
c calculo de b1, sa*asqo
      do i1=1,3
      do j1=1,3
      sum=0.d0
      do k1=1,3
      sum=sum+sa(i1,k1)*asqo(k1,j1)
      enddo
      b1(i1,j1)=sum
      enddo
      enddo
      

c Right boundary (j+1,k)
      ro_hat  = rhob_m(j+1,k)-rhof(j+1,k)*rhof(j+1,k)/g_m(j+1,k)

        a(1,1)=rhob_m(j+1,k)
        a(1,3)=rhof(j+1,k)
        a(2,2)=ro_hat
        a(3,1)=a(1,3)
        a(3,3)=g_m(j+1,k)
       
            

c  matriz e usando coef. viscoelasticos
      
       e(1,1)=dreal(xlamcw_m(j+1,k))+2.d0*dreal(xnw_m(j+1,k))
       e(1,3)=dreal(bw_m(j+1,k))
       e(2,2)=dreal(xnw_m(j+1,k))
       e(3,1)=e(1,3)
       e(3,3)=dreal(xmw_m(j+1,k))
       

c procedimiento para calcular la raiz cuadrada de la matriz
       n=3

      call wurzel(n,a,asq)

c calculo de s, se necesita la inversa de asq
c guardo asq en asqo
      do i1=1,3
      do j1=1,3
      asqo(i1,j1)=asq(i1,j1)
      enddo
      enddo
c procedimiento para calcular la inversa

      call invert(n,asq)
c calculo ae = a**{-1/2}*e 
      do i1=1,3
      do j1=1,3
      sum=0.d0
      do k1=1,3
      sum=sum+asq(i1,k1)*e(k1,j1)
      enddo
      ae(i1,j1)=sum
      enddo
      enddo
c calculo  s = ae*asq = a**{-1/2}*e*a**{-1/2} = d del latex file  
      do i1=1,3
      do j1=1,3
      sum=0.d0
      do k1=1,3
      sum=sum+ae(i1,k1)*asq(k1,j1)
      enddo
      s(i1,j1)=sum
      enddo
      enddo
c calculo raiz cuadrada de s


           
      call wurzel(n,s,ssq)

c calculo asqo*ssq
      do i1=1,3
      do j1=1,3
      sum=0.d0
      do k1=1,3
      sum=sum+asqo(i1,k1)*ssq(k1,j1)
      enddo
      sa(i1,j1)=sum
      enddo
      enddo
c calculo de b2, sa*asqo
      do i1=1,3
      do j1=1,3
      sum=0.d0
      do k1=1,3
      sum=sum+sa(i1,k1)*asqo(k1,j1)
      enddo
      b2(i1,j1)=sum
      enddo
      enddo
      

c Bottom boundary (j,k-1)
       ro_hat  = rhob_m(j,k-1)-rhof(j,k-1)*rhof(j,k-1)/g_m(j,k-1)

        a(1,1)=rhob_m(j,k-1)
        a(1,3)=rhof(j,k-1)
        a(2,2)=ro_hat
        a(3,1)=a(1,3)
        a(3,3)=g_m(j,k-1)
        
            

c  matriz e usando coef. viscoelasticos
      
       e(1,1)=dreal(xlamcw_m(j,k-1))+2.d0*dreal(xnw_m(j,k-1))
       e(1,3)=dreal(bw_m(j,k-1))
       e(2,2)=dreal(xnw_m(j,k-1))
       e(3,1)=e(1,3)
       e(3,3)=dreal(xmw_m(j,k-1))
        
c procedimiento para calcular la raiz cuadrada de la matriz
       n=3

      call wurzel(n,a,asq)
c calculo de s, se necesita la inversa de asq
c guardo asq en asqo
      do i1=1,3
      do j1=1,3
      asqo(i1,j1)=asq(i1,j1)
      enddo
      enddo
c procedimiento para calcular la inversa

      call invert(n,asq)
c calculo ae = a**{-1/2}*e 
      do i1=1,3
      do j1=1,3
      sum=0.d0
      do k1=1,3
      sum=sum+asq(i1,k1)*e(k1,j1)
      enddo
      ae(i1,j1)=sum
      enddo
      enddo
c calculo  s = ae*asq = a**{-1/2}*e*a**{-1/2} = d del latex file  
      do i1=1,3
      do j1=1,3
      sum=0.d0
      do k1=1,3
      sum=sum+ae(i1,k1)*asq(k1,j1)
      enddo
      s(i1,j1)=sum
      enddo
      enddo
c calculo raiz cuadrada de s
          
      call wurzel(n,s,ssq)
c calculo asqo*ssq
      do i1=1,3
      do j1=1,3
      sum=0.d0
      do k1=1,3
      sum=sum+asqo(i1,k1)*ssq(k1,j1)
      enddo
      sa(i1,j1)=sum
      enddo
      enddo
c calculo de b3, sa*asqo
      do i1=1,3
      do j1=1,3
      sum=0.d0
      do k1=1,3
      sum=sum+sa(i1,k1)*asqo(k1,j1)
      enddo
      b3(i1,j1)=sum
      enddo
      enddo
      

c Top boundary (j,k+1)
        ro_hat  = rhob_m(j,k+1)-rhof(j,k+1)*rhof(j,k+1)/g_m(j,k+1)
       
        a(1,1)=rhob_m(j,k+1)
        a(1,3)=rhof(j,k+1)
        a(2,2)=ro_hat
        a(3,1)=a(1,3)
        a(3,3)=g_m(j,k+1)
        
            

c  matriz e usando coef. viscoelasticos
      
       e(1,1)=dreal(xlamcw_m(j,k+1))+2.d0*dreal(xnw_m(j,k+1))
       e(1,3)=dreal(bw_m(j,k+1))
       e(2,2)=dreal(xnw_m(j,k+1))
       e(3,1)=e(1,3)
       e(3,3)=dreal(xmw_m(j,k+1))
        
c procedimiento para calcular la raiz cuadrada de la matriz
       n=3

      call wurzel(n,a,asq)

c calculo de s, se necesita la inversa de asq
c guardo asq en asqo
      do i1=1,3
      do j1=1,3
      asqo(i1,j1)=asq(i1,j1)
      enddo
      enddo
c procedimiento para calcular la inversa

      call invert(n,asq)
c calculo ae = a**{-1/2}*e 
      do i1=1,3
      do j1=1,3
      sum=0.d0
      do k1=1,3
      sum=sum+asq(i1,k1)*e(k1,j1)
      enddo
      ae(i1,j1)=sum
      enddo
      enddo
c calculo  s = ae*asq = a**{-1/2}*e*a**{-1/2} = d del latex file  
      do i1=1,3
      do j1=1,3
      sum=0.d0
      do k1=1,3
      sum=sum+ae(i1,k1)*asq(k1,j1)
      enddo
      s(i1,j1)=sum
      enddo
      enddo
c calculo raiz cuadrada de s


           
      call wurzel(n,s,ssq)
c calculo asqo*ssq
      do i1=1,3
      do j1=1,3
      sum=0.d0
      do k1=1,3
      sum=sum+asqo(i1,k1)*ssq(k1,j1)
      enddo
      sa(i1,j1)=sum
      enddo
      enddo
c calculo de b4, sa*asqo
      do i1=1,3
      do j1=1,3
      sum=0.d0
      do k1=1,3
      sum=sum+sa(i1,k1)*asqo(k1,j1)
      enddo
      b4(i1,j1)=sum
      enddo
      enddo
      

       


         do mm=1,3
         do nn=1,3
         betal(mm,nn,j,k)=0.5d0*(b(mm,nn)+b1(mm,nn))
         betar(mm,nn,j,k)=0.5d0*(b(mm,nn)+b2(mm,nn))      
         betab(mm,nn,j,k)=0.5d0*(b(mm,nn)+b3(mm,nn))     
         betat(mm,nn,j,k)=0.5d0*(b(mm,nn)+b4(mm,nn))
         enddo
         enddo
	 return
	 end


*******************************************************************
      subroutine wurzel(n,a,r)
      implicit double precision(a-h,o-z)
      real*8 a(3,3), rr(3), r(3,3)
      theta=0.9999d0
      eps=1.d-10
      maxiter=1000
c determinacion de c
       c=0.d0
       do i=1,n
       s=0.d0
       do j=1,n
       s=s+dabs(a(i,j))
       enddo
       if(c.lt.s) c=s
       enddo
       c=.5d0*theta/dsqrt(c)
c establece ro
      do i=1,n
      do j=1,n
      r(i,j)=2.d0*c*a(i,j)
      r(j,i)=r(i,j)
      enddo
      enddo
c comienza iteracion
      do ii=1,maxiter
      delta=0.d0
      do i=1,n
      do j=1,n
      s=0.d0
      do k=1,n
      s=s-r(i,k)*r(k,j)
      enddo
      rr(j)=r(i,j)+c*(a(i,j)+s)
      enddo
      do j=i,n
      s=dabs(r(i,j)-rr(j))
      if(s.gt.delta) delta=s
      r(i,j)=rr(j)
      enddo
      enddo
      do i=1,n-1
      do j=i+1,n
      r(j,i)=r(i,j)
      enddo
      enddo
      if(delta.lt.eps) go to 777
      enddo
c     imprime
777    continue
c       write(*,*) 'iter',ii
c       do kk=1,n
c       write(*,*) (r(kk,k),k=1,n)
c       enddo
        return
        end
****************************************************************
      subroutine invert(n,a)
      implicit double precision(a-h,o-z)
      real*8 a(3,3), baux(3), caux(3)
c
      n1=n-1
      a(1,1)=1.d0/a(1,1)
      do 11 m=1,n1
      k=m+1
1      do 3 i=1,m
       sum=0.d0
       do 2 j=1,m
2      sum=sum+a(i,j)*a(j,k)
3      baux(i)=sum
      d=0.d0
      do 4 i=1,m
4     d=d+a(k,i)*baux(i)
c      d=d+a(k,k)
      d=-d+a(k,k)
      a(k,k)=1.d0/d
      do 5 i=1,m
5     a(i,k)=-baux(i)*a(k,k)
      do 7 j=1,m
      sum=0.d0
      do 6 i=1,m
6     sum=sum+a(k,i)*a(i,j)
7     caux(j)=sum
      do 8 j=1,m
8     a(k,j)=-caux(j)*a(k,k)
      do 10 i=1,m
      do 9 j=1,m
9     a(i,j)=a(i,j)-baux(i)*a(k,j)
10    continue
11    continue
c
c       write(*,*) 'matriz inversa'
c       do kk=1,n
c       write(*,*) (a(kk,k),k=1,n)
c       enddo
        return 
         end	       
************************************************************************
          subroutine   factorlu(ma,cc_lu,j,k)
       include 'sizes'
              implicit double precision (a-h,o-z)
      integer x,y,z,zp
          complex*16   ma(12,12),cc_lu(12,12,mnx,mny)
c
c  l-u  factorization
c
c   nd = number of unknowns(=16)
c   ndm = nd -1
        nd = 12 
        ndm = nd -1
    
      do z=1,ndm
       zp=z+1
       do x=zp,nd
        do y=zp,nd
         ma(x,y)=ma(x,y)-ma(x,z)/ma(z,z)*ma(z,y)
        enddo
        ma(x,z)=ma(x,z)/ma(z,z)
       enddo
      enddo
      do x=1,nd
      do y=1,nd
         cc_lu(x,y,j,k)=ma(x,y)
      enddo
      enddo	 

             return
                 end	
******************************************************************************************

        subroutine    save_u(nx,ny,u1ln,u1tn,u1bn,u1rn,
     1                      lag1ln,lag1tn,lag1bn,lag1rn,
     1                      u2ln,u2tn,u2bn,u2rn,
     1                      lag2ln,lag2tn,lag2bn,lag2rn,
     1                      unln,untn,unbn,unrn,
     1                      lagnln,lagntn,lagnbn,lagnrn,
     1                      u1lnp1,u1tnp1,u1bnp1,u1rnp1,
     1                      lag1lnp1,lag1tnp1,lag1bnp1,lag1rnp1,
     1                      u2lnp1,u2tnp1,u2bnp1,u2rnp1,
     1                      lag2lnp1,lag2tnp1,lag2bnp1,lag2rnp1,
     1                      unlnp1,untnp1,unbnp1,unrnp1,
     1                      lagnlnp1,lagntnp1,lagnbnp1,lagnrnp1)
       include 'sizes'
      implicit double precision (a-h,o-z)

c
c    solutions ubl , utl , ubr and utr for both solid 
c    components and   unl, unr, unb, unt,  
c    for wetting and nonwetting  phases  at iteration  levels   n 
c     and   n+1

      complex*16 u1ln(0:mnx+1,0:mny+1),u1tn(0:mnx+1,0:mny+1),
     1           u1bn(0:mnx+1,0:mny+1)
      complex*16 u1rn(0:mnx+1,0:mny+1)
      complex*16 u2ln(0:mnx+1,0:mny+1),u2tn(0:mnx+1,0:mny+1),
     1           u2bn(0:mnx+1,0:mny+1)
      complex*16 u2rn(0:mnx+1,0:mny+1)

      complex*16 unln(0:mnx+1,0:mny+1),untn(0:mnx+1,0:mny+1),
     1           unbn(0:mnx+1,0:mny+1)
      complex*16 unrn(0:mnx+1,0:mny+1)
    

      complex*16 u1lnp1(0:mnx+1,0:mny+1),u1tnp1(0:mnx+1,0:mny+1),
     1           u1bnp1(0:mnx+1,0:mny+1)
      complex*16 u1rnp1(0:mnx+1,0:mny+1)
      complex*16 u2lnp1(0:mnx+1,0:mny+1),u2tnp1(0:mnx+1,0:mny+1),
     1           u2bnp1(0:mnx+1,0:mny+1)
      complex*16 u2rnp1(0:mnx+1,0:mny+1)

      complex*16 unlnp1(0:mnx+1,0:mny+1),untnp1(0:mnx+1,0:mny+1),
     1           unbnp1(0:mnx+1,0:mny+1)
      complex*16 unrnp1(0:mnx+1,0:mny+1)
     
c
c   lagrange  multipliers  parameters  lag1l, lag1b , lag1r, lag1t 
c                                      lag2l, lag2b , lag2r, lag2t
c                                      lagnl, lagnb , lagnr, lagnt 
c                                     
c
c    levels   n   and   n+1
      complex*16 lag1ln(0:mnx+1,0:mny+1),lag1tn(0:mnx+1,0:mny+1),
     1           lag1bn(0:mnx+1,0:mny+1),lag1rn(0:mnx+1,0:mny+1)

      complex*16 lag2ln(0:mnx+1,0:mny+1),lag2tn(0:mnx+1,0:mny+1),
     1           lag2bn(0:mnx+1,0:mny+1),lag2rn(0:mnx+1,0:mny+1)

      complex*16 lagnln(0:mnx+1,0:mny+1),lagntn(0:mnx+1,0:mny+1),
     1           lagnbn(0:mnx+1,0:mny+1),lagnrn(0:mnx+1,0:mny+1)

    
c
      complex*16 lag1lnp1(0:mnx+1,0:mny+1),lag1tnp1(0:mnx+1,0:mny+1),
     1           lag1bnp1(0:mnx+1,0:mny+1),lag1rnp1(0:mnx+1,0:mny+1)

      complex*16 lag2lnp1(0:mnx+1,0:mny+1),lag2tnp1(0:mnx+1,0:mny+1),
     1           lag2bnp1(0:mnx+1,0:mny+1),lag2rnp1(0:mnx+1,0:mny+1)

      complex*16 lagnlnp1(0:mnx+1,0:mny+1),lagntnp1(0:mnx+1,0:mny+1),
     1           lagnbnp1(0:mnx+1,0:mny+1),lagnrnp1(0:mnx+1,0:mny+1)

     

            do  j=0,nx+1
            do  k=0,ny+1
          u1lnp1(j,k) =  u1ln(j,k)
          u1tnp1(j,k) =  u1tn(j,k)
          u1bnp1(j,k) =  u1bn(j,k)
          u1rnp1(j,k) =  u1rn(j,k)
          u2lnp1(j,k) =  u2ln(j,k)
          u2tnp1(j,k) =  u2tn(j,k)
          u2bnp1(j,k) =  u2bn(j,k)
          u2rnp1(j,k) =  u2rn(j,k)

          unlnp1(j,k) =  unln(j,k)
          untnp1(j,k) =  untn(j,k)
          unbnp1(j,k) =  unbn(j,k)
          unrnp1(j,k) =  unrn(j,k)
         

          lag1lnp1(j,k) = lag1ln(j,k)
          lag1tnp1(j,k) = lag1tn(j,k)
          lag2lnp1(j,k) = lag2ln(j,k)
          lag2tnp1(j,k) = lag2tn(j,k)
          lag1bnp1(j,k) = lag1bn(j,k)
          lag1rnp1(j,k) = lag1rn(j,k)
          lag2bnp1(j,k) = lag2bn(j,k)
          lag2rnp1(j,k) = lag2rn(j,k)

          lagnlnp1(j,k) = lagnln(j,k)
          lagntnp1(j,k) = lagntn(j,k)
          lagnbnp1(j,k) = lagnbn(j,k)
          lagnrnp1(j,k) = lagnrn(j,k)

         
           enddo
           enddo

           return
           end
*****************************************************************************************

        subroutine     relax(nx,ny,u1ln,u1tn,u1bn,u1rn,
     1                      lag1ln,lag1tn,lag1bn,lag1rn,
     1                      u2ln,u2tn,u2bn,u2rn,
     1                      lag2ln,lag2tn,lag2bn,lag2rn,
     1                      unln,untn,unbn,unrn,
     1                      lagnln,lagntn,lagnbn,lagnrn,
     1                      u1lnp1,u1tnp1,u1bnp1,u1rnp1,
     1                      lag1lnp1,lag1tnp1,lag1bnp1,lag1rnp1,
     1                      u2lnp1,u2tnp1,u2bnp1,u2rnp1,
     1                      lag2lnp1,lag2tnp1,lag2bnp1,lag2rnp1,
     1                      unlnp1,untnp1,unbnp1,unrnp1,
     1                      lagnlnp1,lagntnp1,lagnbnp1,lagnrnp1)

       include 'sizes'
      implicit double precision (a-h,o-z)

c
c    solutions ubl , utl , ubr and utr for both solid 
c    components and   unl, unr, unb, unt, 
c    for wetting and nonwetting  phases  at iteration  levels   n 
c     and   n+1

      complex*16 u1ln(0:mnx+1,0:mny+1),u1tn(0:mnx+1,0:mny+1),
     1           u1bn(0:mnx+1,0:mny+1)
      complex*16 u1rn(0:mnx+1,0:mny+1)
      complex*16 u2ln(0:mnx+1,0:mny+1),u2tn(0:mnx+1,0:mny+1),
     1           u2bn(0:mnx+1,0:mny+1)
      complex*16 u2rn(0:mnx+1,0:mny+1)

      complex*16 unln(0:mnx+1,0:mny+1),untn(0:mnx+1,0:mny+1),
     1           unbn(0:mnx+1,0:mny+1)
      complex*16 unrn(0:mnx+1,0:mny+1)
     

      complex*16 u1lnp1(0:mnx+1,0:mny+1),u1tnp1(0:mnx+1,0:mny+1),
     1           u1bnp1(0:mnx+1,0:mny+1)
      complex*16 u1rnp1(0:mnx+1,0:mny+1)
      complex*16 u2lnp1(0:mnx+1,0:mny+1),u2tnp1(0:mnx+1,0:mny+1),
     1           u2bnp1(0:mnx+1,0:mny+1)
      complex*16 u2rnp1(0:mnx+1,0:mny+1)

      complex*16 unlnp1(0:mnx+1,0:mny+1),untnp1(0:mnx+1,0:mny+1),
     1           unbnp1(0:mnx+1,0:mny+1)
      complex*16 unrnp1(0:mnx+1,0:mny+1)
     
c
c   lagrange  multipliers  parameters  lag1l, lag1b , lag1r, lag1t 
c                                      lag2l, lag2b , lag2r, lag2t
c                                      lagnl, lagnb , lagnr, lagnt 
c                                    
c
c    levels   n   and   n+1
      complex*16 lag1ln(0:mnx+1,0:mny+1),lag1tn(0:mnx+1,0:mny+1),
     1           lag1bn(0:mnx+1,0:mny+1),lag1rn(0:mnx+1,0:mny+1)

      complex*16 lag2ln(0:mnx+1,0:mny+1),lag2tn(0:mnx+1,0:mny+1),
     1           lag2bn(0:mnx+1,0:mny+1),lag2rn(0:mnx+1,0:mny+1)

      complex*16 lagnln(0:mnx+1,0:mny+1),lagntn(0:mnx+1,0:mny+1),
     1           lagnbn(0:mnx+1,0:mny+1),lagnrn(0:mnx+1,0:mny+1)

     
c
      complex*16 lag1lnp1(0:mnx+1,0:mny+1),lag1tnp1(0:mnx+1,0:mny+1),
     1           lag1bnp1(0:mnx+1,0:mny+1),lag1rnp1(0:mnx+1,0:mny+1)

      complex*16 lag2lnp1(0:mnx+1,0:mny+1),lag2tnp1(0:mnx+1,0:mny+1),
     1           lag2bnp1(0:mnx+1,0:mny+1),lag2rnp1(0:mnx+1,0:mny+1)

      complex*16 lagnlnp1(0:mnx+1,0:mny+1),lagntnp1(0:mnx+1,0:mny+1),
     1           lagnbnp1(0:mnx+1,0:mny+1),lagnrnp1(0:mnx+1,0:mny+1)

      


               factor=.5d0


            do  j=1,nx
            do  k=1,ny
          u1ln(j,k) =(1.d0-factor)*u1lnp1(j,k)+u1ln(j,k)*factor
          u1tn(j,k) =(1.d0-factor)*u1tnp1(j,k)+u1tn(j,k)*factor
          u1bn(j,k) =(1.d0-factor)*u1bnp1(j,k)+u1bn(j,k)*factor
          u1rn(j,k) =(1.d0-factor)*u1rnp1(j,k)+u1rn(j,k)*factor
          u2ln(j,k) =(1.d0-factor)*u2lnp1(j,k)+u2ln(j,k)*factor
          u2tn(j,k) =(1.d0-factor)*u2tnp1(j,k)+u2tn(j,k)*factor
          u2bn(j,k) =(1.d0-factor)*u2bnp1(j,k)+u2bn(j,k)*factor
          u2rn(j,k) =(1.d0-factor)*u2rnp1(j,k)+u2rn(j,k)*factor

          unln(j,k) =(1.d0-factor)*unlnp1(j,k)+unln(j,k)*factor
          untn(j,k) =(1.d0-factor)*untnp1(j,k)+untn(j,k)*factor
          unbn(j,k) =(1.d0-factor)*unbnp1(j,k)+unbn(j,k)*factor
          unrn(j,k) =(1.d0-factor)*unrnp1(j,k)+unrn(j,k)*factor

        

      lag1ln(j,k)=(1.d0-factor)*lag1lnp1(j,k)+lag1ln(j,k)*factor
      lag1tn(j,k)=(1.d0-factor)*lag1tnp1(j,k)+lag1tn(j,k)*factor
      lag2ln(j,k)=(1.d0-factor)*lag2lnp1(j,k)+lag2ln(j,k)*factor
      lag2tn(j,k)=(1.d0-factor)*lag2tnp1(j,k)+lag2tn(j,k)*factor
      lag1bn(j,k)=(1.d0-factor)*lag1bnp1(j,k)+lag1bn(j,k)*factor
      lag1rn(j,k)=(1.d0-factor)*lag1rnp1(j,k)+lag1rn(j,k)*factor
      lag2bn(j,k)=(1.d0-factor)*lag2bnp1(j,k)+lag2bn(j,k)*factor
      lag2rn(j,k)=(1.d0-factor)*lag2rnp1(j,k)+lag2rn(j,k)*factor


      lagnln(j,k)=(1.d0-factor)*lagnlnp1(j,k)+lagnln(j,k)*factor
      lagntn(j,k)=(1.d0-factor)*lagntnp1(j,k)+lagntn(j,k)*factor
      lagnbn(j,k)=(1.d0-factor)*lagnbnp1(j,k)+lagnbn(j,k)*factor
      lagnrn(j,k)=(1.d0-factor)*lagnrnp1(j,k)+lagnrn(j,k)*factor

    
         enddo
         enddo
          return
           end


	       
****************************************************************************************

        
         subroutine snap_freq(jjw,iwsnap,nwsnap,nx,ny,omega,u2ln,
     1                        u2tn,u2bn,u2rn,unbn,untn,
     1                       u1ln,u1tn,u1bn,u1rn,unln,unrn)

       include 'sizes'
      implicit double precision (a-h,o-z)

c
c    solutions  ubr and utr for both solid 
c    components  and unb, unt,  
c    for wetting and nonwetting  phases  at current iteration  level 

        complex*16 u2ln(0:mnx+1,0:mny+1),u2tn(0:mnx+1,0:mny+1),
     1             u2bn(0:mnx+1,0:mny+1)
        complex*16 u2rn(0:mnx+1,0:mny+1)

        complex*16 untn(0:mnx+1,0:mny+1),unbn(0:mnx+1,0:mny+1)
        complex*16 u1ln(0:mnx+1,0:mny+1),u1tn(0:mnx+1,0:mny+1),
     1             u1bn(0:mnx+1,0:mny+1)
        complex*16 u1rn(0:mnx+1,0:mny+1)

        complex*16 unln(0:mnx+1,0:mny+1),unrn(0:mnx+1,0:mny+1)

        
        real*8 omega
        complex*16 aim,avsol1,avsol2
        integer nx,ny,iw,nwsnap,iwsnap(10),jjw


       aim=dcmplx(0.d0,1.d0)
          do  iw=1,nwsnap
           if(jjw.eq.iwsnap(iw)) then


	    
c   writes snapshots in frequency ( solution for a specified frequency, 
c   real  part of the vertical components of the
c   solid and two fluid phases 
c   in 7, 8, 9, so that no more than 
c   1  snapshots  in frequency would be required in the input file



             do   j=1,nx
             do  k=1,ny

1482   format(e15.5)


             avsol2 =   .25d0* (u2ln(j,k)  +
     1                        u2tn(j,k)  +
     1                        u2bn(j,k)  +
     1                        u2rn(j,k)     )

            if(cdabs(avsol2).lt.1.e-14) avsol2 = dcmplx(0.d0,0.d0)
	    
	     write(7+iw-1,1482)dreal(aim*omega*avsol2)
             enddo
             enddo


             do   j=1,nx
             do  k=1,ny

              avsol1 =   .5d0* (-unbn(j,k)  +
     1                        untn(j,k)   )

       if(cdabs(avsol1).lt.1.e-14) avsol1 = dcmplx(0.d0,0.d0)
             
	     write(8+iw-1,1482)dreal(aim*omega*avsol1) 

             enddo
             enddo

    
       

            endif
	    
            enddo
 
        iii=-1
        if(iii.eq.1) then
            write(25,*)' promedios de u1 luego que converge'
              write(25,*)
             do k=1,ny
             write(25,1459)(dreal(.25d0* (u1ln(j,k)  +
     1                           u1tn(j,k)  +
     1                           u1bn(j,k)  +
     1                           u1rn(j,k)     )),j=1,nx)
             enddo

             write(26,*)' promedios de u2 luego que converge'
              write(26,*)
             do k=1,ny
             write(26,1459)(dreal(.25d0* (u2ln(j,k)  +
     1                           u2tn(j,k)  +
     1                           u2bn(j,k)  +
     1                           u2rn(j,k)     )),j=1,nx)
             enddo

             write(27,*)' promedios de un_x luego que converge'
              write(27,*)
             do k=1,ny
             write(27,1459)(dreal(.5d0* (-unln(j,k)  
     1                                + unrn(j,k) ) ),j=1,nx)
             enddo

             write(27,*)' promedios de un_z luego que converge'
              write(27,*)
             do k=1,ny
             write(27,1459)(dreal(.5d0* (-unbn(j,k)  
     1                                + untn(j,k) ) ),j=1,nx)
             enddo
             endif
1459         format(7g15.5/)
            return
             end
**********************************************************************
       subroutine   solvb(nx,ny,jw,u1ln,u1tn,u1bn,u1rn,
     1                    lag1ln,lag1tn,lag1bn,lag1rn,
     1                    u2ln,u2tn,u2bn,u2rn,
     1                    lag2ln,lag2tn,lag2bn,lag2rn,
     1                    unln,untn,unbn,unrn,
     1                    lagnln,lagntn,lagnbn,lagnrn,
     1                    omega,
     1                    betal,betar,betab,betat,h,kdel,
     1                    jsou,ksou,fsour,cc_lu,
     1                    deltal,deltar,deltab,deltat,isourid)
      include 'sizes'


      complex*16 fsour(mlsour),cc_lu(12,12,mnx,mny)
      complex*16 cr(12),answer(12)
      real*8  deltal(mnx),deltar(mnx),deltat(mny),deltab(mny)
      integer blockid,vblockid,blockty,ncontrol,nsx,nsy
      common/a1/ncontrol,blockid,vblockid(2),blockty,nsx,nsy
      
      integer nx,ny,jw,kdel,jsou,ksou,isourid,j,k
      real*8 omega,h       
c
c  Iteration  matrix coefficients  beta
c
      real*8 betal(3,3,mnx,mny),betar(3,3,mnx,mny)
      real*8 betab(3,3,mnx,mny),betat(3,3,mnx,mny)
c
c    Solutions ubl , utl , ubr and utr for both solid 
c    components and   unl, unr, unb, unt 
c    for wetting and nonwetting  phases  at iteration   n 
c
      complex*16 u1ln(0:mnx+1,0:mny+1),u1tn(0:mnx+1,0:mny+1),
     1           u1bn(0:mnx+1,0:mny+1),u1rn(0:mnx+1,0:mny+1)
c
      complex*16 u2ln(0:mnx+1,0:mny+1),u2tn(0:mnx+1,0:mny+1),
     1           u2bn(0:mnx+1,0:mny+1),u2rn(0:mnx+1,0:mny+1)
c
      complex*16 unln(0:mnx+1,0:mny+1),untn(0:mnx+1,0:mny+1),
     1           unbn(0:mnx+1,0:mny+1),unrn(0:mnx+1,0:mny+1)
c
      
c
c   Lagrange  multipliers  parameters  lag1l, lag1b, lag1r, , lag1t ,
c                                      lag2l, lag2b , lag2r, , lag2t
c                                      lagnl, lagnb , lagnr, , lagnt ,
c                                     

c     at iteration   level  n 
c
c
      complex*16 lag1ln(0:mnx+1,0:mny+1),lag1tn(0:mnx+1,0:mny+1),
     1           lag1bn(0:mnx+1,0:mny+1),lag1rn(0:mnx+1,0:mny+1)

      complex*16 lag2ln(0:mnx+1,0:mny+1),lag2tn(0:mnx+1,0:mny+1),
     1           lag2bn(0:mnx+1,0:mny+1),lag2rn(0:mnx+1,0:mny+1)

      complex*16 lagnln(0:mnx+1,0:mny+1),lagntn(0:mnx+1,0:mny+1),
     1           lagnbn(0:mnx+1,0:mny+1),lagnrn(0:mnx+1,0:mny+1)

      

c     end dimension statements
c

	  
          do 1041 j=1,nx,2
          do 1041 k=1,ny,2

*   computes rhs for cell (j,k)

          call         rhs(j,k,cr,u1ln,u1tn,u1bn,u1rn,
     1                    lag1ln,lag1tn,lag1bn,lag1rn,
     1                    u2ln,u2tn,u2bn,u2rn,
     1                    lag2ln,lag2tn,lag2bn,lag2rn,
     1                    unln,untn,unbn,unrn,
     1                    lagnln,lagntn,lagnbn,lagnrn,
     1                    omega,
     1                    betal,betar,betab,betat,h,
     1                    deltal,deltar,deltab,deltat)     
*
*   adds point   source contribution to the  cr  coefficients for the rhs

       call       point_source(j,k,jw,cr,h,kdel,
     1                         jsou,ksou,fsour,isourid)


           call  solve(cc_lu,cr,answer,j,k)

           u1ln(j,k) = answer(1)
           u1bn(j,k) = answer(2)
           u1rn(j,k) = answer(3)
           u1tn(j,k) = answer(4)
           u2ln(j,k) = answer(5)
           u2bn(j,k) = answer(6)
           u2rn(j,k) = answer(7)
           u2tn(j,k) = answer(8)

           unln(j,k) = answer(9)
           unrn(j,k) = answer(10)
           unbn(j,k) = answer(11)
           untn(j,k) = answer(12)

         

c        write(25,*)'B',j,k,u1ln(j,k),u1bn(j,k),u1rn(j,k),u1tn(j,k)
c        write(26,*)'B',j,k,u2ln(j,k),u2bn(j,k),u2rn(j,k),u2tn(j,k)
c        write(27,*)'B',j,k,unln(j,k),unbn(j,k),unrn(j,k),untn(j,k)

c           write(8,6329)j,k,iter,jw
c6329       format(/1x,' solution of 16x16 system  utl,utr,ubl,ubr',
c     1          '  in solv1it for element   ',i2,2x,i2,' iter = ',i5,
c     1          'jw=',i5)
c6399           format(/1x,2e20.8)

c             do m=1,16
c            write(8,6390) dreal(answer(m))
c            write(8,6390) dimag(answer(m))
c             enddo

c                 iii=1
c                   if(iii.eq.1)then
c            write(60,6329)j,k,iter
c            write(60,6399)dreal(u1tlnp1(j,k)),dreal(u1trnp1(j,k))
c            write(60,6399)dreal(u1blnp1(j,k)),dreal(u1brnp1(j,k))
c            write(61,6329)j,k,iter
c            write(61,6399)dimag(u1tlnp1(j,k)),dimag(u1trnp1(j,k))
c            write(61,6399)dimag(u1blnp1(j,k)),dimag(u1brnp1(j,k))
c                  endif

1041       continue

          do 9041 j=2,nx,2
          do 9041 k=2,ny,2
	  
*   computes rhs for cell (j,k)

          call         rhs(j,k,cr,u1ln,u1tn,u1bn,u1rn,
     1                    lag1ln,lag1tn,lag1bn,lag1rn,
     1                    u2ln,u2tn,u2bn,u2rn,
     1                    lag2ln,lag2tn,lag2bn,lag2rn,
     1                    unln,untn,unbn,unrn,
     1                    lagnln,lagntn,lagnbn,lagnrn,
     1                    omega,
     1                    betal,betar,betab,betat,h,
     1                    deltal,deltar,deltab,deltat)     
	  
*
*   adds point   source contribution to the  cr  coefficients for the rhs

       call       point_source(j,k,jw,cr,h,kdel,
     1                         jsou,ksou,fsour,isourid)


c       if(iter.eq.1) then
c            write(60,6329)j,k,iter
c             do m=1,8
c            write(60,6390)dreal(cr(m))
c            write(60,6390)dimag(cr(m))
c             enddo
c        endif

           call  solve(cc_lu,cr,answer,j,k)

           u1ln(j,k) = answer(1)
           u1bn(j,k) = answer(2)
           u1rn(j,k) = answer(3)
           u1tn(j,k) = answer(4)
           u2ln(j,k) = answer(5)
           u2bn(j,k) = answer(6)
           u2rn(j,k) = answer(7)
           u2tn(j,k) = answer(8)

           unln(j,k) = answer(9)
           unrn(j,k) = answer(10)
           unbn(j,k) = answer(11)
           untn(j,k) = answer(12)

        

c        write(25,*)'B',j,k,u1ln(j,k),u1bn(j,k),u1rn(j,k),u1tn(j,k)
c        write(26,*)'B',j,k,u2ln(j,k),u2bn(j,k),u2rn(j,k),u2tn(j,k)
c        write(27,*)'B',j,k,unln(j,k),unbn(j,k),unrn(j,k),untn(j,k)

c           write(8,6329)j,k,iter,jw

c             do m=1,16
c            write(8,6390) dreal(answer(m))
c            write(8,6390) dimag(answer(m))
c             enddo


9041       continue
          return
             end

************************************************************************
       subroutine   solvr(nx,ny,jw,u1ln,u1tn,u1bn,u1rn,
     1                    lag1ln,lag1tn,lag1bn,lag1rn,
     1                    u2ln,u2tn,u2bn,u2rn,
     1                    lag2ln,lag2tn,lag2bn,lag2rn,
     1                    unln,untn,unbn,unrn,
     1                    lagnln,lagntn,lagnbn,lagnrn,
     1                    omega,
     1                    betal,betar,betab,betat,h,kdel,
     1                    jsou,ksou,fsour,cc_lu,
     1                    deltal,deltar,deltab,deltat,isourid)
       include 'sizes'


      complex*16 fsour(mlsour),cc_lu(12,12,mnx,mny)
      complex*16 cr(12),answer(12)
      real*8   deltal(mnx),deltar(mnx),deltat(mny),deltab(mny)
      integer blockid,vblockid,blockty,ncontrol,nsx,nsy
      common/a1/ncontrol,blockid,vblockid(2),blockty,nsx,nsy
      
      integer nx,ny,jw,kdel,jsou,ksou,isourid,j,k
      real*8 omega,h 
c
c  Iteration  matrix coefficients  beta
c
      real*8 betal(3,3,mnx,mny),betar(3,3,mnx,mny)
      real*8 betab(3,3,mnx,mny),betat(3,3,mnx,mny)
c
c    Solutions ubl , utl , ubr and utr for both solid 
c    components and   unl, unr, unb, unt,  
c    for wetting and nonwetting  phases  at iteration   n 
c
      complex*16 u1ln(0:mnx+1,0:mny+1),u1tn(0:mnx+1,0:mny+1),
     1           u1bn(0:mnx+1,0:mny+1),u1rn(0:mnx+1,0:mny+1)
c
      complex*16 u2ln(0:mnx+1,0:mny+1),u2tn(0:mnx+1,0:mny+1),
     1           u2bn(0:mnx+1,0:mny+1),u2rn(0:mnx+1,0:mny+1)

      complex*16 unln(0:mnx+1,0:mny+1),untn(0:mnx+1,0:mny+1),
     1           unbn(0:mnx+1,0:mny+1),unrn(0:mnx+1,0:mny+1)
c
     
c
c   Lagrange  multipliers  parameters  lag1l, lag1b, lag1r, , lag1t ,
c                                      lag2l, lag2b , lag2r, , lag2t
c                                      lagnl, lagnb , lagnr, , lagnt ,
c                                      

c     at iteration   level  n 
c
c
      complex*16 lag1ln(0:mnx+1,0:mny+1),lag1tn(0:mnx+1,0:mny+1),
     1           lag1bn(0:mnx+1,0:mny+1),lag1rn(0:mnx+1,0:mny+1)

      complex*16 lag2ln(0:mnx+1,0:mny+1),lag2tn(0:mnx+1,0:mny+1),
     1           lag2bn(0:mnx+1,0:mny+1),lag2rn(0:mnx+1,0:mny+1)

      complex*16 lagnln(0:mnx+1,0:mny+1),lagntn(0:mnx+1,0:mny+1),
     1           lagnbn(0:mnx+1,0:mny+1),lagnrn(0:mnx+1,0:mny+1)

      

c     end dimension statements
c

          do 1041 j=1,nx,2
          do 1041 k=2,ny,2
	  
          call         rhs(j,k,cr,u1ln,u1tn,u1bn,u1rn,
     1                    lag1ln,lag1tn,lag1bn,lag1rn,
     1                    u2ln,u2tn,u2bn,u2rn,
     1                    lag2ln,lag2tn,lag2bn,lag2rn,
     1                    unln,untn,unbn,unrn,
     1                    lagnln,lagntn,lagnbn,lagnrn,
     1                    omega,
     1                    betal,betar,betab,betat,h,
     1                    deltal,deltar,deltab,deltat) 
         	  

*
*   adds point   source contribution to the  cr  coefficients for the rhs

       call       point_source(j,k,jw,cr,h,kdel,
     1                         jsou,ksou,fsour,isourid)	  

c           write(8,*) 'RHS for element ',j,k
c             do m=1,16
c             write(8,6390)dreal(cr(m))
c             write(8,6390)dimag(cr(m))
c             enddo
c6390      format(8e20.12)
                


c       if(iter.eq.1) then
c            write(60,6329)j,k,iter
c             do m=1,8
c            write(60,6390)dreal(cr(m))
c            write(60,6390)dimag(cr(m))
c             enddo
c        endif

           call  solve(cc_lu,cr,answer,j,k)
	   
           u1ln(j,k) = answer(1)
           u1bn(j,k) = answer(2)
           u1rn(j,k) = answer(3)
           u1tn(j,k) = answer(4)
           u2ln(j,k) = answer(5)
           u2bn(j,k) = answer(6)
           u2rn(j,k) = answer(7)
           u2tn(j,k) = answer(8)

           unln(j,k) = answer(9)
           unrn(j,k) = answer(10)
           unbn(j,k) = answer(11)
           untn(j,k) = answer(12)

         

c        write(25,*)'R',j,k,u1ln(j,k),u1bn(j,k),u1rn(j,k),u1tn(j,k)
c        write(26,*)'R',j,k,u2ln(j,k),u2bn(j,k),u2rn(j,k),u2tn(j,k)
c        write(27,*)'R',j,k,unln(j,k),unbn(j,k),unrn(j,k),untn(j,k)


c           write(8,6329)j,k,iter,jw
c6329       format(/1x,' solution of 16x16 system  utl,utr,ubl,ubr',
c     1          '  in solv1it for element   ',i2,2x,i2,' iter = ',i5,
c     1     'jw=',i5)
c6399           format(/1x,2e20.8)

c             do m=1,16
c            write(8,6390) dreal(answer(m))
c            write(8,6390) dimag(answer(m))
c             enddo


c                 iii=1
c                   if(iii.eq.1)then

c            write(60,6329)j,k,iter
c            write(60,6399)dreal(u1ln(j,k)),dreal(u1rn(j,k))
c            write(60,6399)dreal(u1blnp1(j,k)),dreal(u1brnp1(j,k))

c            write(61,6329)j,k,iter
c            write(61,6399)dimag(u1tlnp1(j,k)),dimag(u1trnp1(j,k))
c            write(61,6399)dimag(u1blnp1(j,k)),dimag(u1brnp1(j,k))

c                  endif

1041       continue


          do 9041 j=2,nx,2
          do 9041 k=1,ny,2
* computes rhs for cell (j,k)
	  
          call         rhs(j,k,cr,u1ln,u1tn,u1bn,u1rn,
     1                    lag1ln,lag1tn,lag1bn,lag1rn,
     1                    u2ln,u2tn,u2bn,u2rn,
     1                    lag2ln,lag2tn,lag2bn,lag2rn,
     1                    unln,untn,unbn,unrn,
     1                    lagnln,lagntn,lagnbn,lagnrn,
     1                    omega,
     1                    betal,betar,betab,betat,h,
     1                    deltal,deltar,deltab,deltat) 	  

*
*   adds point   source contribution to the  cr  coefficients for the rhs

       call       point_source(j,k,jw,cr,h,kdel,
     1                         jsou,ksou,fsour,isourid)	  

                
c         write(8,*) 'jw RHS for element ',jw,j,k
c             do m=1,16
c            write(8,6390)dreal(cr(m))
c            write(8,6390)dimag(cr(m))
c             enddo


c       if(iter.eq.1) then
c            write(60,6329)j,k,iter
c             do m=1,8
c            write(60,6390)dreal(cr(m))
c            write(60,6390)dimag(cr(m))
c             enddo
c        endif

           call  solve(cc_lu,cr,answer,j,k)
	   
           u1ln(j,k) = answer(1)
           u1bn(j,k) = answer(2)
           u1rn(j,k) = answer(3)
           u1tn(j,k) = answer(4)
           u2ln(j,k) = answer(5)
           u2bn(j,k) = answer(6)
           u2rn(j,k) = answer(7)
           u2tn(j,k) = answer(8)

           unln(j,k) = answer(9)
           unrn(j,k) = answer(10)
           unbn(j,k) = answer(11)
           untn(j,k) = answer(12)

          

c          write(25,*)'R',j,k,u1ln(j,k),u1bn(j,k),u1rn(j,k),u1tn(j,k)
c        write(26,*)'R',j,k,u2ln(j,k),u2bn(j,k),u2rn(j,k),u2tn(j,k)
c        write(27,*)'R',j,k,unln(j,k),unbn(j,k),unrn(j,k),untn(j,k)

c            write(8,6329)j,k,iter,jw

c             do m=1,16
c            write(8,6390) dreal(answer(m))
c            write(8,6390) dimag(answer(m))
c             enddo

9041       continue
          return
             end  
***********************************************************************
       subroutine      rhs(j,k,cr,u1ln,u1tn,u1bn,u1rn,
     1                    lag1ln,lag1tn,lag1bn,lag1rn,
     1                    u2ln,u2tn,u2bn,u2rn,
     1                    lag2ln,lag2tn,lag2bn,lag2rn,
     1                    unln,untn,unbn,unrn,
     1                    lagnln,lagntn,lagnbn,lagnrn,
     1                    omega,
     1                    betal,betar,betab,betat,h,
     1                    deltal,deltar,deltab,deltat)
      include 'sizes'
  
      complex*16 cr(12),aim
      real*8  deltal(mnx),deltar(mnx),deltat(mny),deltab(mny)
      real*8 h,omega
      integer j,k
c
c  Iteration  matrix coefficients  beta
c
      real*8 betal(3,3,mnx,mny),betar(3,3,mnx,mny)
      real*8 betab(3,3,mnx,mny),betat(3,3,mnx,mny)
c
c    Solutions ubl , utl , ubr and utr for both solid 
c    components and   unl, unr, unb, unt,  
c    for wetting and nonwetting  phases  at iteration   n 
c
      complex*16 u1ln(0:mnx+1,0:mny+1),u1tn(0:mnx+1,0:mny+1),
     1           u1bn(0:mnx+1,0:mny+1),u1rn(0:mnx+1,0:mny+1)
c
      complex*16 u2ln(0:mnx+1,0:mny+1),u2tn(0:mnx+1,0:mny+1),
     1           u2bn(0:mnx+1,0:mny+1),u2rn(0:mnx+1,0:mny+1)
c
      complex*16 unln(0:mnx+1,0:mny+1),untn(0:mnx+1,0:mny+1),
     1           unbn(0:mnx+1,0:mny+1),unrn(0:mnx+1,0:mny+1)
c
      
c
c   Lagrange  multipliers  parameters  lag1l, lag1b, lag1r, , lag1t ,
c                                      lag2l, lag2b , lag2r, , lag2t
c                                      lagnl, lagnb , lagnr, , lagnt ,
c                                     

c     at iteration   level  n 
c
c
      complex*16 lag1ln(0:mnx+1,0:mny+1),lag1tn(0:mnx+1,0:mny+1),
     1           lag1bn(0:mnx+1,0:mny+1),lag1rn(0:mnx+1,0:mny+1)

      complex*16 lag2ln(0:mnx+1,0:mny+1),lag2tn(0:mnx+1,0:mny+1),
     1           lag2bn(0:mnx+1,0:mny+1),lag2rn(0:mnx+1,0:mny+1)

      complex*16 lagnln(0:mnx+1,0:mny+1),lagntn(0:mnx+1,0:mny+1),
     1           lagnbn(0:mnx+1,0:mny+1),lagnrn(0:mnx+1,0:mny+1)

    
     
c   first executable statement
     
        aim=dcmplx(0.d0,1.d0)
	           
* rhs for  l - equation  (eqn (41) of notes)

      cr(1) = -( lag1rn(j-1,k) 
     1         -aim * omega *betal(1,1,j,k) * u1rn(j-1,k) 
     1         -aim * omega *betal(1,2,j,k) * u2rn(j-1,k)
     1         -aim * omega *betal(1,3,j,k) * unrn(j-1,k)) 
     1           * (1.d0-deltal(j)) * h



* rhs for  b - equation (eqn  (43)  of notes)

c sign 
      cr(2) = -( -lag2tn(j,k-1) 
     1         +aim * omega *betab(2,1,j,k) * u2tn(j,k-1) 
     1         -aim * omega *betab(2,2,j,k) * u1tn(j,k-1)
     1         +aim * omega *betab(2,3,j,k) * untn(j,k-1))
     1          *  (1.d0-deltab(k)) * h

* rhs for  r - equation  (eqn (44) of notes)

      cr(3) = -( -lag1ln(j+1,k)  
     1         -aim * omega *betar(1,1,j,k) * u1ln(j+1,k) 
     1         -aim * omega *betar(1,2,j,k) * u2ln(j+1,k)
     1         +aim * omega *betar(1,3,j,k) * unln(j+1,k))
     1           * (1.d0-deltar(j)) * h

* rhs for  t - equation   (eqn (45) of notes) 

c sign
      cr(4) =  -( lag2bn(j,k+1) 
     1         +aim * omega *betat(2,1,j,k) * u2bn(j,k+1) 
     1         -aim * omega *betat(2,2,j,k) * u1bn(j,k+1)
     1         -aim * omega *betat(2,3,j,k) * unbn(j,k+1))
     1          * (1.d0-deltat(k)) * h


* rhs for  l - equation (for 2nd. comp.)  (eqn (46) of notes) 

      cr(5) = -( lag2rn(j-1,k) 
     1         -aim * omega *betal(2,1,j,k) * u1rn(j-1,k) 
     1         -aim * omega *betal(2,2,j,k) * u2rn(j-1,k)
     1         -aim * omega *betal(2,3,j,k) * unrn(j-1,k))
     1          *  (1.d0-deltal(j)) * h

* rhs for  b - equation (for 2nd. comp.)   (eqn (47) of notes) 

c sign 
      cr(6) = -( lag1tn(j,k-1) 
     1         -aim * omega *betab(1,1,j,k) * u2tn(j,k-1) 
     1         +aim * omega* betab(1,2,j,k) * u1tn(j,k-1)
     1         -aim * omega *betab(1,3,j,k) * untn(j,k-1))
     1          * (1.d0-deltab(k)) * h

* rhs for  r - equation (for 2nd. comp.)   (eqn (48) of notes) 

      cr(7) = -( -lag2ln(j+1,k)  
     1         -aim * omega *betar(2,1,j,k) * u1ln(j+1,k) 
     1         -aim * omega *betar(2,2,j,k) * u2ln(j+1,k)
     1         +aim * omega *betar(2,3,j,k) * unln(j+1,k))
     1          * (1.d0-deltar(j)) * h

* rhs for  t - equation (for 2nd. comp.)   (eqn (49) of notes) 

c sign
      cr(8) = -( -lag1bn(j,k+1) 
     1         -aim * omega *betat(1,1,j,k) * u2bn(j,k+1) 
     1         +aim * omega *betat(1,2,j,k) * u1bn(j,k+1)
     1         +aim * omega *betat(1,3,j,k) * unbn(j,k+1))
     1          * (1.d0-deltat(k)) * h


*  rhs for l-equation in nonwetting phase   (eqn (50) of notes) 


       cr(9) =  -( lagnrn(j-1,k) 
     1         +aim * omega *betal(3,1,j,k) * u1rn(j-1,k) 
     1         +aim * omega *betal(3,2,j,k) * u2rn(j-1,k)
     1         +aim * omega *betal(3,3,j,k) * unrn(j-1,k))
     1          *  (1.d0-deltal(j)) * h

*  rhs for r-equation in nonwetting phase   (eqn (51) of notes)


       cr(10) =  -( lagnln(j+1,k) 
     1         -aim * omega *betar(3,1,j,k) * u1ln(j+1,k) 
     1         -aim * omega *betar(3,2,j,k) * u2ln(j+1,k)
     1         +aim * omega *betar(3,3,j,k) * unln(j+1,k))
     1          *  (1.d0-deltar(j)) * h

*  rhs for b-equation in nonwetting phase   (eqn (52) of notes)

c sign
       cr(11) =  -( lagntn(j,k-1) 
     1         +aim * omega *betab(3,1,j,k) * u2tn(j,k-1) 
     1         -aim * omega *betab(3,2,j,k) * u1tn(j,k-1)
     1         +aim * omega *betab(3,3,j,k) * untn(j,k-1))
     1          *  (1.d0-deltab(k)) * h

*  rhs for t-equation in nonwetting phase    (eqn (53) of notes)

c sign 

       cr(12) =  -( lagnbn(j,k+1) 
     1         -aim * omega *betat(3,1,j,k) * u2bn(j,k+1) 
     1         +aim * omega *betat(3,2,j,k) * u1bn(j,k+1)
     1         +aim * omega *betat(3,3,j,k) * unbn(j,k+1))
     1          *  (1.d0-deltat(k)) * h


        return
	end	     
	     
************************************************************************
       subroutine point_source(j,k,jw,cr,h,kdel,
     1                         jsou,ksou,fsour,isourid)
       include 'sizes'
c      implicit double precision (a-h,o-z)

      complex*16 fsour(mlsour),cr(12)
      real*8 factor,h
      integer j,k,jw,kdel,jsou,ksou,isourid

      integer blockid,vblockid,blockty,ncontrol,nsx,nsy
      common/a1/ncontrol,blockid,vblockid(2),blockty,nsx,nsy
      

c     end dimension statements
c
	
          factor = 1.d0/h**2

*   computes point source  for cell (j,k)

c
c   adds   source contribution to the  cr  coefficients for the rhs


                if(kdel.eq.4)then
           if(blockid.eq.isourid) then
          if(j.eq.jsou.and.k.eq.ksou)then
c
c  Point source. -gradiente delta at the mid point of a grid block
c   only in the frame (compresional point source in the frame)
c
          cr(1) =  cr(1) + fsour(jw)/h * 1.d+6
          cr(2) =  cr(2) 
          cr(3) =  cr(3) - fsour(jw)/h * 1.d+6
          cr(4) =  cr(4) 
          cr(5) =  cr(5) 
          cr(6) =  cr(6) + fsour(jw)/h * 1.d+6
          cr(7) =  cr(7) 
          cr(8) =  cr(8) - fsour(jw)/h * 1.d+6


c
                       endif
                 endif
             endif
	     
c          compressional and shear point source in space only in the frame

                if(kdel.eq.3)then
           if(blockid.eq.isourid) then
          if(j.eq.jsou.and.k.eq.ksou)then
          cr(1) =  cr(1) +
c          compressional part	  
     1 	   h * fsour(jw) * factor *1.d+6 + 
c           shear part     
     1     0.d0 * fsour(jw)* factor *1.d+6 
     
     
          cr(2) =  cr(2) +
c          compressional part	  
     1 	   0.d0 * fsour(jw) * factor * 1.d+6  + 
c           shear part     
     1     h * fsour(jw)* factor * 1.d+6
     	  
          cr(3) =  cr(3) -
c          compressional part	  
     1 	   h * fsour(jw) * factor *1.d+6 + 
c           shear part     
     1     0.d0 * fsour(jw)* factor *1.d+6 	  
	  
          cr(4) =  cr(4) + 
c          compressional part	  
     1 	   0.d0 * fsour(jw) * factor * 1.d+6 - 
c           shear part     
     1     h * fsour(jw)* factor * 1.d+6	  
	  
	   
          cr(5) =  cr(5) +  
c          compressional part	  
     1 	   0.d0 * fsour(jw) * factor * 1.d+6 + 
c           shear part     
     1     h * fsour(jw)* factor * 1.d+6 	  	  
	  
          cr(6) =  cr(6) +
c          compressional part	  
     1 	   h * fsour(jw) * factor * 1.d+6 + 
c           shear part     
     1     0.d0 * fsour(jw)* factor * 1.d+6 	 	  
	  
          cr(7) =  cr(7) + 
c          compressional part	  
     1 	   0.d0 * fsour(jw) * factor * 1.d+6 - 
c           shear part     
     1     h * fsour(jw)* factor * 1.d+6	  		  
	  
	   
          cr(8) =  cr(8) - 
c          compressional part	  
     1 	   h * fsour(jw) * factor * 1.d+6 + 
c           shear part     
     1     0.d0 * fsour(jw)* factor* 1.d+6	  

c
                       endif
                 endif
             endif
	     
                if(kdel.eq.1)then
           if(blockid.eq.isourid) then
          if(j.eq.jsou.and.k.eq.ksou)then
c
c  Point source. -gradiente delta at the mid point of a grid block
c
          cr(1) =  cr(1) + fsour(jw)/h * 1.d+6
          cr(2) =  cr(2) 
          cr(3) =  cr(3) - fsour(jw)/h * 1.d+6
          cr(4) =  cr(4) 
          cr(5) =  cr(5) 
          cr(6) =  cr(6) + fsour(jw)/h * 1.d+6
          cr(7) =  cr(7) 
          cr(8) =  cr(8) - fsour(jw)/h * 1.d+6

          cr(9) =   cr(9)  + fsour(jw)/h* 1.d+6
          cr(10) =  cr(10) + fsour(jw)/h* 1.d+6
          cr(11) =  cr(11) + fsour(jw)/h* 1.d+6
          cr(12) =  cr(12) + fsour(jw)/h* 1.d+6
         
c
                       endif
                 endif
             endif
	     
                if(kdel.eq.2)then
           if(blockid.eq.isourid) then
          if(j.eq.jsou.and.k.eq.ksou)then
c
c   Mi interpretacion de la fuente que usa Carcione
c    multiplico por factor = 1/h  porque 
c    
c   dejando 1.d+6  converge en 2 iteraciones, lo que 
c   no tiene sentido, veamos si esto que hago  arregla ese problema
c

          cr(1) =  cr(1) +
c          compressional part	  
     1 	   h * fsour(jw) * factor *1.d+6 + 
c           shear part     
     1     0.d0 * fsour(jw)* factor *1.d+6 
     
     
          cr(2) =  cr(2) +
c          compressional part	  
     1 	   0.d0 * fsour(jw) * factor * 1.d+6  + 
c           shear part     
     1     h * fsour(jw)* factor * 1.d+6
     	  
          cr(3) =  cr(3) -
c          compressional part	  
     1 	   h * fsour(jw) * factor *1.d+6 + 
c           shear part     
     1     0.d0 * fsour(jw)* factor *1.d+6 	  
	  
          cr(4) =  cr(4) + 
c          compressional part	  
     1 	   0.d0 * fsour(jw) * factor * 1.d+6 - 
c           shear part     
     1     h * fsour(jw)* factor * 1.d+6	  
	  
	   
          cr(5) =  cr(5) +  
c          compressional part	  
     1 	   0.d0 * fsour(jw) * factor * 1.d+6 + 
c           shear part     
     1     h * fsour(jw)* factor * 1.d+6 	  	  
	  
          cr(6) =  cr(6) +
c          compressional part	  
     1 	   h * fsour(jw) * factor * 1.d+6 + 
c           shear part     
     1     0.d0 * fsour(jw)* factor * 1.d+6 	 	  
	  
          cr(7) =  cr(7) + 
c          compressional part	  
     1 	   0.d0 * fsour(jw) * factor * 1.d+6 - 
c           shear part     
     1     h * fsour(jw)* factor * 1.d+6	  		  
	  
	   
          cr(8) =  cr(8) - 
c          compressional part	  
     1 	   h * fsour(jw) * factor * 1.d+6 + 
c           shear part     
     1     0.d0 * fsour(jw)* factor* 1.d+6	  
	  
	

          cr(9) =   cr(9)  + h* fsour(jw) * factor * 1.d+6
          cr(10) =  cr(10) + h* fsour(jw) * factor * 1.d+6
          cr(11) =  cr(11) + h* fsour(jw) * factor * 1.d+6
          cr(12) =  cr(12) + h* fsour(jw) * factor * 1.d+6
          
c
                       endif
                 endif
             endif
	     	     
	     

                if(kdel.eq.0)then
           if(blockid.eq.isourid) then		
          if(j.eq.jsou.and.k.eq.ksou)then
c
c  Point source. -gradiente delta at the mid point of a grid block
c
          cr(1) =  cr(1) + .25d0*fsour(jw)* 1.d+6
          cr(2) =  cr(2) + .25d0*fsour(jw)* 1.d+6
          cr(3) =  cr(3) + .25d0*fsour(jw)* 1.d+6
          cr(4) =  cr(4) + .25d0*fsour(jw)* 1.d+6
          cr(5) =  cr(5) + .25d0*fsour(jw)* 1.d+6
          cr(6) =  cr(6) + .25d0*fsour(jw)* 1.d+6
          cr(7) =  cr(7) + .25d0*fsour(jw)* 1.d+6
          cr(8) =  cr(8) + .25d0*fsour(jw)* 1.d+6
          cr(9)  =   cr(9) - .5d0*fsour(jw)* 1.d+6
          cr(10) =  cr(10) + .5d0*fsour(jw)* 1.d+6
          cr(11) =  cr(11) - .5d0*fsour(jw)* 1.d+6
          cr(12) =  cr(12) + .5d0*fsour(jw)* 1.d+6
         
                       endif
		    endif   
                 endif
                

          return
             end
************************************************************************
          subroutine   solve(cc_lu,b,answer,j,k)
       include 'sizes'
              implicit double precision (a-h,o-z)
      integer x,y,xm,xp
c      integer z,zp
          complex*16   b(12),answer(12),cc_lu(12,12,mnx,mny)
c
c  Solution
c           
c   nd = number of unknowns(=16)
c   ndm = nd -1
       nd=12 
       ndm = nd -1      
   
      do x=2,nd
       xm=x-1
       do y=1,xm
        b(x)=b(x)-cc_lu(x,y,j,k)*b(y)
       enddo
      enddo

      answer(nd)=b(nd)/cc_lu(nd,nd,j,k)
      do x=ndm,1,-1
       xp=x+1
       do y=xp,nd
        b(x)=b(x)-cc_lu(x,y,j,k)*answer(y)
       enddo
       answer(x)=b(x)/cc_lu(x,x,j,k)
      enddo

             return
                 end

************************************************************************		 
      subroutine uplagb(nx,ny,omega,betal,betar,betab,betat,
     1               u1ln,u1tn,u1bn,u1rn,
     1               lag1ln,lag1tn,lag1bn,lag1rn,
     1               u2ln,u2tn,u2bn,u2rn,
     1               lag2ln,lag2tn,lag2bn,lag2rn,
     1               unln,untn,unbn,unrn,
     1               lagnln,lagntn,lagnbn,lagnrn)
       include 'sizes'

      integer nx,ny,j,k,m
      real*8 omega

c
c updates Lagrange multipliers
c

c
c  Iteration  matrix coefficients  beta
c
      real*8 betal(3,3,mnx,mny),betar(3,3,mnx,mny)
      real*8 betab(3,3,mnx,mny),betat(3,3,mnx,mny)
c
c    Solutions ubl , utl , ubr and utr   at iterations   n and n+1
c
      complex*16 u1ln(0:mnx+1,0:mny+1),u1tn(0:mnx+1,0:mny+1),
     1           u1bn(0:mnx+1,0:mny+1),u1rn(0:mnx+1,0:mny+1)
      complex*16 u2ln(0:mnx+1,0:mny+1),u2tn(0:mnx+1,0:mny+1),
     1           u2bn(0:mnx+1,0:mny+1),u2rn(0:mnx+1,0:mny+1)

      complex*16 unln(0:mnx+1,0:mny+1),untn(0:mnx+1,0:mny+1),
     1           unbn(0:mnx+1,0:mny+1),unrn(0:mnx+1,0:mny+1)
     
c
c   Lagrange  multipliers  parameters  laglb, laglt , lagrb, , lagrt ,
c                                      lagbl, lagbr , lagtl, , lagrtr
c     at iterations  n and  n+1
c
c
      complex*16 lag1ln(0:mnx+1,0:mny+1),lag1tn(0:mnx+1,0:mny+1),
     1           lag1bn(0:mnx+1,0:mny+1),lag1rn(0:mnx+1,0:mny+1)

      complex*16 lag2ln(0:mnx+1,0:mny+1),lag2tn(0:mnx+1,0:mny+1),
     1           lag2bn(0:mnx+1,0:mny+1),lag2rn(0:mnx+1,0:mny+1)

      complex*16 lagnln(0:mnx+1,0:mny+1),lagntn(0:mnx+1,0:mny+1),
     1           lagnbn(0:mnx+1,0:mny+1),lagnrn(0:mnx+1,0:mny+1)

      

      complex*16 xx(3),aim

      aim=dcmplx(0.d0,1.d0)


             do 1 j=1,nx,2
             do 1 k=1,ny,2
c right boundary
        xx(1) = u1rn(j,k)-u1ln(j+1,k)
        xx(2) = u2rn(j,k)-u2ln(j+1,k)
        xx(3) = unrn(j,k)+unln(j+1,k)
        

      lag1rn(j,k) = dcmplx(0.d0,0.d0)
      lag2rn(j,k) = dcmplx(0.d0,0.d0)
      lagnrn(j,k) = dcmplx(0.d0,0.d0)
      

             do m=1,3
      lag1rn(j,k) = lag1rn(j,k) + betar(1,m,j,k)*xx(m)
      lag2rn(j,k) = lag2rn(j,k) + betar(2,m,j,k)*xx(m)
      lagnrn(j,k) = lagnrn(j,k) + betar(3,m,j,k)*xx(m) 
             enddo


      lag1rn(j,k)=-aim * omega * lag1rn(j,k)
     1              + lag1ln(j+1,k)


      lag2rn(j,k)=-aim * omega * lag2rn(j,k)
     1              + lag2ln(j+1,k)


      lagnrn(j,k)= aim * omega * lagnrn(j,k)
     1              + lagnln(j+1,k)


      

c left boundary

        xx(1) = u1rn(j-1,k)-u1ln(j,k)
        xx(2) = u2rn(j-1,k)-u2ln(j,k)
        xx(3) = unrn(j-1,k)+unln(j,k)
        

      lag1ln(j,k) = dcmplx(0.d0,0.d0)
      lag2ln(j,k) = dcmplx(0.d0,0.d0)
      lagnln(j,k) = dcmplx(0.d0,0.d0)
      

             do m=1,3
      lag1ln(j,k) = lag1ln(j,k) + betal(1,m,j,k)*xx(m)
      lag2ln(j,k) = lag2ln(j,k) + betal(2,m,j,k)*xx(m)
      lagnln(j,k) = lagnln(j,k) + betal(3,m,j,k)*xx(m) 
             enddo


      lag1ln(j,k)=-aim * omega * lag1ln(j,k)
     1              + lag1rn(j-1,k)


      lag2ln(j,k)=-aim * omega * lag2ln(j,k)
     1              + lag2rn(j-1,k)


      lagnln(j,k)= aim * omega * lagnln(j,k)
     1              + lagnrn(j-1,k)


     


c top boundary

        xx(1) = u2tn(j,k)-u2bn(j,k+1)
        xx(2) = u1bn(j,k+1)-u1tn(j,k)
        xx(3) = untn(j,k)+unbn(j,k+1)
        

      lag1tn(j,k) = dcmplx(0.d0,0.d0)
      lag2tn(j,k) = dcmplx(0.d0,0.d0)
      lagntn(j,k) = dcmplx(0.d0,0.d0)
      

             do m=1,3
      lag1tn(j,k) = lag1tn(j,k) + betat(1,m,j,k)*xx(m)
      lag2tn(j,k) = lag2tn(j,k) + betat(2,m,j,k)*xx(m)
      lagntn(j,k) = lagntn(j,k) + betat(3,m,j,k)*xx(m)
             enddo


      lag1tn(j,k)=-aim * omega * lag1tn(j,k)
     1              + lag1bn(j,k+1)


      lag2tn(j,k)=-aim * omega * lag2tn(j,k)
     1              + lag2bn(j,k+1)


      lagntn(j,k)= aim * omega * lagntn(j,k)
     1              + lagnbn(j,k+1)


    

c bottom boundary

        xx(1) = u2tn(j,k-1)-u2bn(j,k)
        xx(2) = u1bn(j,k)-u1tn(j,k-1)
        xx(3) = untn(j,k-1)+unbn(j,k)
        

      lag1bn(j,k) = dcmplx(0.d0,0.d0)
      lag2bn(j,k) = dcmplx(0.d0,0.d0)
      lagnbn(j,k) = dcmplx(0.d0,0.d0)
      

             do m=1,3
      lag1bn(j,k) = lag1bn(j,k) + betab(1,m,j,k)*xx(m)
      lag2bn(j,k) = lag2bn(j,k) + betab(2,m,j,k)*xx(m)
      lagnbn(j,k) = lagnbn(j,k) + betab(3,m,j,k)*xx(m) 
             enddo


      lag1bn(j,k)=-aim * omega * lag1bn(j,k)
     1              + lag1tn(j,k-1)


      lag2bn(j,k)=-aim * omega * lag2bn(j,k)
     1              + lag2tn(j,k-1)


      lagnbn(j,k)= aim * omega * lagnbn(j,k)
     1              + lagntn(j,k-1)


      




1       continue
             do 2 j=2,nx,2
             do 2 k=2,ny,2

c right boundary
        xx(1) = u1rn(j,k)-u1ln(j+1,k)
        xx(2) = u2rn(j,k)-u2ln(j+1,k)
        xx(3) = unrn(j,k)+unln(j+1,k)
        

      lag1rn(j,k) = dcmplx(0.d0,0.d0)
      lag2rn(j,k) = dcmplx(0.d0,0.d0)
      lagnrn(j,k) = dcmplx(0.d0,0.d0)
      

             do m=1,3
      lag1rn(j,k) = lag1rn(j,k) + betar(1,m,j,k)*xx(m)
      lag2rn(j,k) = lag2rn(j,k) + betar(2,m,j,k)*xx(m)
      lagnrn(j,k) = lagnrn(j,k) + betar(3,m,j,k)*xx(m) 
             enddo


      lag1rn(j,k)=-aim * omega * lag1rn(j,k)
     1              + lag1ln(j+1,k)


      lag2rn(j,k)=-aim * omega * lag2rn(j,k)
     1              + lag2ln(j+1,k)


      lagnrn(j,k)= aim * omega * lagnrn(j,k)
     1              + lagnln(j+1,k)


      

c left boundary

        xx(1) = u1rn(j-1,k)-u1ln(j,k)
        xx(2) = u2rn(j-1,k)-u2ln(j,k)
        xx(3) = unrn(j-1,k)+unln(j,k)
       

      lag1ln(j,k) = dcmplx(0.d0,0.d0)
      lag2ln(j,k) = dcmplx(0.d0,0.d0)
      lagnln(j,k) = dcmplx(0.d0,0.d0)
      

             do m=1,3
      lag1ln(j,k) = lag1ln(j,k) + betal(1,m,j,k)*xx(m)
      lag2ln(j,k) = lag2ln(j,k) + betal(2,m,j,k)*xx(m)
      lagnln(j,k) = lagnln(j,k) + betal(3,m,j,k)*xx(m) 
             enddo


      lag1ln(j,k)=-aim * omega * lag1ln(j,k)
     1              + lag1rn(j-1,k)


      lag2ln(j,k)=-aim * omega * lag2ln(j,k)
     1              + lag2rn(j-1,k)


      lagnln(j,k)= aim * omega * lagnln(j,k)
     1              + lagnrn(j-1,k)


      


c top boundary

        xx(1) = u2tn(j,k)-u2bn(j,k+1)
        xx(2) = u1bn(j,k+1)-u1tn(j,k)
        xx(3) = untn(j,k)+unbn(j,k+1)
       

      lag1tn(j,k) = dcmplx(0.d0,0.d0)
      lag2tn(j,k) = dcmplx(0.d0,0.d0)
      lagntn(j,k) = dcmplx(0.d0,0.d0)
     

             do m=1,3
      lag1tn(j,k) = lag1tn(j,k) + betat(1,m,j,k)*xx(m)
      lag2tn(j,k) = lag2tn(j,k) + betat(2,m,j,k)*xx(m)
      lagntn(j,k) = lagntn(j,k) + betat(3,m,j,k)*xx(m) 
             enddo


      lag1tn(j,k)=-aim * omega * lag1tn(j,k)
     1              + lag1bn(j,k+1)


      lag2tn(j,k)=-aim * omega * lag2tn(j,k)
     1              + lag2bn(j,k+1)


      lagntn(j,k)= aim * omega * lagntn(j,k)
     1              + lagnbn(j,k+1)


      

c bottom boundary

        xx(1) = u2tn(j,k-1)-u2bn(j,k)
        xx(2) = u1bn(j,k)-u1tn(j,k-1)
        xx(3) = untn(j,k-1)+unbn(j,k)
        

      lag1bn(j,k) = dcmplx(0.d0,0.d0)
      lag2bn(j,k) = dcmplx(0.d0,0.d0)
      lagnbn(j,k) = dcmplx(0.d0,0.d0)
     

             do m=1,3
      lag1bn(j,k) = lag1bn(j,k) + betab(1,m,j,k)*xx(m)
      lag2bn(j,k) = lag2bn(j,k) + betab(2,m,j,k)*xx(m)
      lagnbn(j,k) = lagnbn(j,k) + betab(3,m,j,k)*xx(m) 
             enddo


      lag1bn(j,k)=-aim * omega * lag1bn(j,k)
     1              + lag1tn(j,k-1)


      lag2bn(j,k)=-aim * omega * lag2bn(j,k)
     1              + lag2tn(j,k-1)


      lagnbn(j,k)= aim * omega * lagnbn(j,k)
     1              + lagntn(j,k-1)


      
2       continue

         return
           end

************************************************************************
      subroutine uplagr(nx,ny,omega,betal,betar,betab,betat,
     1               u1ln,u1tn,u1bn,u1rn,
     1               lag1ln,lag1tn,lag1bn,lag1rn,
     1               u2ln,u2tn,u2bn,u2rn,
     1               lag2ln,lag2tn,lag2bn,lag2rn,
     1               unln,untn,unbn,unrn,
     1               lagnln,lagntn,lagnbn,lagnrn)
       include 'sizes'
      integer nx,ny,j,k,m
      real*8 omega  

c
c updates Lagrange multipliers
c

c
c  Iteration  matrix coefficients  beta
c
      real*8 betal(3,3,mnx,mny),betar(3,3,mnx,mny)
      real*8 betab(3,3,mnx,mny),betat(3,3,mnx,mny)
c
c    Solutions ubl , utl , ubr and utr   at iterations   n and n+1
c
      complex*16 u1ln(0:mnx+1,0:mny+1),u1tn(0:mnx+1,0:mny+1),
     1           u1bn(0:mnx+1,0:mny+1)
      complex*16 u1rn(0:mnx+1,0:mny+1)
      complex*16 u2ln(0:mnx+1,0:mny+1),u2tn(0:mnx+1,0:mny+1),
     1           u2bn(0:mnx+1,0:mny+1)
      complex*16 u2rn(0:mnx+1,0:mny+1)

      complex*16 unln(0:mnx+1,0:mny+1),untn(0:mnx+1,0:mny+1),
     1           unbn(0:mnx+1,0:mny+1)
      complex*16 unrn(0:mnx+1,0:mny+1)
     
c
c   Lagrange  multipliers  parameters  laglb, laglt , lagrb, , lagrt ,
c                                      lagbl, lagbr , lagtl, , lagrtr
c     at iterations  n and  n+1
c
c
      complex*16 lag1ln(0:mnx+1,0:mny+1),lag1tn(0:mnx+1,0:mny+1),
     1           lag1bn(0:mnx+1,0:mny+1),lag1rn(0:mnx+1,0:mny+1)

      complex*16 lag2ln(0:mnx+1,0:mny+1),lag2tn(0:mnx+1,0:mny+1),
     1           lag2bn(0:mnx+1,0:mny+1),lag2rn(0:mnx+1,0:mny+1)

      complex*16 lagnln(0:mnx+1,0:mny+1),lagntn(0:mnx+1,0:mny+1),
     1           lagnbn(0:mnx+1,0:mny+1),lagnrn(0:mnx+1,0:mny+1)

      

      complex*16 xx(3),aim

      aim=dcmplx(0.d0,1.d0)

             do 1 j=1,nx,2
             do 1 k=2,ny,2
c right boundary
        xx(1) = u1rn(j,k)-u1ln(j+1,k)
        xx(2) = u2rn(j,k)-u2ln(j+1,k)
        xx(3) = unrn(j,k)+unln(j+1,k)
        

      lag1rn(j,k) = dcmplx(0.d0,0.d0)
      lag2rn(j,k) = dcmplx(0.d0,0.d0)
      lagnrn(j,k) = dcmplx(0.d0,0.d0)
      

             do m=1,3
      lag1rn(j,k) = lag1rn(j,k) + betar(1,m,j,k)*xx(m)
      lag2rn(j,k) = lag2rn(j,k) + betar(2,m,j,k)*xx(m)
      lagnrn(j,k) = lagnrn(j,k) + betar(3,m,j,k)*xx(m) 
             enddo


      lag1rn(j,k)=-aim * omega * lag1rn(j,k)
     1              + lag1ln(j+1,k)


      lag2rn(j,k)=-aim * omega * lag2rn(j,k)
     1              + lag2ln(j+1,k)


      lagnrn(j,k)= aim * omega * lagnrn(j,k)
     1              + lagnln(j+1,k)


      

c left boundary

        xx(1) = u1rn(j-1,k)-u1ln(j,k)
        xx(2) = u2rn(j-1,k)-u2ln(j,k)
        xx(3) = unrn(j-1,k)+unln(j,k)
      

      lag1ln(j,k) = dcmplx(0.d0,0.d0)
      lag2ln(j,k) = dcmplx(0.d0,0.d0)
      lagnln(j,k) = dcmplx(0.d0,0.d0)
      

             do m=1,3
      lag1ln(j,k) = lag1ln(j,k) + betal(1,m,j,k)*xx(m)
      lag2ln(j,k) = lag2ln(j,k) + betal(2,m,j,k)*xx(m)
      lagnln(j,k) = lagnln(j,k) + betal(3,m,j,k)*xx(m) 
             enddo


      lag1ln(j,k)=-aim * omega * lag1ln(j,k)
     1              + lag1rn(j-1,k)


      lag2ln(j,k)=-aim * omega * lag2ln(j,k)
     1              + lag2rn(j-1,k)


      lagnln(j,k)= aim * omega * lagnln(j,k)
     1              + lagnrn(j-1,k)


      


c top boundary

        xx(1) = u2tn(j,k)-u2bn(j,k+1)
        xx(2) = u1bn(j,k+1)-u1tn(j,k)
        xx(3) = untn(j,k)+unbn(j,k+1)
       

      lag1tn(j,k) = dcmplx(0.d0,0.d0)
      lag2tn(j,k) = dcmplx(0.d0,0.d0)
      lagntn(j,k) = dcmplx(0.d0,0.d0)
      

             do m=1,3
      lag1tn(j,k) = lag1tn(j,k) + betat(1,m,j,k)*xx(m)
      lag2tn(j,k) = lag2tn(j,k) + betat(2,m,j,k)*xx(m)
      lagntn(j,k) = lagntn(j,k) + betat(3,m,j,k)*xx(m) 
             enddo


      lag1tn(j,k)=-aim * omega * lag1tn(j,k)
     1              + lag1bn(j,k+1)


      lag2tn(j,k)=-aim * omega * lag2tn(j,k)
     1              + lag2bn(j,k+1)


      lagntn(j,k)= aim * omega * lagntn(j,k)
     1              + lagnbn(j,k+1)


     

c bottom boundary

        xx(1) = u2tn(j,k-1)-u2bn(j,k)
        xx(2) = u1bn(j,k)-u1tn(j,k-1)
        xx(3) = untn(j,k-1)+unbn(j,k)
        

      lag1bn(j,k) = dcmplx(0.d0,0.d0)
      lag2bn(j,k) = dcmplx(0.d0,0.d0)
      lagnbn(j,k) = dcmplx(0.d0,0.d0)
      

             do m=1,3
      lag1bn(j,k) = lag1bn(j,k) + betab(1,m,j,k)*xx(m)
      lag2bn(j,k) = lag2bn(j,k) + betab(2,m,j,k)*xx(m)
      lagnbn(j,k) = lagnbn(j,k) + betab(3,m,j,k)*xx(m) 
             enddo


      lag1bn(j,k)=-aim * omega * lag1bn(j,k)
     1              + lag1tn(j,k-1)


      lag2bn(j,k)=-aim * omega * lag2bn(j,k)
     1              + lag2tn(j,k-1)


      lagnbn(j,k)= aim * omega * lagnbn(j,k)
     1              + lagntn(j,k-1)


      

1       continue
             do 2 j=2,nx,2
             do 2 k=1,ny,2
c right boundary
        xx(1) = u1rn(j,k)-u1ln(j+1,k)
        xx(2) = u2rn(j,k)-u2ln(j+1,k)
        xx(3) = unrn(j,k)+unln(j+1,k)
        

      lag1rn(j,k) = dcmplx(0.d0,0.d0)
      lag2rn(j,k) = dcmplx(0.d0,0.d0)
      lagnrn(j,k) = dcmplx(0.d0,0.d0)
      

             do m=1,3
      lag1rn(j,k) = lag1rn(j,k) + betar(1,m,j,k)*xx(m)
      lag2rn(j,k) = lag2rn(j,k) + betar(2,m,j,k)*xx(m)
      lagnrn(j,k) = lagnrn(j,k) + betar(3,m,j,k)*xx(m) 
             enddo


      lag1rn(j,k)=-aim * omega * lag1rn(j,k)
     1              + lag1ln(j+1,k)


      lag2rn(j,k)=-aim * omega * lag2rn(j,k)
     1              + lag2ln(j+1,k)


      lagnrn(j,k)= aim * omega * lagnrn(j,k)
     1              + lagnln(j+1,k)


      

c left boundary

        xx(1) = u1rn(j-1,k)-u1ln(j,k)
        xx(2) = u2rn(j-1,k)-u2ln(j,k)
        xx(3) = unrn(j-1,k)+unln(j,k)
       

      lag1ln(j,k) = dcmplx(0.d0,0.d0)
      lag2ln(j,k) = dcmplx(0.d0,0.d0)
      lagnln(j,k) = dcmplx(0.d0,0.d0)
      

             do m=1,3
      lag1ln(j,k) = lag1ln(j,k) + betal(1,m,j,k)*xx(m)
      lag2ln(j,k) = lag2ln(j,k) + betal(2,m,j,k)*xx(m)
      lagnln(j,k) = lagnln(j,k) + betal(3,m,j,k)*xx(m)
             enddo


      lag1ln(j,k)=-aim * omega * lag1ln(j,k)
     1              + lag1rn(j-1,k)


      lag2ln(j,k)=-aim * omega * lag2ln(j,k)
     1              + lag2rn(j-1,k)


      lagnln(j,k)= aim * omega * lagnln(j,k)
     1              + lagnrn(j-1,k)


      


c top boundary

        xx(1) = u2tn(j,k)-u2bn(j,k+1)
        xx(2) = u1bn(j,k+1)-u1tn(j,k)
        xx(3) = untn(j,k)+unbn(j,k+1)
        

      lag1tn(j,k) = dcmplx(0.d0,0.d0)
      lag2tn(j,k) = dcmplx(0.d0,0.d0)
      lagntn(j,k) = dcmplx(0.d0,0.d0)
      

             do m=1,3
      lag1tn(j,k) = lag1tn(j,k) + betat(1,m,j,k)*xx(m)
      lag2tn(j,k) = lag2tn(j,k) + betat(2,m,j,k)*xx(m)
      lagntn(j,k) = lagntn(j,k) + betat(3,m,j,k)*xx(m)
             enddo


      lag1tn(j,k)=-aim * omega * lag1tn(j,k)
     1              + lag1bn(j,k+1)


      lag2tn(j,k)=-aim * omega * lag2tn(j,k)
     1              + lag2bn(j,k+1)


      lagntn(j,k)= aim * omega * lagntn(j,k)
     1              + lagnbn(j,k+1)


      

c bottom boundary

        xx(1) = u2tn(j,k-1)-u2bn(j,k)
        xx(2) = u1bn(j,k)-u1tn(j,k-1)
        xx(3) = untn(j,k-1)+unbn(j,k)
        

      lag1bn(j,k) = dcmplx(0.d0,0.d0)
      lag2bn(j,k) = dcmplx(0.d0,0.d0)
      lagnbn(j,k) = dcmplx(0.d0,0.d0)
     

             do m=1,3
      lag1bn(j,k) = lag1bn(j,k) + betab(1,m,j,k)*xx(m)
      lag2bn(j,k) = lag2bn(j,k) + betab(2,m,j,k)*xx(m)
      lagnbn(j,k) = lagnbn(j,k) + betab(3,m,j,k)*xx(m) 
             enddo


      lag1bn(j,k)=-aim * omega * lag1bn(j,k)
     1              + lag1tn(j,k-1)


      lag2bn(j,k)=-aim * omega * lag2bn(j,k)
     1              + lag2tn(j,k-1)


      lagnbn(j,k)= aim * omega * lagnbn(j,k)
     1              + lagntn(j,k-1)


      
2       continue
         return
           end
***********************************************************************
       subroutine finvpic2(jjw,nx,ny,u1ln,u1tn,u1bn,u1rn,
     1                    u2ln,u2tn,u2bn,u2rn,unln,untn,unbn,unrn,
     1                    tpic2,tpic_curls,
     1                    tpicny,ntsnap,itsnap,dt,delw,h,
     1                    tpic_divus,tpic_divun)
        include 'sizes'
      implicit double precision(a-h,o-z)
      complex*16 u1ln(0:mnx+1,0:mny+1),u1tn(0:mnx+1,0:mny+1),
     1           u1bn(0:mnx+1,0:mny+1)
      complex*16 u1rn(0:mnx+1,0:mny+1)
c
      complex*16 u2ln(0:mnx+1,0:mny+1),u2tn(0:mnx+1,0:mny+1),
     1           u2bn(0:mnx+1,0:mny+1)
      complex*16 u2rn(0:mnx+1,0:mny+1)
      complex*16 unln(0:mnx+1,0:mny+1),untn(0:mnx+1,0:mny+1),
     1           unbn(0:mnx+1,0:mny+1)
      complex*16 unrn(0:mnx+1,0:mny+1)
      
      dimension tpic2(mnx,mny,mtsnap),tpic_curls(mnx,mny,mtsnap)
      real*8 tpicny(mnx,mny,mtsnap)
      real*8 tpic_divus(mnx,mny,mtsnap),tpic_divun(mnx,mny,mtsnap)

      integer itsnap(mtsnap)
      complex*16 avsol1,avsol2,aim
      real*8 h
      aim=dcmplx(0.d0,1.d0)
c
      
c      do k=1,ny
c         do j=1,nx

c             avsol1 =  .25d0* (u1ln(j,k)  +
c     1                        u1tn(j,k)  +
c     1                        u1bn(j,k)  +
c     1                        u1rn(j,k)     )

c       if(cdabs(avsol1).lt.1.e-14) avsol1 = dcmplx(0.d0,0.d0)

c            do  jt = 1,ntsnap
c               fjt=itsnap(jt)
c               fjt = fjt - 1.d0
c               fjw=jjw
c               fjw = fjw -1.d0
c               fjw = fjw + .5d0
c               v = fjw * delw * fjt * dt
c               tpic1(j,k,jt) = tpic1(j,k,jt) +
c     $   dreal(aim* fjw * delw *avsol1 * dcmplx(dcos(v),dsin(v)) )
c             enddo          
c              enddo            
c               enddo
           do  k=1,ny
           do  j=1,nx

             avsol2 =  .25d0* (u2ln(j,k)  +
     1                        u2tn(j,k)  +
     1                        u2bn(j,k)  +
     1                        u2rn(j,k)     )

        if(cdabs(avsol2).lt.1.e-14) avsol2 = dcmplx(0.d0,0.d0)

            do  jt = 1,ntsnap
               fjt=itsnap(jt)
               fjt = fjt - 1.d0
               fjw=jjw
               fjw = fjw -1.d0
               fjw = fjw + .5d0
               v = fjw * delw * fjt * dt
               tpic2(j,k,jt) = tpic2(j,k,jt) +
     $     dreal( aim*fjw*delw*avsol2 * dcmplx(dcos(v),dsin(v)) )
             enddo          
              enddo            
               enddo
c      do k=1,ny
c         do j=1,nx

c             avsol1 =  .5d0* ( -unln(j,k)  +
c     1                        unrn(j,k)  )

c       if(cdabs(avsol1).lt.1.e-14) avsol1 = dcmplx(0.d0,0.d0)

c            do  jt = 1,ntsnap
c               fjt=itsnap(jt)
c               fjt = fjt - 1.d0
c               fjw=jjw
c               fjw = fjw -1.d0
c               fjw = fjw + .5d0
c               v = fjw * delw * fjt * dt
c               tpicnx(j,k,jt) = tpicnx(j,k,jt) +
c     $     dreal(aim*fjw*delw* avsol1 * dcmplx(dcos(v),dsin(v)) )
c             enddo          
c              enddo            
c               enddo
c           do  k=1,ny
c           do  j=1,nx

c             avsol2 =  .5d0* ( -uwln(j,k)  +
c     1                        uwrn(j,k) )

c        if(cdabs(avsol2).lt.1.e-14) avsol2 = dcmplx(0.d0,0.d0)

c            do  jt = 1,ntsnap
c               fjt=itsnap(jt)
c               fjt = fjt - 1.d0
c               fjw=jjw
c               fjw = fjw -1.d0
c               fjw = fjw + .5d0
c               v = fjw * delw * fjt * dt
c               tpicwx(j,k,jt) = tpicwx(j,k,jt) +
c     $     dreal(aim*fjw*delw* avsol2 * dcmplx(dcos(v),dsin(v)) )
c             enddo          
c              enddo            
c               enddo

      do k=1,ny
         do j=1,nx

             avsol1 =  .5d0* ( -unbn(j,k)  +
     1                        untn(j,k)  )

       if(cdabs(avsol1).lt.1.e-14) avsol1 = dcmplx(0.d0,0.d0)

            do  jt = 1,ntsnap
               fjt=itsnap(jt)
               fjt = fjt - 1.d0
               fjw=jjw
               fjw = fjw -1.d0
               fjw = fjw + .5d0
               v = fjw * delw * fjt * dt
               tpicny(j,k,jt) = tpicny(j,k,jt) +
     $    dreal(aim*fjw*delw* avsol1 * dcmplx(dcos(v),dsin(v)) )
             enddo          
              enddo            
               enddo
         
	       
c snapshot de la divergencia del solido
          do  k=1,ny
           do  j=1,nx
         avsol2=   (1.d0/h)* ( u1rn(j,k)  - u1ln(j,k)
     1                          +u2tn(j,k)  - u2bn(j,k) )
           if(cdabs(avsol2).lt.1.e-14) avsol2 = dcmplx(0.d0,0.d0)

            do  jt = 1,ntsnap
               fjt=itsnap(jt)
               fjt = fjt - 1.d0
               fjw=jjw
               fjw = fjw -1.d0
               fjw = fjw + .5d0
               v = fjw * delw * fjt * dt
               tpic_divus(j,k,jt) = tpic_divus(j,k,jt) +
     $     dreal( aim*fjw*delw*avsol2 * dcmplx(dcos(v),dsin(v)) )
             enddo          
              enddo            
               enddo	  
	

c snapshot de la divergencia del fluido
          do  k=1,ny
           do  j=1,nx
          avsol2=   (1.d0/h)* ( unln(j,k)  + unrn(j,k)
     1                          +unbn(j,k)  + untn(j,k) )

           if(cdabs(avsol2).lt.1.e-14) avsol2 = dcmplx(0.d0,0.d0)

            do  jt = 1,ntsnap
               fjt=itsnap(jt)
               fjt = fjt - 1.d0
               fjw=jjw
               fjw = fjw -1.d0
               fjw = fjw + .5d0
               v = fjw * delw * fjt * dt
               tpic_divun(j,k,jt) = tpic_divun(j,k,jt) +
     $     dreal( aim*fjw*delw*avsol2 * dcmplx(dcos(v),dsin(v)) )
             enddo          
              enddo            
               enddo	






c Lo siguiente es el curl del solido
       
           do  k=1,ny
           do  j=1,nx

             avsol2 =  (1.d0/h)*( (u1tn(j,k)-u1bn(j,k)) - 
     1              	        (u2rn(j,k)-u2ln(j,k))   )

        if(cdabs(avsol2).lt.1.e-14) avsol2 = dcmplx(0.d0,0.d0)

            do  jt = 1,ntsnap
               fjt=itsnap(jt)
               fjt = fjt - 1.d0
               fjw=jjw
               fjw = fjw -1.d0
               fjw = fjw + .5d0
               v = fjw * delw * fjt * dt
               tpic_curls(j,k,jt) = tpic_curls(j,k,jt) +
     $     dreal( aim*fjw*delw*avsol2 * dcmplx(dcos(v),dsin(v)) )
             enddo          
              enddo            
               enddo	       
	       
	       
	       
      return
      end
c*********************************************************************

       subroutine savtrace(nrec,delw,jjw,h,irx,iry,fu1,fu2,
     1                     fdivus,fdivun,funz,
     1                     fcurl_us,fcurl_un,
     1                     u1ln,u1bn,u1rn,u1tn,u2ln,u2bn,u2rn,u2tn,
     1                     unln,untn,unbn,unrn,irecid)     
     
        include 'sizes'
      implicit double precision (a-h,o-z)
      complex*16 fu1(mlsour,mnrec),fu2(mlsour,mnrec)
c JUAN change
      
      complex*16 fdivus(mlsour,mnrec),fdivun(mlsour,mnrec)
      complex*16 fcurl_us(mlsour,mnrec),fcurl_un(mlsour,mnrec)
            
      
      complex*16 funz(mlsour,mnrec)

        complex*16 avdivus,avdivun,avsol1,avsol2,aim
	complex*16 avcurl_us,avcurl_un
	
        dimension  irx(mnrec),iry(mnrec)
 	dimension  irecid(mnrec)
	
      complex*16 u1ln(0:mnx+1,0:mny+1),u1tn(0:mnx+1,0:mny+1),
     1           u1bn(0:mnx+1,0:mny+1),u1rn(0:mnx+1,0:mny+1)
c
      complex*16 u2ln(0:mnx+1,0:mny+1),u2tn(0:mnx+1,0:mny+1),
     1           u2bn(0:mnx+1,0:mny+1),u2rn(0:mnx+1,0:mny+1)
c
      complex*16 unln(0:mnx+1,0:mny+1),untn(0:mnx+1,0:mny+1),
     1           unbn(0:mnx+1,0:mny+1),unrn(0:mnx+1,0:mny+1)
c
*****************************************************************************
      integer blockid,vblockid,blockty,ncontrol,nsx,nsy
      common/a1/ncontrol,blockid,vblockid(2),blockty,nsx,nsy    
*****************************************************************************     
     
      aim=dcmplx(0.d0,1.d0)
      
          
	  
               fjw=jjw
               fjw = fjw -1.d0	       
               fjw = fjw + .5d0
	       
c
c saves Fourier transform of traces of velocity 
c     at the specified receiver locations

c
         do 7436 i = 1, nrec
           if(blockid.eq.irecid(i)) then
	  
   
c      write(6,*)' blockid = ',blockid
c      write(6,*)' irecid(i) = ',irecid(i)
      		   	 
           j=irx(i)
           k=iry(i)
             avsol1 =   .25d0* (u1ln(j,k)  +
     1                        u1tn(j,k)  +
     1                        u1bn(j,k)  +
     1                        u1rn(j,k)     )
         if(cdabs(avsol1).lt.1.e-14) avsol1 = dcmplx(0.d0,0.d0)

         fu1(jjw,i) = aim*fjw*delw* avsol1
	 
              avsol2=   .25d0* (u2ln(j,k)  +
     1                        u2tn(j,k)  +
     1                        u2bn(j,k)  +
     1                        u2rn(j,k)     )

         if(cdabs(avsol2).lt.1.e-14) avsol2 = dcmplx(0.d0,0.d0)

         fu2(jjw,i) = aim*fjw*delw* avsol2

c JUAN change  (pag. 9-10 del fax #4)
	 
          avdivus=   (1.d0/h)* ( u1rn(j,k)  - u1ln(j,k)
     1                          +u2tn(j,k)  - u2bn(j,k) )
         fdivus(jjw,i) = aim*fjw*delw*avdivus
	 
         avdivun=   (1.d0/h)* ( unln(j,k)  + unrn(j,k)
     1                          +unbn(j,k)  + untn(j,k) )
         fdivun(jjw,i) = aim*fjw*delw*avdivun
	 
        
	 
	 funz(jjw,i) = .5d0*(untn(j,k) - unbn(j,k))	 	 
	 

c  curl  of 2 phases (s,n) at the cell center of the receiver location
	 
	 avcurl_us = (1.d0/h)*( (u1tn(j,k)-u1bn(j,k)) - 
     1              	        (u2rn(j,k)-u2ln(j,k))   )
	 avcurl_un = (1.d0/h)*( (unln(j,k)+unrn(j,k)) - 
     1              	        (unbn(j,k)+untn(j,k))   )
     
	 
     
         fcurl_us(jjw,i) = aim*fjw*delw*avcurl_us
         fcurl_un(jjw,i) = aim*fjw*delw*avcurl_un	 
        
        
          endif	
	   	 	 	 
 7436    continue



            return
               end
***********************************************************************

      subroutine out_traces(nx,ny,ntsnap,fu2,fdivus,fdivun,funz,
     1                    fcurl_us,fcurl_un, 
     1                    nt,dt,delw,jw1,jw2,nrec,irecid)     
     
     
        include 'sizes'
      implicit double precision (a-h,o-z)
      integer nx, ny, k,nrec
      complex*16 fu2(mlsour,mnrec),
     1           x1(mlsour),x2(mlsour)
c JUAN change
      complex*16 funz(mlsour,mnrec)
      complex*16 fdivus(mlsour,mnrec),fdivun(mlsour,mnrec) 
      complex*16 fcurl_us(mlsour,mnrec),fcurl_un(mlsour,mnrec)
     
                 
      real*8 uu(ntstep)

      
      dimension  irecid(mnrec)
      integer blockid,vblockid,blockty
      common/a1/ncontrol,blockid,vblockid(2),blockty,nsx,nsy
       
       if(blockid.eq.ncontrol)then     
           write(6,*) " enters outime"
       endif	   
      pi = 4.d0*datan(1.d0)


c
c      computes the inverse fourier transform to obtain the traces
c       of the velocity 
c
c     loop over the receivers

*   TRACES are written in files   fort.60 ----, fort.84

c JUAN : ojo, asi como esta no se pueden escribir mas de  5   trazas 
c   de cada tipo  (nrec.le.5) !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


c
c      Traces for vertical component of solid phase 

 340  format(2g15.4)
9157  format(g15.4)



      do  k=1,nrec
           if(blockid.eq.irecid(k)) then
   
c      write(6,*)' blockid = ',blockid
c      write(6,*)' irecid(k) = ',irecid(k)
	   
         do  n=jw1,jw2
            x1(n) = fu2(n,k)
         enddo

            call finvu2(x1,jw2,uu,nt,dt,delw)
       
c
c  Writes in 60 + k-1  current trace for u1 in the time domain
c
         write(50+k-1,340)((n-1)*dt,uu(n),n=1,nt)
	 
	   endif
          enddo
	  
c  Traces for vertical component of fluid  phase
  
      do  k=1,nrec
              if(blockid.eq.irecid(k)) then
         do  n=jw1,jw2
            x1(n) = funz(n,k)
         enddo

            call finvu2(x1,jw2,uu,nt,dt,delw)
c
c  Writes in 66 + k-1  current trace for u1 in the time domain
c
         write(57+k-1,340)((n-1)*dt,uu(n),n=1,nt)
	 
	       endif
          enddo




c   traces for div. solid phase

         do  k=1,nrec
              if(blockid.eq.irecid(k)) then
         do  n=jw1,jw2
            x2(n) = fdivus(n,k)
         enddo

             call finvu2(x2,jw2,uu,nt,dt,delw)

c  Writes in 72 + k-1  current trace for divus in the time domain
c
         write(64+k-1,340)((n-1)*dt,uu(n),n=1,nt)
	       endif
         enddo

c   traces for divergence of fluid phase 	 
	 
         do  k=1,nrec
              if(blockid.eq.irecid(k)) then
         do  n=jw1,jw2
            x2(n) = fdivun(n,k)
         enddo

             call finvu2(x2,jw2,uu,nt,dt,delw)

c  Writes in 75+ k-1  current trace for divun in the time domain
c
c
         write(71+k-1,340)((n-1)*dt,uu(n),n=1,nt)
	       endif
         enddo
	 


c    traces for  curl us
 	 
         do  k=1,nrec
              if(blockid.eq.irecid(k)) then
         do  n=jw1,jw2
            x2(n) = fcurl_us(n,k)
         enddo

             call finvu2(x2,jw2,uu,nt,dt,delw)

c  Writes in 80+ k-1  current trace for  curl us in the time domain
c
c
         write(78+k-1,340)((n-1)*dt,uu(n),n=1,nt)
	       endif
         enddo
	 
*  JUAN, 2006 : se anulan las trazas de curl  un    	 
c     curl un
 	 
         do  k=1,nrec
              if(blockid.eq.irecid(k)) then
         do  n=jw1,jw2
            x2(n) = fcurl_un(n,k)
         enddo

             call finvu2(x2,jw2,uu,nt,dt,delw)

c  Writes in 84+ k-1  current trace for divun in the time domain
c
c
c         write(84+k-1,340)((n-1)*dt,uu(n),n=1,nt)
              endif
         enddo
       if(blockid.eq.ncontrol)then     
           write(6,*) " leaves outime"
       endif	   
	   
	   
c Patricia/Claudia: asi es como grabe trazas en formato SU para 
c los graficos del problema
c inverso que estaban en las matrices  tracesr(i,j),tracesz(i,j)
c
c Por favor vean como escribir estas trazas en ese formato, porque para 
c  la charla quizas haya que poner un array de receptores 
c  y despues marcar los arribos. 

c  	   
c         ibyte=4
c       open(28,access='direct',file='true_trazasr.bin',
c     1      recl=ibyte*ltstep)
c         do i=1,nrec
c         write(28,rec=i)(sngl(tracesr(i,j)),j=1,ltstep)

c         enddo
c         close (28)


           return
          end
